unit About;

interface

uses Windows, StdCtrls, Buttons, ExtCtrls, Forms, Graphics, Classes, Controls;

type
  TfmAbout = class(TForm)
    InfoPanel: TPanel;
    MTL_Logo: TImage;
    ToolName: TLabel;
    VersionInfo: TLabel;
    ToolDescription: TLabel;
    CopyRight: TLabel;
    Panel1: TPanel;
    OSInfo: TLabel;
    MemInfo: TLabel;
    MemValue: TLabel;
    OK_Button: TBitBtn;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fmAbout: TfmAbout;

implementation

{$R *.dfm}

uses SysUtils, ProcessUtils, StringUtils, RegUtils, DataInstances, DataConstants,
     LabelNumbers, HelpContextNumbers;

procedure TfmAbout.FormCreate(Sender: TObject);
begin
  Caption:=' '+DeleteAcceleratorKey(LanguageStrings[mlAbout]);
  HelpContext:=hcAbout;

  ToolName.Caption:=UpperCase(OwnName);
  VersionInfo.Caption:='Version '+CPcs45Version;

  ToolName.Font.Size:=18;
  ToolDescription.Caption:=LanguageStrings[flMainToolName];
  ToolDescription.Width:=136;

  CopyRight.Caption:=LanguageStrings[flCopyright];

  OSInfo.Caption:=GetWindowsVersionInfo(LanguageStrings[flBuild]);

  MemInfo.Caption:=LanguageStrings[flMemory];
  MemValue.Caption:=FormatFloat('#,###" KB"', GetAvailablePhysicalMemory div 1024);

  OK_Button.Caption:=LanguageStrings[blOk];

  OK_Button.Top:=InfoPanel.Top+InfoPanel.Height+20;
  OK_Button.Left:=InfoPanel.Left+ (InfoPanel.Width-OK_Button.Width) DIV 2;

  Self.Height:=OK_Button.Top+80;
end;

end.
