unit ChangeDevice;

interface

uses
  Windows, Forms, Buttons, ExtCtrls, DataTypes, StdCtrls, Classes, Controls;

type
  TfmChangeDevice = class(TForm)
    TargetDeviceSelection: TRadioGroup;
    OK_Button: TBitBtn;
    Close_Button: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure OK_ButtonClick(Sender: TObject);
  private
    { Private declarations }
    fNewDevice: TDeviceType;
  public
    { Public declarations }
    function GetDevice: TDeviceType;
  end;

var
  fmChangeDevice: TfmChangeDevice;

implementation

{$R *.dfm}

uses StringUtils, DataInstances, LabelNumbers, HelpContextNumbers;

function TfmChangeDevice.GetDevice: TDeviceType;
begin
  Result:=fNewDevice;
end;

procedure TfmChangeDevice.FormCreate(Sender: TObject);
begin
  Caption:=' '+DeleteAcceleratorKey(LanguageStrings[flChangeDeviceType]);
  HelpContext:=hcChangeDevice;

  with TargetDeviceSelection do
       begin
       Caption:=' '+LanguageStrings[flTargetDeviceType];

       Items.Add(LanguageStrings[flMTL4573_5573]);
       Items.Add(LanguageStrings[flMTL4575_5575]);

       ItemIndex:=0;
       end;

  fNewDevice:=dtNone;

  OK_Button.Caption:=LanguageStrings[blSetting];
  Close_Button.Caption:=LanguageStrings[blClose];

  OK_Button.Top:=TargetDeviceSelection.Top+TargetDeviceSelection.Height+20;
  OK_Button.Left:=TargetDeviceSelection.Left;
  Close_Button.Top:=OK_Button.Top;
  Close_Button.Left:=TargetDeviceSelection.Left+TargetDeviceSelection.Width-Close_Button.Width;

  Self.Height:=Close_Button.Top+80;
end;

procedure TfmChangeDevice.OK_ButtonClick(Sender: TObject);
begin
  if (TargetDeviceSelection.ItemIndex=1) then
     fNewDevice:=dtx575
  else fNewDevice:=dtx573;
end;

end.
