unit ErrorIndication;

interface

uses Windows, StdCtrls, Buttons, Classes, Controls, Forms, DataTypes;

type
  TfmErrorIndication = class(TForm)
    IndicationGroupBox: TGroupBox;
    IndicateDefects: TCheckBox;
    IndicateDisturbances: TCheckBox;
    IndicateExcpetions: TCheckBox;
    OK_Button: TBitBtn;
    Close_Button: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CheckButtonClick(Sender: TObject);
    procedure OK_ButtonClick(Sender: TObject);
  private
    { Private declarations }
   ErrorIndications: TTrippleBoolArray;
  public
    { Public declarations }
    procedure SetErrorIndication(Value: TTrippleBoolArray);
    function GetErrorIndication: TTrippleBoolArray;
  end;

var
  fmErrorIndication: TfmErrorIndication;

implementation

{$R *.dfm}

uses StringUtils, DataInstances, LabelNumbers, HelpContextNumbers;

procedure TfmErrorIndication.SetErrorIndication(Value: TTrippleBoolArray);
begin
  ErrorIndications:=Value;
end;

function TfmErrorIndication.GetErrorIndication: TTrippleBoolArray;
begin
  Result:=ErrorIndications;
end;

procedure TfmErrorIndication.FormCreate(Sender: TObject);
begin
  Caption:=' '+DeleteAcceleratorKey(LanguageStrings[mlErrorIndication]);

  HelpContext:=hcErrorIndication;

  IndicationGroupBox.Caption:=LanguageStrings[flIndicate];
  IndicateDefects.Caption:=LanguageStrings[flDefect];
  IndicateDisturbances.Caption:=LanguageStrings[flDisruption];
  IndicateExcpetions.Caption:=LanguageStrings[flException];

  OK_Button.Caption:=LanguageStrings[blSetting];
  Close_Button.Caption:=LanguageStrings[blClose];

  OK_Button.Top:=IndicationGroupBox.Top+IndicationGroupBox.Height+20;
  OK_Button.Left:=IndicationGroupBox.Left+(IndicationGroupBox.Width-OK_Button.Width) DIV 2;
  Close_Button.Top:=OK_Button.Top+OK_Button.Height+15;
  Close_Button.Left:=OK_Button.Left;

  Self.Height:=Close_Button.Top+80;
end;

procedure TfmErrorIndication.FormShow(Sender: TObject);
begin
  IndicateDefects.Checked:=ErrorIndications[0];
  IndicateDisturbances.Checked:=ErrorIndications[1];
  IndicateExcpetions.Checked:=ErrorIndications[2];

  OK_Button.Enabled:=false;
  FocusControl(IndicationGroupBox);
end;

procedure TfmErrorIndication.CheckButtonClick(Sender: TObject);
begin
  OK_Button.Enabled:=(IndicateDefects.Checked<>ErrorIndications[0]) or
                     (IndicateDisturbances.Checked<>ErrorIndications[1]) or
                     (IndicateExcpetions.Checked<>ErrorIndications[2]);
end;

procedure TfmErrorIndication.OK_ButtonClick(Sender: TObject);
begin
  ErrorIndications[0]:=IndicateDefects.Checked;
  ErrorIndications[1]:=IndicateDisturbances.Checked;
  ErrorIndications[2]:=IndicateExcpetions.Checked;
end;

end.
