unit ModuleData_32;

interface

uses Windows, StdCtrls, ExtCtrls, Controls, ComCtrls, Buttons, Classes, Gauges,
     Forms, EditControls, GroupControls, DataTypes, HartModules;

type
  TModuleFreqDataRec = record
    InputSource: TFreqInputType;
    SignalInvert,
    InputAndLFD: byte;
    Point4mA  : real;
    Point20mA : real;
    DampingTimeConstant : real;
    OutputMode   : TOutputModeSet;
    AdjustMode   : TAdjustModeSet;
    OffsetAdjust,
    GainAdjust   : real;
    LeakFlowMode : TOnOffSet;
    LFThreshold,
    LFCurrent    :  real;
    TransmitterFailureAlarmLevel : TAlarmLevelSet;
    PulseOutputMode: TPulseOutputMode;
    DivisorValue : integer;
    PulseLength  : real;

    InhibitMode  : TInhibitMode;
    AlarmOutputMode: TAlarmOutputMode;
    PulseInverter,
    AlarmInverter: boolean;
    Threshold1,
    Hysteresis1,
    Threshold2,
    Hysteresis2   : real;
    end;


  TfmModuleData_32 = class(TForm)
    PageControl1: TPageControl;

    InputTabSheet: TTabSheet;
    InputSourceSelection: TMyRadioGroup;
    SignalRangeBox: TGroupBox;
    Point4mA_Edit: TLabelRealEdit;
    Point20mA_Edit: TLabelRealEdit;

    CurrentOutputTabSheet: TTabSheet;
    OutputFilteringBox: TGroupBox;
    DampingConstantPanel: TPanel;
    DampingConstant_Edit: TLabelRealEdit;
    DeadZeroButton: TRadioButton;
    NE43OnButton: TRadioButton;
    NE43OffButton: TRadioButton;
    OutputAdjust: TGroupBox;
    AdjustDisable: TRadioButton;
    AdjustEnable: TRadioButton;
    AdjustHardware: TRadioButton;
    AdjustPanel: TPanel;
    Offset_Edit: TLabelRealEdit;
    Gain_Edit: TLabelRealEdit;
    LeakFlowSelection: TGroupBox;
    LeakFlowDisable: TRadioButton;
    LeakFlowEnable: TRadioButton;
    LeakFlowPanel: TPanel;
    LeakFlowThreshold_Edit: TLabelRealEdit;
    LeakFlowOutput_Edit: TLabelRealEdit;
    TX_Alarm_Selector: TMyRadioGroup;

    DigitalOutputTabSheet: TTabSheet;
    InhibitModeSelection: TMyRadioGroup;
    PulseConfigGroupBox: TGroupBox;
    PulseOffRadioButton: TRadioButton;
    PulseDirectRadioButton: TRadioButton;
    PulseToggleRadioButton: TRadioButton;
    PulseFixedRadioButton: TRadioButton;
    PulseDividerGroupBox: TGroupBox;
    Divisor_Edit: TLabelIntegerEdit;
    PulseDuration_Edit: TLabelRealEdit;
    PulseLFDRadioButton: TRadioButton;
    PulseSingleTripRadioButton: TRadioButton;
    PulseWindowTripRadioButton: TRadioButton;
    InvertedPulseCheckBox: TCheckBox;
    TripAOnPulseGroupBox: TGroupBox;
    Trip1_OnPulse_Threshold_Edit: TLabelRealEdit;
    Hysteresis1_OnPulse_Edit: TLabelRealEdit;
    TripBOnPulseGroupBox: TGroupBox;
    Trip2_OnPulse_Threshold_Edit: TLabelRealEdit;
    Hysteresis2_OnPulse_Edit: TLabelRealEdit;

    AlarmConfigGroupBox: TGroupBox;
    AlarmOffRadioButton: TRadioButton;
    AlarmDirectRadioButton: TRadioButton;
    AlarmLFDRadioButton: TRadioButton;
    AlarmSingleTripRadioButton: TRadioButton;
    AlarmWindowTripRadioButton: TRadioButton;
    InvertedAlarmCheckBox: TCheckBox;
    TripAOnAlarmGroupBox: TGroupBox;
    Trip1_OnAlarm_Threshold_Edit: TLabelRealEdit;
    Hysteresis1_OnAlarm_Edit: TLabelRealEdit;
    TripBOnAlarmGroupBox: TGroupBox;
    Trip2_OnAlarm_Threshold_Edit: TLabelRealEdit;
    Hysteresis2_OnAlarm_Edit: TLabelRealEdit;

    CommGauge: TGauge;
    OK_Button: TBitBtn;
    Close_Button: TBitBtn;

    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure PageControl1DrawTab(Control: TCustomTabControl; TabIndex: Integer;
      const Rect: TRect; Active: Boolean);

    procedure InputSourceSelectionClick(Sender: TObject);
    procedure Point4mA_EditChange(Sender: TObject);
    procedure Point4mA_EditExit(Sender: TObject);
    procedure Point4mA_EditRangeValidationError(Sender: TObject);
    procedure Point20mA_EditChange(Sender: TObject);
    procedure Point20mA_EditExit(Sender: TObject);
    procedure Point20mA_EditRangeValidationError(Sender: TObject);
    procedure DampingConstant_EditChange(Sender: TObject);
    procedure DampingConstant_EditRangeValidationError(Sender: TObject);
    procedure DeadZeroButtonClick(Sender: TObject);
    procedure NE43OnButtonClick(Sender: TObject);
    procedure NE43OffButtonClick(Sender: TObject);
    procedure AdjustDisableClick(Sender: TObject);
    procedure AdjustEnableClick(Sender: TObject);
    procedure AdjustHardwareClick(Sender: TObject);
    procedure Offset_EditChange(Sender: TObject);
    procedure Offset_EditRangeValidationError(Sender: TObject);
    procedure Gain_EditChange(Sender: TObject);
    procedure Gain_EditRangeValidationError(Sender: TObject);
    procedure LeakFlowDisableClick(Sender: TObject);
    procedure LeakFlowEnableClick(Sender: TObject);
    procedure LeakFlowThreshold_EditChange(Sender: TObject);
    procedure LeakFlowThreshold_EditRangeValidationError(Sender: TObject);
    procedure LeakFlowOutput_EditChange(Sender: TObject);
    procedure LeakFlowOutput_EditRangeValidationError(Sender: TObject);
    procedure TX_Alarm_SelectorClick(Sender: TObject);
    procedure InhibitModeSelectionClick(Sender: TObject);
    procedure PulseOffRadioButtonClick(Sender: TObject);
    procedure PulseDirectRadioButtonClick(Sender: TObject);
    procedure PulseToggleRadioButtonClick(Sender: TObject);
    procedure PulseFixedRadioButtonClick(Sender: TObject);
    procedure PulseLFDRadioButtonClick(Sender: TObject);
    procedure PulseSingleTripRadioButtonClick(Sender: TObject);
    procedure PulseWindowTripRadioButtonClick(Sender: TObject);
    procedure InvertedPulseCheckBoxClick(Sender: TObject);
    procedure Divisor_EditChange(Sender: TObject);
    procedure Divisor_EditRangeValidationError(Sender: TObject);
    procedure PulseDuration_EditChange(Sender: TObject);
    procedure PulseDuration_EditRangeValidationError(Sender: TObject);
    procedure Trip1_OnPulse_Threshold_EditChange(Sender: TObject);
    procedure Trip1_OnPulse_Threshold_EditRangeValidationError(Sender: TObject);
    procedure Hysteresis1_OnPulse_EditChange(Sender: TObject);
    procedure Hysteresis1_OnPulse_EditRangeValidationError(Sender: TObject);
    procedure Trip2_OnPulse_Threshold_EditChange(Sender: TObject);
    procedure Trip2_OnPulse_Threshold_EditRangeValidationError(Sender: TObject);
    procedure Hysteresis2_OnPulse_EditChange(Sender: TObject);
    procedure Hysteresis2_OnPulse_EditRangeValidationError(Sender: TObject);
    procedure AlarmOffRadioButtonClick(Sender: TObject);
    procedure AlarmDirectRadioButtonClick(Sender: TObject);
    procedure AlarmLFDRadioButtonClick(Sender: TObject);
    procedure AlarmSingleTripRadioButtonClick(Sender: TObject);
    procedure AlarmWindowTripRadioButtonClick(Sender: TObject);
    procedure InvertedAlarmCheckBoxClick(Sender: TObject);
    procedure Trip1_OnAlarm_Threshold_EditChange(Sender: TObject);
    procedure Trip1_OnAlarm_Threshold_EditRangeValidationError(Sender: TObject);
    procedure Hysteresis1_OnAlarm_EditChange(Sender: TObject);
    procedure Hysteresis1_OnAlarm_EditRangeValidationError(Sender: TObject);
    procedure Trip2_OnAlarm_Threshold_EditChange(Sender: TObject);
    procedure Trip2_OnAlarm_Threshold_EditRangeValidationError(Sender: TObject);
    procedure Hysteresis2_OnAlarm_EditChange(Sender: TObject);
    procedure Hysteresis2_OnAlarm_EditRangeValidationError(Sender: TObject);
  private
    { Private declarations }
    fDialogMode: TDialogMode;
    fSaveMode: TSaveMode;
    pHartModule: PBasicHartModule;
    fDeviceType: TDeviceType;
    fModuleFreqDataRec: TModuleFreqDataRec;
    fProtectedPath : boolean;

    procedure EncodeModuleData;
    procedure DecodeModuleData;

    procedure SetInputSourceSelectionLabels;
    procedure SetInputSourceSelectionItems;
    procedure SetSignalRangeEditLabels;
    procedure SetSignalRangeEditLimits;
    procedure SetSignalRangeEditValues;
    procedure SetDeviceSpecificOutputFilteringAndLimitationLabels;
    procedure SetOutputFilteringEditLimits;
    procedure SetOutputFilteringValue;
    procedure SetOuputLimitationItems;
    procedure SetDeviceSpecificOutpuAdjustLabels;
    procedure SetOutputAdjustLimits;
    procedure SetOutputAdjustControls;
    procedure SetLeakFlowLabels;
    procedure SetLeakFlowLimits;
    procedure SetLeakFlowControls;
    procedure SetTransmitterAlarmLabels;
    procedure SetTransmitterAlarmItems;
    procedure SetInhibitInputLabels;
    procedure SetInhibitInputItems(DisableUnused: boolean);
    procedure SetPulseOutputLabels;
    procedure SetPulseOutputLimits;
    procedure SetInactiveDivisor_Edit;
    procedure SetInactivePulseDuration_Edit;
    procedure SetInactivePulseTrip2Controls;
    procedure SetVisiblePulseDividerMode;
    procedure SetVisiblePulseTripMode;
    procedure SetPulseOutputControls;
    procedure SetAlarmOutputLabels;
    procedure SetAlarmOutputLimits;
    procedure SetAlarmOutputControls;

    procedure SetAllLabels;
    procedure SetRangeErrorMessages;
    procedure ArrangeDeviceTypeSpecificVisibleControls;
    procedure ArrangeDisplayModeLook;
    procedure ArrangeConfigurationModeLook;
    procedure SetAllDisplayValues;
    procedure IndicateReceivedChar;
    procedure UpdateAcceptButton;
  public
    { Public declarations }
    procedure AssignHartModule(Value: PBasicHartModule);
    procedure SetMode(DMode: TDialogMode; SMode: TSaveMode);
  end;

var
  fmModuleData_32: TfmModuleData_32;

implementation

{$R *.dfm}

uses Dialogs, Graphics, StringUtils, ProcessUtils, DataInstances, DataConstants, LabelNumbers,
     HartDataTypes, HartDataConstants, HelpContextNumbers, ConversionProcs;

procedure TfmModuleData_32.EncodeModuleData;
var lPrimaryVariableOutputData: THPrimaryVariableOutput;
    lLeakFlowOffParameters: THLeakFlowOffParameters_x532;
    lAdjustOutputParameters: THAdjustOutputParameters;
    lInputConfiguration : THInputConfiguration_x532;
    lDividerParameters: THDividerParameters;
    lTripParameters: THTripParameters_x532;
    lTripA,lTripB: THTripParameters_1003;
    lFullScale, lNE43Mode,
    lTXAlarmLevel, lInputAndLFD: byte;
  procedure ClearModuleFreqDataRec; // local procedure
  begin
    with fModuleFreqDataRec do
         begin
         AdjustMode:=tmOff;
         OffsetAdjust:=0.0;
         GainAdjust:=0.0;

         LeakFlowMode:=tsOff;
         LFThreshold:=0.0;
         LFCurrent:=4.0;

         PulseOutputMode:=pmOff;
         DivisorValue:=100;
         PulseLength:=1.0;
         PulseInverter:=false;

         AlarmOutputMode:=amOff;
         Threshold1:=20.0;
         Hysteresis1:=1.0;
         Threshold2:=80.0;
         Hysteresis2:=1.0;
         AlarmInverter:=false;
         end;
end;

begin
  if (pHartModule<>nil) then
     begin
     lPrimaryVariableOutputData:=TSingleChannelHartModule(pHartModule^).PrimaryVariableOutputData;
     lFullScale:=THartModule_Freq(pHartModule^).FullScale;
     lAdjustOutputParameters:=THartModule_Freq(pHartModule^).AdjustOutputParameters;
     lTXAlarmLevel:=THartModule_Freq(pHartModule^).TransmitterFailureAlarmLevel;
     lDividerParameters:=THartModule_Freq(pHartModule^).DividerParameters;
     if (fDeviceType=dtx532) then
        begin
        lInputConfiguration:=THartModule_x532(pHartModule^).InputConfiguration;
        lNE43Mode:=THartModule_x532(pHartModule^).NE43Mode;
        lLeakFlowOffParameters:=THartModule_x532(pHartModule^).LeakFlowOffParameters;
        lTripParameters:=THartModule_x532(pHartModule^).TripParameters;
        end;
     if (fDeviceType=dt1003) then
        begin
        lInputAndLFD:=THartModule_1003(pHartModule^).InputAndLFDMode;
        lLeakFlowOffParameters:=GetLeakFlowParameters_x532(THartModule_1003(pHartModule^).LeakFlowOffParameters);
        lTripA:=THartModule_1003(pHartModule^).TripAParameters;
        if (ValueUnitsFromHART(lTripA.TPUnits)<>tuPercent) then
           begin
           lTripA.TPUnits:=ValueUnitsToHART(tuPercent);
           lTripA.TripValue:=PercentValueFromRange(lTripA.TripValue,lPrimaryVariableOutputData.Point4mA,lPrimaryVariableOutputData.Point20mA);
           lTripA.Hysteresis:=PercentValueFromRange(lTripA.Hysteresis,lPrimaryVariableOutputData.Point4mA,lPrimaryVariableOutputData.Point20mA);
           end;
        lTripB:=THartModule_1003(pHartModule^).TripBParameters;
        if (ValueUnitsFromHART(lTripB.TPUnits)<>tuPercent) then
           begin
           lTripB.TPUnits:=ValueUnitsToHART(tuPercent);
           lTripB.TripValue:=PercentValueFromRange(lTripB.TripValue,lPrimaryVariableOutputData.Point4mA,lPrimaryVariableOutputData.Point20mA);
           lTripB.Hysteresis:=PercentValueFromRange(lTripB.Hysteresis,lPrimaryVariableOutputData.Point4mA,lPrimaryVariableOutputData.Point20mA);
           end;
        end;

     ClearModuleFreqDataRec;

     with fModuleFreqDataRec do
          begin
          if (fDeviceType=dtx532) then
             InputSource:=FreqInputSensorFromHART(lInputConfiguration.InputSource);

          Point4mA:=lPrimaryVariableOutputData.Point4mA;
          Point20mA:=lPrimaryVariableOutputData.Point20mA;
          DampingTimeConstant:=lPrimaryVariableOutputData.DampingTimeConstant;

          if (fDeviceType=dtx532) then
             OutputMode:=FreqOutputModeFromHART(lFullScale,lNE43Mode)
          else OutputMode:=FreqOutputModeFromHART(lFullScale,0);

          AdjustMode:=AdjustModeFromHART(lAdjustOutputParameters.AdjMode);
          if (AdjustMode<>tmOff) then
             begin
             OffsetAdjust:=lAdjustOutputParameters.OffsetValue;
             GainAdjust:=lAdjustOutputParameters.GainValue;
             end;

          // Note: lLeakFlowOffParam_1003 was transferred to lLeakFlowOffParameters
          LeakFlowMode:=LeakFlowModeFromHART(lLeakFlowOffParameters.FunctionSelect);
          if (LeakFlowMode<>tsOff) then
             begin
             LFThreshold:=lLeakFlowOffParameters.LeakFlowOffValue;
             LFCurrent:=lLeakFlowOffParameters.LeakFlowOffCurrent;
             end;

          TransmitterFailureAlarmLevel:=AlarmLevelFromHART(lTXAlarmLevel);

          if (fDeviceType=dtx532) then
             PulseOutputMode:=PulseOutputModex532FromHART(lDividerParameters.FunctionSelect,lInputConfiguration.InputSource)
          else PulseOutputMode:=PulseOutputMode1003FromHART(lDividerParameters.FunctionSelect,lInputAndLFD,lTripA.FunctionSelect,lTripB.FunctionSelect);

          if (PulseOutputMode=pmToggle) or
             (PulseOutputMode=pmPulses) then
             begin
             DivisorValue:=System.Round(lDividerParameters.Divider);
             if (PulseOutputMode=pmPulses) then
                PulseLength:=lDividerParameters.Duration;
             end
          else
             if (fDeviceType=dt1003) and
                ((PulseOutputMode=pmTrip1) or // pmTrip1 or pmTrip2 only on E01003
                 (PulseOutputMode=pmTrip2)) then
                begin
                PulseInverter:=TripOutputInverted(lTripA.FunctionSelect);
                Threshold1:=lTripA.TripValue;
                Hysteresis1:=lTripA.Hysteresis;
                if (PulseOutputMode=pmTrip2) then
                   begin
                   Threshold2:=lTripB.TripValue;
                   Hysteresis2:=lTripB.Hysteresis;
                   end;
                end;

          if (fDeviceType=dtx532) then
             AlarmOutputMode:=AlarmOutputModeFromHART(lTripParameters.FunctionSelect,lInputConfiguration.InputSource)
          else AlarmOutputMode:=AlarmOutputMode1003FromHART(lInputAndLFD,lTripA.FunctionSelect,lTripB.FunctionSelect);

          if (AlarmOutputMode=amOff) or
             (AlarmOutputMode=amLFD) then
             begin
             if (AlarmOutputMode=amLFD) and
                (fDeviceType=dtx532) then     // relevant only for MTL4532
                 InhibitMode:=InhibitModeFromHART(lTripParameters.FunctionSelect,lInputConfiguration.SignalInvert)
             else InhibitMode:=imOff;
             if (AlarmOutputMode=amOff) then
                AlarmInverter:=false
             else AlarmInverter:=false; // insert adequate formula here
             end;

          if (AlarmOutputMode=amTrip1) or
             (AlarmOutputMode=amTrip2) then
             begin
             if (fDeviceType=dtx532) then
                begin
                Threshold1:=lTripParameters.TripAValue;
                Hysteresis1:=lTripParameters.AHysteresis;
                if (AlarmOutputMode=amTrip2) then
                   begin
                   Threshold2:=lTripParameters.TripBValue;
                   Hysteresis2:=lTripParameters.BHysteresis;
                   end;
                InhibitMode:=InhibitModeFromHART(lTripParameters.FunctionSelect,lInputConfiguration.SignalInvert);
                AlarmInverter:=AlarmOutputInvertFromHART(lTripParameters.FunctionSelect,lInputConfiguration.InputSource,lInputConfiguration.SignalInvert);
                end;

             if (fDeviceType=dt1003) then
                begin
                if (AlarmOutputMode=amTrip2) then
                   begin
                   AlarmInverter:=TripOutputInverted(lTripA.FunctionSelect);
                   Threshold1:=lTripA.TripValue;
                   Hysteresis1:=lTripA.Hysteresis;
                   end
                else AlarmInverter:=TripOutputInverted(lTripB.FunctionSelect);
                Threshold2:=lTripB.TripValue;
                Hysteresis2:=lTripB.Hysteresis;
                end;
             end;

          if (fDeviceType=dtx532) then
             SignalInvert:=lInputConfiguration.SignalInvert;

          end;
     end;
end;

procedure TfmModuleData_32.DecodeModuleData;
var lPrimaryVariableOutputData: THPrimaryVariableOutput;
    lLeakFlowOffParameters: THLeakFlowOffParameters_x532;
    lAdjustOutputParameters: THAdjustOutputParameters;
    lInputConfiguration : THInputConfiguration_x532;
    lFullScale, lNE43Mode, lTXAlarmLevel: byte;
    lDividerParameters: THDividerParameters;
    lTripParameters: THTripParameters_x532;
    lTripA,lTripB: THTripParameters_1003;
    lInputAndLFD: byte;
  procedure ClearLocalModuleParameters; // local procedure
  begin
    if (fDeviceType=dtx532) then
       begin
       lDividerParameters.FunctionSelect:=CP_Blank_Pattern;
       with lTripParameters do
            begin
            FunctionSelect:=CP_Blank_Pattern; // ???
            TPAUnits:=CHart_Percent;
            TripAValue:=20.0;
            AHysteresis:=1.0;
            TPBUnits:=CHart_Percent;
            TripBValue:=80.0;
            BHysteresis:=1.0;
            end;
       end;
    if (fDeviceType=dt1003) then
       begin
       lInputAndLFD:=CP3_Input_PA2IC1;
       lDividerParameters.FunctionSelect:=CP3_Off_Pattern;
       with lTripA do
            begin
            FunctionSelect:=CP3_Off_Pattern;
            TPUnits:=CHart_Percent;
            TripValue:=20.0;
            Hysteresis:=1.0;
            end;
       with lTripB do
            begin
            FunctionSelect:=CP3_Off_Pattern;
            TPUnits:=CHart_Percent;
            TripValue:=20.0;
            Hysteresis:=1.0;
            end;
       end;
end;

begin
  if (pHartModule<>nil) then
     begin
     if (fDeviceType=dtx532) then
        begin
        lInputConfiguration.InputSource:=FreqInputSensorToHART(fModuleFreqDataRec.InputSource);
        lInputConfiguration.SignalInvert:=CP_Blank_Pattern;
        end;
     // the input and invert configuration will be initialised here and updated
     // with some other informations and assigned to module on end of this procedure

     lPrimaryVariableOutputData.PVAlarm:=0;          // not used in MTL products, set to 0
     lPrimaryVariableOutputData.TransferFunction:=0; // not used in this product (set to 0);
     lPrimaryVariableOutputData.PVUnits:=CHart_Herz;
     lPrimaryVariableOutputData.Point4mA:=fModuleFreqDataRec.Point4mA;
     lPrimaryVariableOutputData.Point20mA:=fModuleFreqDataRec.Point20mA;
     lPrimaryVariableOutputData.DampingTimeConstant:=fModuleFreqDataRec.DampingTimeConstant;

     TSingleChannelHartModule(pHartModule^).PrimaryVariableOutputData:=lPrimaryVariableOutputData;

     FreqOutputModeToHART(fModuleFreqDataRec.OutputMode,lFullScale,lNE43Mode);

     THartModule_Freq(pHartModule^).FullScale:=lFullScale;
     if (fDeviceType=dtx532) then
        THartModule_x532(pHartModule^).NE43Mode:=lNE43Mode;

     lAdjustOutputParameters.AdjMode:=AdjustModeToHART(fModuleFreqDataRec.AdjustMode);
     lAdjustOutputParameters.AdjUnits:=CHart_Percent;
     if (fModuleFreqDataRec.AdjustMode<>tmOff) then
        begin
        lAdjustOutputParameters.OffsetValue:=fModuleFreqDataRec.OffsetAdjust;
        lAdjustOutputParameters.GainValue:=fModuleFreqDataRec.GainAdjust;
        end
     else
        begin
        lAdjustOutputParameters.OffsetValue:=0.0;
        lAdjustOutputParameters.GainValue:=0.0;
        end;

     THartModule_Freq(pHartModule^).AdjustOutputParameters:=lAdjustOutputParameters;

     lLeakFlowOffParameters.FunctionSelect:=LeakFlowModeToHART(fModuleFreqDataRec.LeakFlowMode);
     lLeakFlowOffParameters.LFUnits:=CHart_Percent;
     if (fModuleFreqDataRec.LeakFlowMode<>tsOff) then
        begin
        lLeakFlowOffParameters.LeakFlowOffValue:=fModuleFreqDataRec.LFThreshold;
        lLeakFlowOffParameters.LeakFlowOffCurrent:=fModuleFreqDataRec.LFCurrent;
        end
     else
        begin
        lLeakFlowOffParameters.LeakFlowOffValue:=0.0;
        lLeakFlowOffParameters.LeakFlowOffCurrent:=0.0;
        end;

     if (fDeviceType=dtx532) then
        THartModule_x532(pHartModule^).LeakFlowOffParameters:=lLeakFlowOffParameters
     else THartModule_1003(pHartModule^).LeakFlowOffParameters:=GetLeakFlowParameters_1003(lLeakFlowOffParameters);

     lTXAlarmLevel:=AlarmLevelToHART(fModuleFreqDataRec.TransmitterFailureAlarmLevel);
     THartModule_Freq(pHartModule^).TransmitterFailureAlarmLevel:=lTXAlarmLevel;

     // Inhibit will be evaluated as a part of Alarm Function

     ClearLocalModuleParameters;

     if (fDeviceType=dtx532) then
        PulseOutputModex532ToHART(fModuleFreqDataRec.PulseOutputMode,lDividerParameters.FunctionSelect,lInputConfiguration.InputSource)
     else PulseOutputMode1003ToHART(fModuleFreqDataRec.PulseOutputMode,lDividerParameters.FunctionSelect,lInputAndLFD,lTripA.FunctionSelect,lTripB.FunctionSelect);

     if (fModuleFreqDataRec.PulseOutputMode=pmToggle) or
        (fModuleFreqDataRec.PulseOutputMode=pmPulses) then
        begin
        lDividerParameters.Divider:=fModuleFreqDataRec.DivisorValue;
        if (fModuleFreqDataRec.PulseOutputMode=pmPulses) then
           lDividerParameters.Duration:=fModuleFreqDataRec.PulseLength
        else lDividerParameters.Duration:=0.0;
        end
     else // fModuleFreqDataRec.PulseOutputMode=pmOff or fModuleFreqDataRec.PulseOutputMode=pm11
          // or (fDeviceType=dt1003) and (fModuleFreqDataRec.PulseOutputMode=pmLFD)
          // or (fDeviceType=dt1003) and (fModuleFreqDataRec.PulseOutputMode=pmTrip1 or fModuleFreqDataRec.PulseOutputMode=pmTrip2)
        begin
        lDividerParameters.Divider:=1;
        lDividerParameters.Duration:=0.0;
        if (fDeviceType=dt1003) and
           ((fModuleFreqDataRec.PulseOutputMode=pmTrip1) or (fModuleFreqDataRec.PulseOutputMode=pmTrip2))then
           begin
           InvertTripOutput(fModuleFreqDataRec.PulseInverter,lTripA.FunctionSelect);
           lTripA.TripValue:=fModuleFreqDataRec.Threshold1;
           lTripA.Hysteresis:=fModuleFreqDataRec.Hysteresis1;
           if (fModuleFreqDataRec.PulseOutputMode=pmTrip2) then
              begin
              InvertTripOutput(not(fModuleFreqDataRec.PulseInverter),lTripB.FunctionSelect);
              lTripB.TripValue:=fModuleFreqDataRec.Threshold2;
              lTripB.Hysteresis:=fModuleFreqDataRec.Hysteresis2;
              end;
           end;
        end;

     THartModule_Freq(pHartModule^).DividerParameters:=lDividerParameters;

     if (fDeviceType=dtx532) then
        begin
        lTripParameters.FunctionSelect:=AlarmOutputModeToHART(fModuleFreqDataRec.AlarmOutputMode,fModuleFreqDataRec.AlarmInverter,fModuleFreqDataRec.InhibitMode);
        lTripParameters.TPAUnits:=CHart_Percent;
        lTripParameters.TPBUnits:=CHart_Percent;
        if (fModuleFreqDataRec.AlarmOutputMode=amTrip1) or
           (fModuleFreqDataRec.AlarmOutputMode=amTrip2) then
           begin
           lTripParameters.TripAValue:=fModuleFreqDataRec.Threshold1;
           lTripParameters.AHysteresis:=fModuleFreqDataRec.Hysteresis1;
           if (fModuleFreqDataRec.AlarmOutputMode=amTrip2) then
              begin
              lTripParameters.TripBValue:=fModuleFreqDataRec.Threshold2;
              lTripParameters.BHysteresis:=fModuleFreqDataRec.Hysteresis2;
              end
           else
              begin
              lTripParameters.TripBValue:=0.0;
              lTripParameters.BHysteresis:=0.0;
              end;
           end
        else  // fModuleFreqDataRec.AlarmOutputMode=amOff or fModuleFreqDataRec.AlarmOutputMode=amLFD
           begin
           lTripParameters.TripAValue:=0.0;
           lTripParameters.AHysteresis:=0.0;
           lTripParameters.TripBValue:=0.0;
           lTripParameters.BHysteresis:=0.0;
           end;
        AlarmOutputModeToInputHART(fModuleFreqDataRec.AlarmOutputMode,lInputConfiguration.InputSource);
        InhibitModeToHART(fModuleFreqDataRec.InhibitMode,lInputConfiguration.SignalInvert);

        THartModule_x532(pHartModule^).TripParameters:=lTripParameters;
        end;

     // Input configuration was updated during alarm output evaluation with information
     // about inhibit, invert etc. and can be now transferred to the hart module
     if (fDeviceType=dtx532) then
        THartModule_x532(pHartModule^).InputConfiguration:=lInputConfiguration;

     if (fDeviceType=dt1003) then
        begin
        AlarmOutputMode1003ToHART(fModuleFreqDataRec.AlarmOutputMode,lTripA.FunctionSelect,lTripB.FunctionSelect,lInputAndLFD);

        if (fModuleFreqDataRec.AlarmOutputMode=amTrip1) then
           begin
           InvertTripOutput(fModuleFreqDataRec.AlarmInverter,lTripB.FunctionSelect);
           lTripB.TripValue:=fModuleFreqDataRec.Threshold2;
           lTripB.Hysteresis:=fModuleFreqDataRec.Hysteresis2;
           end
        else
           if (fModuleFreqDataRec.AlarmOutputMode=amTrip2) then
              begin
              InvertTripOutput(fModuleFreqDataRec.AlarmInverter,lTripA.FunctionSelect);
              lTripA.TripValue:=fModuleFreqDataRec.Threshold1;
              lTripA.Hysteresis:=fModuleFreqDataRec.Hysteresis1;
              InvertTripOutput(not(fModuleFreqDataRec.AlarmInverter),lTripB.FunctionSelect);
              lTripB.TripValue:=fModuleFreqDataRec.Threshold2;
              lTripB.Hysteresis:=fModuleFreqDataRec.Hysteresis2;
              end;

        THartModule_1003(pHartModule^).TripAParameters:=lTripA;
        THartModule_1003(pHartModule^).TripBParameters:=lTripB;
        end;

     if (fDeviceType=dt1003) then
        begin
        lInputAndLFD:=lInputAndLFD or CP3_LFD_ForceTx;

        THartModule_1003(pHartModule^).InputAndLFDMode:=lInputAndLFD;
        end;
     end;
end;

procedure TfmModuleData_32.SetInputSourceSelectionLabels;
begin
  InputSourceSelection.Caption:=LanguageStrings[flInputSource];

  InputSourceSelection.Items.Clear;
  InputSourceSelection.Items.Add(LanguageStrings[flCurrentOrVoltage]);
  InputSourceSelection.Items.Add(LanguageStrings[flSwitchProximity]);
end;

procedure TfmModuleData_32.SetInputSourceSelectionItems;
begin
  case fModuleFreqDataRec.InputSource  of
       fiVoltCurrent: InputSourceSelection.ItemIndex:=0;
       fiProxy: InputSourceSelection.ItemIndex:=1;
       else InputSourceSelection.ItemIndex:=-1;
       end;
  if fDialogMode=dmDisplay then InputSourceSelection.DisableNotCheckedButtons;
end;

procedure TfmModuleData_32.SetSignalRangeEditLabels;
begin
  SignalRangeBox.Caption:=LanguageStrings[flSignalRange];
  Point4mA_Edit.LabelCaption:=LanguageStrings[fl4mAPoint];
  Point20mA_Edit.LabelCaption:=LanguageStrings[fl20mAPoint];
  Point4mA_Edit.UnitText:=LanguageStrings[flHerz];
  Point20mA_Edit.UnitText:=LanguageStrings[flHerz];
end;

procedure TfmModuleData_32.SetSignalRangeEditLimits;
begin
  with Point4mA_Edit do
       begin
       Min:=C_Lim_Freq.LLim;
       Max:=C_Lim_Freq.Ulim;
       end;
  with Point20mA_Edit do
       begin
       Min:=C_Lim_Freq.LLim;
       Max:=C_Lim_Freq.Ulim;
       end;
end;

procedure TfmModuleData_32.SetSignalRangeEditValues;
begin
  Point4mA_Edit.Value:=fModuleFreqDataRec.Point4mA;
  Point20mA_Edit.Value:=fModuleFreqDataRec.Point20mA;
end;

procedure TfmModuleData_32.SetDeviceSpecificOutputFilteringAndLimitationLabels;
begin
  OutputFilteringBox.Caption:=LanguageStrings[flFilteringAndLimitation];

  DampingConstant_Edit.LabelCaption:=LanguageStrings[flDampingConst];

  DeadZeroButton.Caption:=LanguageStrings[flOut0to20mA];
  NE43OnButton.Caption:=LanguageStrings[flOutNE43];

  if (fDeviceType=dtx532) then
     NE43OffButton.Caption:=LanguageStrings[flOutMTL]
  else NE43OffButton.Caption:=LanguageStrings[flOut4to20mA];
end;

procedure TfmModuleData_32.SetOutputFilteringEditLimits;
begin
  with DampingConstant_Edit do
       begin
       Min:=C_Lim_Damp.LLim;
       Max:=C_Lim_Damp.Ulim;
       end;
end;

procedure TfmModuleData_32.SetOutputFilteringValue;
begin
  DampingConstant_Edit.Value:=fModuleFreqDataRec.DampingTimeConstant;
end;

procedure TfmModuleData_32.SetOuputLimitationItems;
begin
  DeadZeroButton.Enabled:=true;
  NE43OnButton.Enabled:=true;
  NE43OffButton.Enabled:=true;
  case fModuleFreqDataRec.OutputMode of
       omDead: DeadZeroButton.Checked:=true;
       omNE43: NE43OnButton.Checked:=true;
       else    NE43OffButton.Checked:=true;
       end;
  if fDialogMode=dmDisplay then
     begin
     DeadZeroButton.Enabled:=DeadZeroButton.Checked;
     NE43OnButton.Enabled:=NE43OnButton.Checked;
     NE43OffButton.Enabled:=NE43OffButton.Checked;
     end;
end;

procedure TfmModuleData_32.SetDeviceSpecificOutpuAdjustLabels;
begin
  OutputAdjust.Caption:=DeleteAcceleratorKey(LanguageStrings[flAdjustOutput]);
  AdjustDisable.Caption:=LanguageStrings[flOff];
  if (fDeviceType=dt1003) then
     begin
     AdjustEnable.Caption:=LanguageStrings[flSoftAdjust];
     AdjustHardware.Caption:=LanguageStrings[flHardAdjust];
     end
  else AdjustEnable.Caption:=LanguageStrings[flOn];

  Offset_Edit.LabelCaption:=LanguageStrings[flAdjustOffset];
  Offset_Edit.UnitText:=LanguageStrings[flPercent];
  Gain_Edit.LabelCaption:=LanguageStrings[flAdjustGain];
  Gain_Edit.UnitText:=LanguageStrings[flPercent];
end;

procedure TfmModuleData_32.SetOutputAdjustLimits;
begin
  with Offset_Edit do
       begin
       Min:=-5.0;
       Max:=5.0;
       end;
  with Gain_Edit do
       begin
       Min:=-5.0;
       Max:=5.0;
       end;
end;

procedure TfmModuleData_32.SetOutputAdjustControls;
begin
  AdjustDisable.Enabled:=true;
  AdjustEnable.Enabled:=true;
  if (fDeviceType=dt1003) then
     AdjustHardware.Enabled:=true;

  AdjustPanel.Enabled:=true;
  Offset_Edit.Enabled:=true;
  Offset_Edit.EditColor:=clWindow;
  Gain_Edit.Enabled:=true;
  Gain_Edit.EditColor:=clWindow;

  case fModuleFreqDataRec.AdjustMode of
       tmOff: AdjustDisable.Checked:=true;
       tmSoft: AdjustEnable.Checked:=true;
       tmHard: if (fDeviceType=dt1003) then
                  AdjustHardware.Checked:=true
               else AdjustDisable.Checked:=true;
       end;
  if (fModuleFreqDataRec.AdjustMode<>tmOff) then
     begin
     Offset_Edit.Value:=fModuleFreqDataRec.OffsetAdjust;
     Gain_Edit.Value:=fModuleFreqDataRec.GainAdjust;
     Offset_Edit.EditFont.Color:=Self.Font.Color;
     Gain_Edit.EditFont.Color:=Self.Font.Color;
     end
  else // fModuleFreqDataRec.AdjustMode=tmOff
     begin
     AdjustPanel.Enabled:=false;
     Offset_Edit.Enabled:=false;
     Offset_Edit.EditColor:=clSilver;
     Offset_Edit.EditFont.Color:=clSilver;
     Gain_Edit.Enabled:=false;
     Gain_Edit.EditColor:=clSilver;
     Gain_Edit.EditFont.Color:=clSilver;
     end;

  if fDialogMode=dmDisplay then
     begin
     AdjustDisable.Enabled:=AdjustDisable.Checked;
     AdjustEnable.Enabled:=AdjustEnable.Checked;
     if (fDeviceType=dt1003) then
        AdjustHardware.Enabled:=AdjustHardware.Checked;

     AdjustPanel.Enabled:=false;
     Offset_Edit.Enabled:=false;
     Offset_Edit.EditColor:=clSilver;
     Gain_Edit.Enabled:=false;
     Gain_Edit.EditColor:=clSilver;
     end;
end;

procedure TfmModuleData_32.SetLeakFlowLabels;
begin
  LeakFlowSelection.Caption:=DeleteAcceleratorKey(LanguageStrings[flLeakFlowOption]);

  LeakFlowDisable.Caption:=LanguageStrings[flOff];
  LeakFlowEnable.Caption:=LanguageStrings[flOn];
  LeakFlowThreshold_Edit.LabelCaption:=LanguageStrings[flLeakFlowThreshold];
  LeakFlowThreshold_Edit.UnitText:=LanguageStrings[flPercent];
  LeakFlowOutput_Edit.LabelCaption:=LanguageStrings[flLeakFlowCurrent];
  LeakFlowOutput_Edit.UnitText:=LanguageStrings[flmiliAmp];
end;

procedure TfmModuleData_32.SetLeakFlowLimits;
begin
  with LeakFlowThreshold_Edit do
       begin
       Min:=0.75;
       Max:=20.0;
       end;
  with LeakFlowOutput_Edit do
       begin
       Min:=2.0;
       Max:=5.0;
       end;
end;

procedure TfmModuleData_32.SetLeakFlowControls;
begin
  LeakFlowDisable.Enabled:=true;
  LeakFlowEnable.Enabled:=(fModuleFreqDataRec.OutputMode<>omDead); // true;

  LeakFlowPanel.Enabled:=true;
  LeakFlowThreshold_Edit.Enabled:=true;
  LeakFlowThreshold_Edit.EditColor:=clWindow;
  LeakFlowOutput_Edit.Enabled:=true;
  LeakFlowOutput_Edit.EditColor:=clWindow;

  if (fModuleFreqDataRec.LeakFlowMode=tsOn) then
     begin
     LeakFlowEnable.Checked:=true;
     LeakFlowThreshold_Edit.Value:=fModuleFreqDataRec.LFThreshold;
     LeakFlowOutput_Edit.Value:=fModuleFreqDataRec.LFCurrent;
     LeakFlowThreshold_Edit.EditFont.Color:=Self.Font.Color;
     LeakFlowOutput_Edit.EditFont.Color:=Self.Font.Color;
     end
  else // fModuleFreqDataRec.LeakFlowMode=tsOff
     begin
     LeakFlowDisable.Checked:=true;
     LeakFlowPanel.Enabled:=false;
     LeakFlowThreshold_Edit.Enabled:=false;
     LeakFlowThreshold_Edit.EditColor:=clSilver;
     LeakFlowThreshold_Edit.EditFont.Color:=clSilver;
     LeakFlowOutput_Edit.Enabled:=false;
     LeakFlowOutput_Edit.EditColor:=clSilver;
     LeakFlowOutput_Edit.EditFont.Color:=clSilver;
     end;

  if fDialogMode=dmDisplay then
     begin
     LeakFlowDisable.Enabled:=LeakFlowDisable.Checked;
     LeakFlowEnable.Enabled:=LeakFlowEnable.Checked;

     LeakFlowPanel.Enabled:=false;
     LeakFlowThreshold_Edit.Enabled:=false;
     LeakFlowThreshold_Edit.EditColor:=clSilver;
     LeakFlowOutput_Edit.Enabled:=false;
     LeakFlowOutput_Edit.EditColor:=clSilver;
     end;
end;

procedure TfmModuleData_32.SetTransmitterAlarmLabels;
begin
  TX_Alarm_Selector.Caption:=LanguageStrings[flTXAlarmLevel];
  TX_Alarm_Selector.Items.Clear;
  TX_Alarm_Selector.Items.Add(LanguageStrings[flLowAlarm]);
  TX_Alarm_Selector.Items.Add(LanguageStrings[flHighAlarm]);
  TX_Alarm_Selector.Items.Add(LanguageStrings[flAlarmOff]);
end;

procedure TfmModuleData_32.SetTransmitterAlarmItems;
begin
  TX_Alarm_Selector.EnableAllButtons;
  if fModuleFreqDataRec.TransmitterFailureAlarmLevel in [taLow..taHigh] then
     TX_Alarm_Selector.ItemIndex:=integer(fModuleFreqDataRec.TransmitterFailureAlarmLevel)
  else TX_Alarm_Selector.ItemIndex:=2;
  if (fDialogMode=dmDisplay) or
     (fModuleFreqDataRec.OutputMode=omDead) then
     TX_Alarm_Selector.DisableNotCheckedButtons;
end;

procedure TfmModuleData_32.SetInhibitInputLabels;
begin
  with InhibitModeSelection do
       begin
       if fDialogMode=dmDisplay then Caption:=DeleteAcceleratorKey(LanguageStrings[flInhibitInputEnable]);
       if fDialogMode=dmConfig then Caption:=LanguageStrings[flInhibitInputEnable];
       Items.Clear;
       Items.Add(LanguageStrings[flOff]);
       Items.Add(LanguageStrings[flNormalShort]);
       Items.Add(LanguageStrings[flInvertedShort]);
       end;
end;

procedure TfmModuleData_32.SetInhibitInputItems(DisableUnused: boolean);
begin
  InhibitModeSelection.EnableAllButtons;
  if fModuleFreqDataRec.InhibitMode in [imOff..imInverted] then
     InhibitModeSelection.ItemIndex:=integer(fModuleFreqDataRec.InhibitMode)
  else InhibitModeSelection.ItemIndex:=2;
  if (fDialogMode=dmDisplay) or DisableUnused then
     InhibitModeSelection.DisableNotCheckedButtons;
end;

procedure TfmModuleData_32.SetPulseOutputLabels;
begin
  with PulseConfigGroupBox do
       begin
       if fDialogMode=dmDisplay then Caption:=DeleteAcceleratorKey(LanguageStrings[flPulseOutput]);
       if fDialogMode=dmConfig then Caption:=LanguageStrings[flPulseOutput];
       end;
  PulseOffRadioButton.Caption:=LanguageStrings[flOff];
  PulseDirectRadioButton.Caption:=LanguageStrings[flPulseDirect];
  PulseToggleRadioButton.Caption:=LanguageStrings[flToggleOutput];
  PulseFixedRadioButton.Caption:=LanguageStrings[flFixedPulse];
  PulseSingleTripRadioButton.Caption:=LanguageStrings[flSimpleTrip];
  PulseWindowTripRadioButton.Caption:=LanguageStrings[flWindowTrip];
  InvertedPulseCheckBox.Caption:=LanguageStrings[flInvertedOutput];
  PulseLFDRadioButton.Caption:=LanguageStrings[flLFDShort];

  PulseDividerGroupBox.Caption:=LanguageStrings[flDividerOption];

  Divisor_Edit.LabelCaption:=LanguageStrings[flDivisorValue];
  with PulseDuration_Edit do
       begin
       LabelCaption:=LanguageStrings[flPulseDuration];
       UnitText:='ms';
       end;

  TripAOnPulseGroupBox.Caption:=LanguageStrings[flTrip1];
  with Trip1_OnPulse_Threshold_Edit do
       begin
       LabelCaption:=LanguageStrings[flThreshold];
       UnitText:='%';
       end;
  with Hysteresis1_OnPulse_Edit do
       begin
       LabelCaption:=LanguageStrings[flHysteresis];
       UnitText:='%';
       end;

  TripBOnPulseGroupBox.Caption:=LanguageStrings[flTrip2];
  with Trip2_OnPulse_Threshold_Edit do
       begin
       LabelCaption:=LanguageStrings[flThreshold];
       UnitText:='%';
       end;
  with Hysteresis2_OnPulse_Edit do
       begin
       LabelCaption:=LanguageStrings[flHysteresis];
       UnitText:='%';
       end;
end;

procedure TfmModuleData_32.SetPulseOutputLimits;
begin
  with Divisor_Edit do        // Def_DividerLimits;
       begin
       Min:=1;
       Max:=65534;
       end;
  with PulseDuration_Edit do  // Def_PulseLimits;
       begin
       Min:=0.05;
       Max:=10.0;
       end;
  with Trip1_OnPulse_Threshold_Edit do
       begin
       Min:=0.75;
       Max:=99.25;
       end;
  with Hysteresis1_OnPulse_Edit do
       begin
       Min:=0.5;
       Max:=10.0;
       end;
  with Trip2_OnPulse_Threshold_Edit do
       begin
       Min:=0.75;
       Max:=99.25;
       end;
  with Hysteresis2_OnPulse_Edit do
       begin
       Min:=0.5;
       Max:=10.0;
       end;
end;

procedure TfmModuleData_32.SetInactiveDivisor_Edit;
begin
  Divisor_Edit.Enabled:=false;
  Divisor_Edit.EditColor:=clSilver;
  Divisor_Edit.EditFont.Color:=clSilver;
end;

procedure TfmModuleData_32.SetInactivePulseDuration_Edit;
begin
  PulseDuration_Edit.Enabled:=false;
  PulseDuration_Edit.EditColor:=clSilver;
  PulseDuration_Edit.EditFont.Color:=clSilver;
end;

procedure TfmModuleData_32.SetInactivePulseTrip2Controls;
begin
  Trip2_OnPulse_Threshold_Edit.Enabled:=false;
  Trip2_OnPulse_Threshold_Edit.EditColor:=clSilver;
  Trip2_OnPulse_Threshold_Edit.EditFont.Color:=clSilver;
  Hysteresis2_OnPulse_Edit.Enabled:=false;
  Hysteresis2_OnPulse_Edit.EditColor:=clSilver;
  Hysteresis2_OnPulse_Edit.EditFont.Color:=clSilver;
end;

procedure TfmModuleData_32.SetVisiblePulseDividerMode;
begin
  PulseDividerGroupBox.Visible:=true;
  TripAOnPulseGroupBox.Visible:=false;
  TripBOnPulseGroupBox.Visible:=false;
end;

procedure TfmModuleData_32.SetVisiblePulseTripMode;
begin
  PulseDividerGroupBox.Visible:=false;
  TripAOnPulseGroupBox.Visible:=true;
  TripBOnPulseGroupBox.Visible:=true;
end;

procedure TfmModuleData_32.SetPulseOutputControls;
begin
  PulseOffRadioButton.Enabled:=true;
  PulseDirectRadioButton.Enabled:=true;
  PulseToggleRadioButton.Enabled:=true;
  PulseFixedRadioButton.Enabled:=true;

  PulseDividerGroupBox.Enabled:=true;
  Divisor_Edit.Enabled:=true;
  Divisor_Edit.EditColor:=clWindow;
  PulseDuration_Edit.Enabled:=true;
  PulseDuration_Edit.EditColor:=clWindow;

  if (fDeviceType=dt1003) then
     begin
     PulseLFDRadioButton.Enabled:=true;
     PulseSingleTripRadioButton.Enabled:=true;
     PulseWindowTripRadioButton.Enabled:=true;
     InvertedPulseCheckBox.Enabled:=true;
     InvertedPulseCheckBox.Checked:=false;
     
     TripAOnPulseGroupBox.Enabled:=true;
     Trip1_OnPulse_Threshold_Edit.Enabled:=true;
     Trip1_OnPulse_Threshold_Edit.EditColor:=clWindow;
     Hysteresis1_OnPulse_Edit.Enabled:=true;
     Hysteresis1_OnPulse_Edit.EditColor:=clWindow;

     TripBOnPulseGroupBox.Enabled:=true;
     Trip2_OnPulse_Threshold_Edit.Enabled:=true;
     Trip2_OnPulse_Threshold_Edit.EditColor:=clWindow;
     Hysteresis2_OnPulse_Edit.Enabled:=true;
     Hysteresis2_OnPulse_Edit.EditColor:=clWindow;

     SetVisiblePulseDividerMode;
     end;

  if (fModuleFreqDataRec.PulseOutputMode=pmOff) then
     begin
     PulseOffRadioButton.Checked:=true;
     SetInactiveDivisor_Edit;
     SetInactivePulseDuration_Edit;
     if (fDeviceType=dt1003) then
        InvertedPulseCheckBox.Enabled:=false;
     end;

  if ((fDeviceType=dtx532) and (fModuleFreqDataRec.PulseOutputMode=pm11)) then
     begin
     PulseDirectRadioButton.Checked:=true;
     SetInactiveDivisor_Edit;
     SetInactivePulseDuration_Edit;
     end;

  if (fModuleFreqDataRec.PulseOutputMode=pmPulses) then
     begin
     PulseFixedRadioButton.Checked:=true;
     Divisor_Edit.Value:=fModuleFreqDataRec.DivisorValue;
     Divisor_Edit.EditFont.Color:=Self.Font.Color;
     PulseDuration_Edit.Value:=fModuleFreqDataRec.PulseLength;
     PulseDuration_Edit.EditFont.Color:=Self.Font.Color;
     if (fDeviceType=dt1003) then
        InvertedPulseCheckBox.Enabled:=false;
     end;

  if ((fDeviceType=dtx532) and (fModuleFreqDataRec.PulseOutputMode=pmToggle)) then
     begin
     PulseToggleRadioButton.Checked:=true;
     Divisor_Edit.Value:=fModuleFreqDataRec.DivisorValue;
     Divisor_Edit.EditFont.Color:=Self.Font.Color;
     SetInactivePulseDuration_Edit;
     end;

  if (fDeviceType=dt1003) then
     begin
     if (fModuleFreqDataRec.PulseOutputMode=pmLFD) then
        begin
        PulseLFDRadioButton.Checked:=true;
        SetInactiveDivisor_Edit;
        SetInactivePulseDuration_Edit;
        InvertedPulseCheckBox.Enabled:=false;
        end;

     if (fModuleFreqDataRec.PulseOutputMode=pmTrip1) then
        begin
        PulseSingleTripRadioButton.Checked:=true;
        InvertedPulseCheckBox.Checked:=fModuleFreqDataRec.PulseInverter;
        SetVisiblePulseTripMode;
        Trip1_OnPulse_Threshold_Edit.Value:=fModuleFreqDataRec.Threshold1;
        Trip1_OnPulse_Threshold_Edit.EditFont.Color:=Self.Font.Color;
        Hysteresis1_OnPulse_Edit.Value:=fModuleFreqDataRec.Hysteresis1;
        Hysteresis1_OnPulse_Edit.EditFont.Color:=Self.Font.Color;
        SetInactivePulseTrip2Controls;
        end;

     if (fModuleFreqDataRec.PulseOutputMode=pmTrip2) then
        begin
        PulseWindowTripRadioButton.Checked:=true;
        InvertedPulseCheckBox.Checked:=fModuleFreqDataRec.PulseInverter;
        SetVisiblePulseTripMode;
        Trip1_OnPulse_Threshold_Edit.Value:=fModuleFreqDataRec.Threshold1;
        Trip1_OnPulse_Threshold_Edit.EditFont.Color:=Self.Font.Color;
        Hysteresis1_OnPulse_Edit.Value:=fModuleFreqDataRec.Hysteresis1;
        Hysteresis1_OnPulse_Edit.EditFont.Color:=Self.Font.Color;
        Trip2_OnPulse_Threshold_Edit.Value:=fModuleFreqDataRec.Threshold2;
        Trip2_OnPulse_Threshold_Edit.EditFont.Color:=Self.Font.Color;
        Hysteresis2_OnPulse_Edit.Value:=fModuleFreqDataRec.Hysteresis2;
        Hysteresis2_OnPulse_Edit.EditFont.Color:=Self.Font.Color;
        end;
     end;

  if fDialogMode=dmDisplay then
     begin
     PulseOffRadioButton.Enabled:=PulseOffRadioButton.Checked;
     PulseDirectRadioButton.Enabled:=PulseDirectRadioButton.Checked;
     PulseToggleRadioButton.Enabled:=PulseToggleRadioButton.Checked;
     PulseFixedRadioButton.Enabled:=PulseFixedRadioButton.Checked;

     PulseDividerGroupBox.Enabled:=false;
     Divisor_Edit.EditColor:=clSilver;
     PulseDuration_Edit.EditColor:=clSilver;

     if (fDeviceType=dt1003) then
        begin
        PulseLFDRadioButton.Enabled:=PulseLFDRadioButton.Checked;
        PulseSingleTripRadioButton.Enabled:=PulseSingleTripRadioButton.Checked;
        PulseWindowTripRadioButton.Enabled:=PulseWindowTripRadioButton.Checked;
        InvertedPulseCheckBox.Enabled:=InvertedPulseCheckBox.Checked;

        Trip1_OnPulse_Threshold_Edit.EditColor:=clSilver;
        Hysteresis1_OnPulse_Edit.EditColor:=clSilver;

        TripBOnPulseGroupBox.Enabled:=false;
        Trip2_OnPulse_Threshold_Edit.EditColor:=clSilver;
        Hysteresis2_OnPulse_Edit.EditColor:=clSilver;
        end;
     end;
end;

procedure TfmModuleData_32.SetAlarmOutputLabels;
begin
  with AlarmConfigGroupBox do
       begin
       if fDialogMode=dmDisplay then Caption:=DeleteAcceleratorKey(LanguageStrings[flAlarmOutput]);
       if fDialogMode=dmDisplay then Caption:=LanguageStrings[flAlarmOutput];
       end;

  AlarmOffRadioButton.Caption:=LanguageStrings[flOff];
  AlarmLFDRadioButton.Caption:=LanguageStrings[flLFDShort];
  AlarmSingleTripRadioButton.Caption:=LanguageStrings[flSimpleTrip];
  AlarmWindowTripRadioButton.Caption:=LanguageStrings[flWindowTrip];
  InvertedAlarmCheckBox.Caption:=LanguageStrings[flInvertedOutput];

  TripAOnAlarmGroupBox.Caption:=LanguageStrings[flTrip1];
  with Trip1_OnAlarm_Threshold_Edit do
       begin
       LabelCaption:=LanguageStrings[flThreshold];
       UnitText:='%';
       end;
  with Hysteresis1_OnAlarm_Edit do
       begin
       LabelCaption:=LanguageStrings[flHysteresis];
       UnitText:='%';
       end;

  TripBOnAlarmGroupBox.Caption:=LanguageStrings[flTrip2];
  with Trip2_OnAlarm_Threshold_Edit do
       begin
       LabelCaption:=LanguageStrings[flThreshold];
       UnitText:='%';
       end;
  with Hysteresis2_OnAlarm_Edit do
       begin
       LabelCaption:=LanguageStrings[flHysteresis];
       UnitText:='%';
       end;
end;

procedure TfmModuleData_32.SetAlarmOutputLimits;
begin
  with Trip1_OnAlarm_Threshold_Edit do
       begin
       Min:=0.75;
       Max:=99.25;
       end;
  with Hysteresis1_OnAlarm_Edit do
       begin
       Min:=0.5;
       Max:=10.0;
       end;
  with Trip2_OnAlarm_Threshold_Edit do
       begin
       Min:=0.75;
       Max:=99.25;
       end;
  with Hysteresis2_OnAlarm_Edit do
       begin
       Min:=0.5;
       Max:=10.0;
       end;
end;

procedure TfmModuleData_32.SetAlarmOutputControls;
begin
  AlarmOffRadioButton.Enabled:=true;
  AlarmDirectRadioButton.Enabled:=AlarmDirectRadioButton.Visible and (fModuleFreqDataRec.InputSource=fiVoltCurrent);
  AlarmLFDRadioButton.Enabled:=true;
  AlarmSingleTripRadioButton.Enabled:=true;
  AlarmWindowTripRadioButton.Enabled:=true;
  InvertedAlarmCheckBox.Enabled:=true;

  TripAOnAlarmGroupBox.Enabled:=true;
  Trip1_OnAlarm_Threshold_Edit.Enabled:=true;
  Trip1_OnAlarm_Threshold_Edit.EditColor:=clWindow;
  Hysteresis1_OnAlarm_Edit.Enabled:=true;
  Hysteresis1_OnAlarm_Edit.EditColor:=clWindow;

  TripBOnAlarmGroupBox.Enabled:=true;
  Trip2_OnAlarm_Threshold_Edit.Enabled:=true;
  Trip2_OnAlarm_Threshold_Edit.EditColor:=clWindow;
  Hysteresis2_OnAlarm_Edit.Enabled:=true;
  Hysteresis2_OnAlarm_Edit.EditColor:=clWindow;


  if (fModuleFreqDataRec.AlarmOutputMode=amTrip1) or
     (fModuleFreqDataRec.AlarmOutputMode=amTrip2) then
     begin
     AlarmDirectRadioButton.Checked:=false;
     if (fModuleFreqDataRec.AlarmOutputMode=amTrip1) then
        begin
        AlarmSingleTripRadioButton.Checked:=true;

        if (fDeviceType=dtx532) then
           begin
           Trip1_OnAlarm_Threshold_Edit.Value:=fModuleFreqDataRec.Threshold1;
           Trip1_OnAlarm_Threshold_Edit.EditFont.Color:=Self.Font.Color;
           Hysteresis1_OnAlarm_Edit.Value:=fModuleFreqDataRec.Hysteresis1;
           Hysteresis1_OnAlarm_Edit.EditFont.Color:=Self.Font.Color;
           end
        else // (fDeviceType=dt1003)
           begin
           Trip1_OnAlarm_Threshold_Edit.Value:=fModuleFreqDataRec.Threshold2;
           Trip1_OnAlarm_Threshold_Edit.EditFont.Color:=Self.Font.Color;
           Hysteresis1_OnAlarm_Edit.Value:=fModuleFreqDataRec.Hysteresis2;
           Hysteresis1_OnAlarm_Edit.EditFont.Color:=Self.Font.Color;
           end;

        TripBOnAlarmGroupBox.Enabled:=false;
        Trip2_OnAlarm_Threshold_Edit.Enabled:=false;
        Trip2_OnAlarm_Threshold_Edit.EditColor:=clSilver;
        Trip2_OnAlarm_Threshold_Edit.EditFont.Color:=clSilver;
        Hysteresis2_OnAlarm_Edit.Enabled:=false;
        Hysteresis2_OnAlarm_Edit.EditColor:=clSilver;
        Hysteresis2_OnAlarm_Edit.EditFont.Color:=clSilver;
        end
     else // fModuleFreqDataRec.AlarmOutputMode=amTrip2
        begin
        AlarmWindowTripRadioButton.Checked:=true;

        Trip1_OnAlarm_Threshold_Edit.Value:=fModuleFreqDataRec.Threshold1;
        Trip1_OnAlarm_Threshold_Edit.EditFont.Color:=Self.Font.Color;
        Hysteresis1_OnAlarm_Edit.Value:=fModuleFreqDataRec.Hysteresis1;
        Hysteresis1_OnAlarm_Edit.EditFont.Color:=Self.Font.Color;

        Trip2_OnAlarm_Threshold_Edit.Value:=fModuleFreqDataRec.Threshold2;
        Trip2_OnAlarm_Threshold_Edit.EditFont.Color:=Self.Font.Color;
        Hysteresis2_OnAlarm_Edit.Value:=fModuleFreqDataRec.Hysteresis2;
        Hysteresis2_OnAlarm_Edit.EditFont.Color:=Self.Font.Color;
        end;
     InvertedAlarmCheckBox.Checked:=fModuleFreqDataRec.AlarmInverter;
     end
  else // fModuleFreqDataRec.AlarmOutputMode=amOff (or am11 or amLFD)
     begin
     AlarmOffRadioButton.Checked:=(fModuleFreqDataRec.AlarmOutputMode=amOff);
     AlarmDirectRadioButton.Checked:=AlarmDirectRadioButton.Enabled and (fModuleFreqDataRec.AlarmOutputMode=am11);
     AlarmLFDRadioButton.Enabled:=(fModuleFreqDataRec.InputSource=fiProxy);
     AlarmLFDRadioButton.Checked:=(fModuleFreqDataRec.AlarmOutputMode=amLFD);

     InvertedAlarmCheckBox.Enabled:=false;
     InvertedAlarmCheckBox.Checked:=false;

     Trip1_OnAlarm_Threshold_Edit.Enabled:=false;
     Trip1_OnAlarm_Threshold_Edit.EditColor:=clSilver;
     Trip1_OnAlarm_Threshold_Edit.EditFont.Color:=clSilver;
     Hysteresis1_OnAlarm_Edit.Enabled:=false;
     Hysteresis1_OnAlarm_Edit.EditColor:=clSilver;
     Hysteresis1_OnAlarm_Edit.EditFont.Color:=clSilver;

     Trip2_OnAlarm_Threshold_Edit.Enabled:=false;
     Trip2_OnAlarm_Threshold_Edit.EditColor:=clSilver;
     Trip2_OnAlarm_Threshold_Edit.EditFont.Color:=clSilver;
     Hysteresis2_OnAlarm_Edit.Enabled:=false;
     Hysteresis2_OnAlarm_Edit.EditColor:=clSilver;
     Hysteresis2_OnAlarm_Edit.EditFont.Color:=clSilver;
     end;

  if fDialogMode=dmDisplay then
     begin
     AlarmOffRadioButton.Enabled:=AlarmOffRadioButton.Checked;
     AlarmDirectRadioButton.Enabled:=AlarmDirectRadioButton.Checked;
     AlarmLFDRadioButton.Enabled:=AlarmLFDRadioButton.Checked;
     AlarmSingleTripRadioButton.Enabled:=AlarmSingleTripRadioButton.Checked;
     AlarmWindowTripRadioButton.Enabled:=AlarmWindowTripRadioButton.Checked;
     InvertedAlarmCheckBox.Enabled:=InvertedAlarmCheckBox.Checked;

     TripAOnAlarmGroupBox.Enabled:=false;
     Trip1_OnAlarm_Threshold_Edit.EditColor:=clSilver;
     Hysteresis1_OnAlarm_Edit.EditColor:=clSilver;

     TripBOnAlarmGroupBox.Enabled:=false;
     Trip2_OnAlarm_Threshold_Edit.EditColor:=clSilver;
     Hysteresis2_OnAlarm_Edit.EditColor:=clSilver;
     end;
end;

procedure TfmModuleData_32.SetAllLabels;
begin
  // Self.Caption will be set later according to the fDialogMode

  InputTabSheet.Caption:=LanguageStrings[flInputTab];
  SetInputSourceSelectionLabels;
  SetSignalRangeEditLabels;

  CurrentOutputTabSheet.Caption:=LanguageStrings[flCurrentOutputTab];
  SetLeakFlowLabels;
  SetTransmitterAlarmLabels;

  DigitalOutputTabSheet.Caption:=LanguageStrings[flDigitalOutputsTab];
  SetInhibitInputLabels;
  SetPulseOutputLabels;
  SetAlarmOutputLabels;
end;

procedure TfmModuleData_32.SetRangeErrorMessages;
begin
  Point4mA_Edit.RangeErrorMessage:=LanguageStrings[msFieldBetween];
  Point20mA_Edit.RangeErrorMessage:=LanguageStrings[msFieldBetween];

  DampingConstant_Edit.RangeErrorMessage:=LanguageStrings[msFieldBetween];

  Offset_Edit.RangeErrorMessage:=LanguageStrings[msFieldBetween];
  Gain_Edit.RangeErrorMessage:=LanguageStrings[msFieldBetween];

  LeakFlowThreshold_Edit.RangeErrorMessage:=LanguageStrings[msFieldBetween];
  LeakFlowOutput_Edit.RangeErrorMessage:=LanguageStrings[msFieldBetween];

  Divisor_Edit.RangeErrorMessage:=RestoreRessourceStringControls(LanguageStrings[msFieldBetween]);
  PulseDuration_Edit.RangeErrorMessage:=RestoreRessourceStringControls(LanguageStrings[msFieldBetween]);

  Trip1_OnPulse_Threshold_Edit.RangeErrorMessage:=RestoreRessourceStringControls(LanguageStrings[msFieldBetween]);
  Hysteresis1_OnPulse_Edit.RangeErrorMessage:=RestoreRessourceStringControls(LanguageStrings[msFieldBetween]);
  Trip2_OnPulse_Threshold_Edit.RangeErrorMessage:=RestoreRessourceStringControls(LanguageStrings[msFieldBetween]);
  Hysteresis2_OnPulse_Edit.RangeErrorMessage:=RestoreRessourceStringControls(LanguageStrings[msFieldBetween]);

  Trip1_OnAlarm_Threshold_Edit.RangeErrorMessage:=RestoreRessourceStringControls(LanguageStrings[msFieldBetween]);
  Hysteresis1_OnAlarm_Edit.RangeErrorMessage:=RestoreRessourceStringControls(LanguageStrings[msFieldBetween]);
  Trip2_OnAlarm_Threshold_Edit.RangeErrorMessage:=RestoreRessourceStringControls(LanguageStrings[msFieldBetween]);
  Hysteresis2_OnAlarm_Edit.RangeErrorMessage:=RestoreRessourceStringControls(LanguageStrings[msFieldBetween]);
end;

procedure TfmModuleData_32.ArrangeDeviceTypeSpecificVisibleControls;
begin
  if (fDeviceType=dtx532) then
     begin
     AdjustDisable.Top:=25;
     AdjustEnable.Top:=45;
     AdjustHardware.Visible:=false;

     end
  else  // (fDeviceType=dt1003)
     begin
     InputSourceSelection.Visible:=false;
     SignalRangeBox.Top:=10;

     DeadZeroButton.Left:=97;
     NE43OnButton.Visible:=false;

     AdjustDisable.Top:=20;
     AdjustEnable.Top:=35;
     AdjustHardware.Top:=50;

     InhibitModeSelection.Visible:=false;

     PulseConfigGroupBox.Top:=5;
     PulseConfigGroupBox.Height:=265;

     PulseDirectRadioButton.Visible:=false;
     PulseToggleRadioButton.Visible:=false;

     PulseOffRadioButton.Top:=18;
     PulseFixedRadioButton.Top:=18-4; // because Word Wrap

     PulseSingleTripRadioButton.Top:=35;
     PulseWindowTripRadioButton.Top:=35;

     InvertedPulseCheckBox.Top:=65;
     PulseLFDRadioButton.Top:=65;
     PulseLFDRadioButton.Left:=85;

     PulseDividerGroupBox.Top:=95;
     TripAOnPulseGroupBox.Top:=95;
     TripBOnPulseGroupBox.Top:=180;

     AlarmDirectRadioButton.Visible:=false;
     AlarmLFDRadioButton.Left:=65;
     end;
end;

procedure TfmModuleData_32.ArrangeDisplayModeLook;
begin
  Caption:=' '+DeleteAcceleratorKey(LanguageStrings[flDisplayModule]);
  HelpContext:=hcDisplayModule_x532;

  // Input Configuration Tab Sheet

  SignalRangeBox.Enabled:=false;
  Point4mA_Edit.EditColor:=clSilver;
  Point20mA_Edit.EditColor:=clSilver;

  DampingConstantPanel.Enabled:=false;
  DampingConstant_Edit.EditColor:=clSilver;

  AdjustPanel.Enabled:=false;
  Offset_Edit.EditColor:=clSilver;
  Gain_Edit.EditColor:=clSilver;

  LeakFlowPanel.Enabled:=false;
  LeakFlowThreshold_Edit.EditColor:=clSilver;
  LeakFlowOutput_Edit.EditColor:=clSilver;

  PulseDividerGroupBox.Enabled:=false;
  Divisor_Edit.EditColor:=clSilver;
  PulseDuration_Edit.EditColor:=clSilver;

  TripAOnPulseGroupBox.Enabled:=false;
  Trip1_OnPulse_Threshold_Edit.EditColor:=clSilver;
  Hysteresis1_OnPulse_Edit.EditColor:=clSilver;
  TripBOnPulseGroupBox.Enabled:=false;
  Trip2_OnPulse_Threshold_Edit.EditColor:=clSilver;
  Hysteresis2_OnPulse_Edit.EditColor:=clSilver;

  TripAOnAlarmGroupBox.Enabled:=false;
  Trip1_OnAlarm_Threshold_Edit.EditColor:=clSilver;
  Hysteresis1_OnAlarm_Edit.EditColor:=clSilver;
  TripBOnAlarmGroupBox.Enabled:=false;
  Trip2_OnAlarm_Threshold_Edit.EditColor:=clSilver;
  Hysteresis2_OnAlarm_Edit.EditColor:=clSilver;

  CommGauge.Visible:=false;
  OK_Button.Visible:=false;

  Close_Button.Top:=PageControl1.Top+PageControl1.Height+20;
  Close_Button.Left:=CommGauge.Left+(CommGauge.Width-Close_Button.Width) DIV 2;

  Self.Height:=Close_Button.Top+80;
end;

procedure TfmModuleData_32.ArrangeConfigurationModeLook;
var lButtonGap: integer;
begin
  Caption:=' '+DeleteAcceleratorKey(LanguageStrings[flConfigModule]);
  HelpContext:=hcConfigureModule_x532;

  SetRangeErrorMessages;

  SetSignalRangeEditLimits;
  SetOutputFilteringEditLimits;
  SetOutputAdjustLimits;
  SetLeakFlowLimits;
  SetPulseOutputLimits;
  SetAlarmOutputLimits;

  CommGauge.Visible:=true;
  CommGauge.Top:=PageControl1.Top+PageControl1.Height+15;

  OK_Button.Top:=CommGauge.Top+CommGauge.Height+20;
  Close_Button.Top:=OK_Button.Top;

  lButtonGap:=(CommGauge.Width-OK_Button.Width-Close_Button.Width) DIV 3;
  OK_Button.Left:=CommGauge.Left+lButtonGap;
  Close_Button.Left:=CommGauge.Left+OK_Button.Width+2*lButtonGap;

  Self.Height:=Close_Button.Top+80;
end;

procedure TfmModuleData_32.SetAllDisplayValues;
begin
  fProtectedPath:=true;

  // Input Configuration Tab Sheet
  SetInputSourceSelectionItems;
  SetSignalRangeEditValues;

  // Current Output Configuration Tab Sheet
  SetOutputFilteringValue;
  SetOuputLimitationItems;
  SetOutputAdjustControls;
  SetLeakFlowControls;
  SetTransmitterAlarmItems;

  // Digital Outputs Configuration Tab Sheet
  SetInhibitInputItems((fModuleFreqDataRec.AlarmOutputMode=amOff) or (fModuleFreqDataRec.AlarmOutputMode=amLFD));
  SetPulseOutputControls;
  SetAlarmOutputControls;

  fProtectedPath:=false;
end;

procedure TfmModuleData_32.IndicateReceivedChar;
begin
  if CommGauge.Progress < CommGauge.MaxValue then
     begin
     CommGauge.AddProgress(1);
     WaitMilliseconds(10);
     end
  else WaitMilliseconds(100);
end;

procedure TfmModuleData_32.UpdateAcceptButton;
begin
  if pHartModule<>nil then
     OK_Button.Enabled:=not(pHartModule^.VerifyDeviceData);
end;

//****************************************************************************//

procedure TfmModuleData_32.AssignHartModule(Value: PBasicHartModule);
begin
  pHartModule:=Value;
  if (pHartModule<>nil) then
     pHartModule^.AssignReceivedCharEvent(IndicateReceivedChar);
end;

procedure TfmModuleData_32.SetMode(DMode: TDialogMode; SMode: TSaveMode);
begin
  fDialogMode:=DMode; fSaveMode:=SMode;
end;

//****************************************************************************//

procedure TfmModuleData_32.FormCreate(Sender: TObject);
begin
  fDialogMode:=dmDisplay;
  fSaveMode:=smToDevice;
  fProtectedPath:=false;
  fDeviceType:=dtNone;
  pHartModule:=nil;

  with fModuleFreqDataRec do
       begin
       InputSource:=fiProxy;
       SignalInvert:=0;
       InputAndLFD:=0;
       Point4mA:=0.0;
       Point20mA:=1000.0;
       DampingTimeConstant:=0.0;
       OutputMode:=omLive;
       AdjustMode:=tmOff;
       OffsetAdjust:=0.0;
       GainAdjust:=0.0;
       LeakFlowMode:=tsOff;
       LFThreshold:=0.0;
       LFCurrent:=4.0;
       TransmitterFailureAlarmLevel:=taOff;
       PulseOutputMode:=pmOff;
       DivisorValue:=1;
       PulseLength:=1.0;

       InhibitMode:=imOff;
       AlarmOutputMode:=amOff;
       PulseInverter:=false;
       AlarmInverter:=false;
       Threshold1:=20.0;
       Hysteresis1:=1.0;
       Threshold2:=80.0;
       Hysteresis2:=1.0;
       end;

  PageControl1.OwnerDraw:=true;

  SetAllLabels;
end;

procedure TfmModuleData_32.FormShow(Sender: TObject);
begin
  if (pHartModule<>nil) then
     begin

     fDeviceType:=IdentToType(pHartModule^.BasicDeviceData.UID);
     if (fDeviceType<>dtNone) then
        begin
        EncodeModuleData;

        SetDeviceSpecificOutputFilteringAndLimitationLabels;
        SetDeviceSpecificOutpuAdjustLabels;
        ArrangeDeviceTypeSpecificVisibleControls;

        if fDialogMode=dmDisplay then ArrangeDisplayModeLook;
        if fDialogMode=dmConfig then ArrangeConfigurationModeLook;

        SetAllDisplayValues;

        if fDialogMode=dmConfig then OK_Button.Enabled:=false;
        end
     else
        begin
        MessageDlg('Unexpected error',mtError,[mbCancel],hcNoHelpTopic);
        Close;
        end;
     end
  else Close;
end;

procedure TfmModuleData_32.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var fExpectedTransferDataLength: integer;
    lUploadRequired,
    lTooSmallSpan,
    lIgnoreSmallSpan: boolean;
begin
  CanClose:=(ModalResult<>mrOK);
  if (pHartModule<>nil) and (fDialogMode=dmConfig) then
     begin
     // OriginalCursor:=Cursor;
     lUploadRequired:=false;
     lIgnoreSmallSpan:=false;
     PageControl1.Enabled:=false;
     OK_Button.Enabled:=false;
     Close_Button.Enabled:=false;
     if ((ModalResult<>mrOK) and not(pHartModule^.VerifyDeviceData)) then
        case (MessageDlg(LanguageStrings[mlChangedNotSaved],mtWarning,[mbYes,mbNo,mbCancel],hcNoHelpTopic)) of
             mrYes: lUploadRequired:=true;
             mrNo:  ModalResult:=mrIgnore;
             else CanClose:=false;
             end;

     if ((ModalResult=mrOK) or lUploadRequired) then
        begin
        lTooSmallSpan:=(System.Abs(fModuleFreqDataRec.Point20mA-fModuleFreqDataRec.Point4mA)<C_SpanLim_Freq) or
                       ((fModuleFreqDataRec.Point20mA>fModuleFreqDataRec.Point4mA) and
                        (((fModuleFreqDataRec.Point20mA-fModuleFreqDataRec.Point4mA)/fModuleFreqDataRec.Point20mA)<C_MinSpanRatio)) or
                       ((fModuleFreqDataRec.Point20mA<fModuleFreqDataRec.Point4mA) and
                        (((fModuleFreqDataRec.Point4mA-fModuleFreqDataRec.Point20mA)/fModuleFreqDataRec.Point4mA)<C_MinSpanRatio));

        if lTooSmallSpan then
           case (MessageDlg(LanguageStrings[msSpanTooSmall],mtWarning,[mbIgnore,mbCancel],hcNoHelpTopic)) of
                mrIgnore: lIgnoreSmallSpan:=true;
                else CanClose:=false;
                end;

        if not(lTooSmallSpan) or lIgnoreSmallSpan then
           begin
           pHartModule^.EvaluateRequiredDeviceDataStatusFlags;
           fExpectedTransferDataLength:=pHartModule^.GetModuleTransferDataLength(tdUpload);
           if (fExpectedTransferDataLength>0) then
              begin
              if (fSaveMode=smToDevice) then
                 begin
                 CommGauge.MaxValue:=fExpectedTransferDataLength;

                 Cursor:=crHourGlass;
                 Application.ProcessMessages;
                 pHartModule^.UploadRequiredDeviceData;

                 if not(pHartModule^.VerifyDeviceData) then
                    begin
                    MessageDlg(LanguageStrings[msDifferentResponse],mtError,[mbOk],hcNoHelpTopic);

                    EncodeModuleData;
                    SetAllDisplayValues;
                    pHartModule^.SynchronizeRequiredDeviceData;
                    UpdateAcceptButton;

                    ModalResult:=mrCancel;
                    end;

                 CommGauge.Progress:=0;
                 end
              else  // (fSaveMode=smToMemory)
                 begin
                 pHartModule^.SynchronizeActualDeviceData;
                 MessageDlg(LanguageStrings[msDataSavedToMemory],mtConfirmation,[mbOk],hcNoHelpTopic);
                 end;
              end;
           end;
        end;

     if not(CanClose) then
        begin
        PageControl1.Enabled:=true;
        UpdateAcceptButton;
        Close_Button.Enabled:=true;
        end;
     Cursor:=OriginalCursor;
     end;
end;

procedure TfmModuleData_32.FormDestroy(Sender: TObject);
begin
  if (pHartModule<>nil) then
     pHartModule^.UnAssignReceivedCharEvent;
end;

procedure TfmModuleData_32.PageControl1Change(Sender: TObject);
begin
  if (fDialogMode=dmDisplay) then
     begin
     if (PageControl1.ActivePage=InputTabSheet) then
        HelpContext:=hcDisplayInput32
     else if (PageControl1.ActivePage=CurrentOutputTabSheet) then
             HelpContext:=hcDisplayOutput32
     else // (PageControl1.ActivePage=DigitalOutputTabSheet)
             HelpContext:=hcDisplayDigital;
     end
  else // fDialogMode=dmConfig
     begin
     if (PageControl1.ActivePage=InputTabSheet) then
        HelpContext:=hcConfigInput32
     else if (PageControl1.ActivePage=CurrentOutputTabSheet) then
             HelpContext:=hcConfigOutput32
     else // (PageControl1.ActivePage=DigitalOutputTabSheet)
             HelpContext:=hcConfigDigital;
     end;
end;

procedure TfmModuleData_32.PageControl1DrawTab(Control: TCustomTabControl;
  TabIndex: Integer; const Rect: TRect; Active: Boolean);
begin
  if (Active) then
     Control.Canvas.Font.Style:=Control.Canvas.Font.Style+[fsBold]
  else Control.Canvas.Font.Style:=Control.Canvas.Font.Style-[fsBold];
  Control.Canvas.TextOut(Rect.Left+5,Rect.Top+3,PageControl1.Pages[TabIndex].Caption);
end;

//****************************************************************************//

procedure TfmModuleData_32.InputSourceSelectionClick(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.InputSource:=TFreqInputType(InputSourceSelection.ItemIndex);

     // Note: InputToAlarm (am11) is available only for Voltage and Current Input
     // Note: LFD on Alarm (amLFD) is available only for Switch/Proximity Detector Input 
     if not(((fModuleFreqDataRec.InputSource=fiVoltCurrent) and
        (fModuleFreqDataRec.AlarmOutputMode=am11)) or
        ((fModuleFreqDataRec.InputSource=fiProxy) and
        (fModuleFreqDataRec.AlarmOutputMode=amLFD))) then
        fModuleFreqDataRec.AlarmOutputMode:=amOff;
     SetAlarmOutputControls;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.Point4mA_EditChange(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.Point4mA:=Point4mA_Edit.Value;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.Point4mA_EditExit(Sender: TObject);
begin
  if (Point4mA_Edit.Value=0.0) then
     Point4mA_Edit.Value:=C_LowLim_Freq;
end;

procedure TfmModuleData_32.Point4mA_EditRangeValidationError(Sender: TObject);
begin
  Point4mA_Edit.SetValueToValidRange;
end;

procedure TfmModuleData_32.Point20mA_EditChange(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.Point20mA:=Point20mA_Edit.Value;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.Point20mA_EditExit(Sender: TObject);
begin
  if (Point20mA_Edit.Value=0.0) then
     Point20mA_Edit.Value:=C_LowLim_Freq;
end;

procedure TfmModuleData_32.Point20mA_EditRangeValidationError(Sender: TObject);
begin
  Point20mA_Edit.SetValueToValidRange;
end;

procedure TfmModuleData_32.DampingConstant_EditChange(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.DampingTimeConstant:=DampingConstant_Edit.Value;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.DampingConstant_EditRangeValidationError(Sender: TObject);
begin
  DampingConstant_Edit.SetValueToValidRange;
end;

procedure TfmModuleData_32.DeadZeroButtonClick(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.OutputMode:=omDead;

     if (fModuleFreqDataRec.LeakFlowMode<>tsOff) then
        fModuleFreqDataRec.LeakFlowMode:=tsOff;
     SetLeakFlowControls;

     if (fModuleFreqDataRec.TransmitterFailureAlarmLevel<>taOff) then
        fModuleFreqDataRec.TransmitterFailureAlarmLevel:=taOff;
     SetTransmitterAlarmItems;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.NE43OnButtonClick(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.OutputMode:=omNE43;

     SetLeakFlowControls;
     SetTransmitterAlarmItems;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.NE43OffButtonClick(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.OutputMode:=omLive;

     SetLeakFlowControls;
     SetTransmitterAlarmItems;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.AdjustDisableClick(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.AdjustMode:=tmOff;
     SetOutputAdjustControls;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.AdjustEnableClick(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.AdjustMode:=tmSoft;
     SetOutputAdjustControls;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.AdjustHardwareClick(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.AdjustMode:=tmHard;
     SetOutputAdjustControls;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.Offset_EditChange(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.OffsetAdjust:=Offset_Edit.Value;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.Offset_EditRangeValidationError(Sender: TObject);
begin
  Offset_Edit.SetValueToValidRange;
end;

procedure TfmModuleData_32.Gain_EditChange(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.GainAdjust:=Gain_Edit.Value;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.Gain_EditRangeValidationError(Sender: TObject);
begin
  Gain_Edit.SetValueToValidRange;
end;

procedure TfmModuleData_32.LeakFlowDisableClick(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.LeakFlowMode:=tsOff;
     SetLeakFlowControls;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.LeakFlowEnableClick(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.LeakFlowMode:=tsOn;
     SetLeakFlowControls;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.LeakFlowThreshold_EditChange(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.LFThreshold:=LeakFlowThreshold_Edit.Value;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.LeakFlowThreshold_EditRangeValidationError(Sender: TObject);
begin
  LeakFlowThreshold_Edit.SetValueToValidRange;
end;

procedure TfmModuleData_32.LeakFlowOutput_EditChange(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.LFCurrent:=LeakFlowOutput_Edit.Value;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.LeakFlowOutput_EditRangeValidationError(Sender: TObject);
begin
  LeakFlowOutput_Edit.SetValueToValidRange;
end;

procedure TfmModuleData_32.TX_Alarm_SelectorClick(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.TransmitterFailureAlarmLevel:=TAlarmLevelSet(TX_Alarm_Selector.ItemIndex);

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.InhibitModeSelectionClick(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.InhibitMode:=TInhibitMode(InhibitModeSelection.ItemIndex);

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.PulseOffRadioButtonClick(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.PulseOutputMode:=pmOff;
     SetPulseOutputControls;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.PulseDirectRadioButtonClick(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.PulseOutputMode:=pm11;
     SetPulseOutputControls;

     if (fDeviceType=dtx532) and
        (fModuleFreqDataRec.AlarmOutputMode=am11) then
        begin
        fModuleFreqDataRec.AlarmOutputMode:=amOff;
        SetAlarmOutputControls;
        end;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.PulseToggleRadioButtonClick(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.PulseOutputMode:=pmToggle;
     SetPulseOutputControls;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.PulseFixedRadioButtonClick(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.PulseOutputMode:=pmPulses;
     SetPulseOutputControls;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.PulseLFDRadioButtonClick(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.PulseOutputMode:=pmLFD;
     SetPulseOutputControls;

     if (fDeviceType=dt1003) and
        (fModuleFreqDataRec.AlarmOutputMode=amLFD) then
        begin
        fModuleFreqDataRec.AlarmOutputMode:=amOff;
        SetAlarmOutputControls;
        end;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.PulseSingleTripRadioButtonClick(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.PulseOutputMode:=pmTrip1;
     SetPulseOutputControls;

     if (fDeviceType=dt1003) and
        (fModuleFreqDataRec.AlarmOutputMode=amTrip2) then
        begin
        fModuleFreqDataRec.AlarmOutputMode:=amTrip1;
        SetAlarmOutputControls;
        end;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.PulseWindowTripRadioButtonClick(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.PulseOutputMode:=pmTrip2;
     SetPulseOutputControls;

     if (fDeviceType=dt1003) and
        ((fModuleFreqDataRec.AlarmOutputMode=amTrip1) or
         (fModuleFreqDataRec.AlarmOutputMode=amTrip2)) then
        begin
        fModuleFreqDataRec.AlarmOutputMode:=amOff;
        SetAlarmOutputControls;
        end;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.InvertedPulseCheckBoxClick(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.PulseInverter:=InvertedPulseCheckBox.Checked;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.Divisor_EditChange(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.DivisorValue:=Divisor_Edit.Value;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.Divisor_EditRangeValidationError(Sender: TObject);
begin
  Divisor_Edit.SetValueToValidRange;
end;

procedure TfmModuleData_32.PulseDuration_EditChange(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.PulseLength:=PulseDuration_Edit.Value;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.PulseDuration_EditRangeValidationError(Sender: TObject);
begin
  PulseDuration_Edit.SetValueToValidRange;
end;

procedure TfmModuleData_32.Trip1_OnPulse_Threshold_EditChange(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.Threshold1:=Trip1_OnPulse_Threshold_Edit.Value;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.Trip1_OnPulse_Threshold_EditRangeValidationError(Sender: TObject);
begin
  Trip1_OnPulse_Threshold_Edit.SetValueToValidRange;
end;

procedure TfmModuleData_32.Hysteresis1_OnPulse_EditChange(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.Hysteresis1:=Hysteresis1_OnPulse_Edit.Value;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.Hysteresis1_OnPulse_EditRangeValidationError(Sender: TObject);
begin
  Hysteresis1_OnPulse_Edit.SetValueToValidRange;
end;

procedure TfmModuleData_32.Trip2_OnPulse_Threshold_EditChange(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.Threshold2:=Trip2_OnPulse_Threshold_Edit.Value;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.Trip2_OnPulse_Threshold_EditRangeValidationError(Sender: TObject);
begin
  Trip2_OnPulse_Threshold_Edit.SetValueToValidRange;
end;

procedure TfmModuleData_32.Hysteresis2_OnPulse_EditChange(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.Hysteresis2:=Hysteresis2_OnPulse_Edit.Value;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.Hysteresis2_OnPulse_EditRangeValidationError(Sender: TObject);
begin
  Hysteresis2_OnPulse_Edit.SetValueToValidRange;
end;

procedure TfmModuleData_32.AlarmOffRadioButtonClick(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.AlarmOutputMode:=amOff;
     fModuleFreqDataRec.InhibitMode:=imOff;

     SetAlarmOutputControls;
     SetInhibitInputItems(true);

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.AlarmDirectRadioButtonClick(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.AlarmOutputMode:=am11;
     fModuleFreqDataRec.InhibitMode:=imOff;

     SetAlarmOutputControls;
     if (fDeviceType=dtx532) then
        SetInhibitInputItems(true);

     if (fDeviceType=dtx532) and
        (fModuleFreqDataRec.PulseOutputMode=pm11) then
        begin
        fModuleFreqDataRec.PulseOutputMode:=pmOff;
        SetPulseOutputControls;
        end;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.AlarmLFDRadioButtonClick(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.AlarmOutputMode:=amLFD;
     fModuleFreqDataRec.InhibitMode:=imOff;

     SetAlarmOutputControls;
     if (fDeviceType=dtx532) then
        SetInhibitInputItems(true);

     if (fDeviceType=dt1003) and
        (fModuleFreqDataRec.PulseOutputMode=pmLFD) then
        begin
        fModuleFreqDataRec.PulseOutputMode:=pmOff;
        SetPulseOutputControls;
        end;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.AlarmSingleTripRadioButtonClick(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.AlarmOutputMode:=amTrip1;

     SetAlarmOutputControls;
     SetInhibitInputItems(false);

     if (fDeviceType=dt1003) and
        (fModuleFreqDataRec.PulseOutputMode=pmTrip2) then
        begin
        fModuleFreqDataRec.PulseOutputMode:=pmTrip1;
        SetPulseOutputControls;
        end;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.AlarmWindowTripRadioButtonClick(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.AlarmOutputMode:=amTrip2;
     SetAlarmOutputControls;
     SetInhibitInputItems(false);

     if (fDeviceType=dt1003) and
        ((fModuleFreqDataRec.PulseOutputMode=pmTrip1) or
         (fModuleFreqDataRec.PulseOutputMode=pmTrip2)) then
        begin
        fModuleFreqDataRec.PulseOutputMode:=pmOff;
        SetPulseOutputControls;
        end;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.InvertedAlarmCheckBoxClick(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.AlarmInverter:=InvertedAlarmCheckBox.Checked;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.Trip1_OnAlarm_Threshold_EditChange(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     if (fDeviceType=dtx532) or (fModuleFreqDataRec.AlarmOutputMode=amTrip2) then
        fModuleFreqDataRec.Threshold1:=Trip1_OnAlarm_Threshold_Edit.Value
     else fModuleFreqDataRec.Threshold2:=Trip1_OnAlarm_Threshold_Edit.Value;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.Trip1_OnAlarm_Threshold_EditRangeValidationError(Sender: TObject);
begin
  Trip1_OnAlarm_Threshold_Edit.SetValueToValidRange;
end;

procedure TfmModuleData_32.Hysteresis1_OnAlarm_EditChange(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     if (fDeviceType=dtx532) or (fModuleFreqDataRec.AlarmOutputMode=amTrip2) then
        fModuleFreqDataRec.Hysteresis1:=Hysteresis1_OnAlarm_Edit.Value
     else fModuleFreqDataRec.Hysteresis2:=Hysteresis1_OnAlarm_Edit.Value;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.Hysteresis1_OnAlarm_EditRangeValidationError(Sender: TObject);
begin
  Hysteresis1_OnAlarm_Edit.SetValueToValidRange;
end;

procedure TfmModuleData_32.Trip2_OnAlarm_Threshold_EditChange(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.Threshold2:=Trip2_OnAlarm_Threshold_Edit.Value;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.Trip2_OnAlarm_Threshold_EditRangeValidationError(Sender: TObject);
begin
  Trip2_OnAlarm_Threshold_Edit.SetValueToValidRange;
end;

procedure TfmModuleData_32.Hysteresis2_OnAlarm_EditChange(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModuleFreqDataRec.Hysteresis2:=Hysteresis2_OnAlarm_Edit.Value;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_32.Hysteresis2_OnAlarm_EditRangeValidationError(Sender: TObject);
begin
  Hysteresis2_OnAlarm_Edit.SetValueToValidRange;
end;

end.
