unit ModuleData_76;

interface

uses Windows, Buttons, Grids, StdCtrls, Controls, ExtCtrls, ComCtrls, Classes, Gauges,
     Forms, Graphics, Dialogs, EditControls, GroupControls, DataTypes,
     HartDataTypes, HartModules;

type
  TModule2ChDataRec = record
    InputType,
    UserSensorType : TTempInputType;
    InputOption    : Tx576InputOptionSet;
    TypeNumber1,
    TypeNumber2    : word;
    ColdJunction1,
    ColdJunction2  : Tx576CJCSet;
    CJCUserValue1,
    CJCUserValue2  : real;
    WiringNumber1,
    WiringNumber2  : word;
    Linearisation1,
    Linearisation2 : TOnOffSet;
    PVUnits1,
    PVUnits2       : word;

    Point4mA1,
    Point4mA2      : real;
    Point20mA1,
    Point20mA2     : real;
    FilterFrequencySetting : TFilterFrequency;

    DampingTimeConstant1,
    DampingTimeConstant2   : real;
    SmoothingTimeConstant1,
    SmoothingTimeConstant2 : single;

    NamurOption1,
    NamurOption2           : TNamurOptionSet;
    ResponseSpeed          : TResponseSpeed;

    TransmitterFailureAlarmLevel1,
    TransmitterFailureAlarmLevel2  : TAlarmLevelSet;
    ColdJunctionFailureAlarmLevel1,
    ColdJunctionFailureAlarmLevel2 : TAlarmLevelSet;
    OpenCircuitAlarmLevel1,
    OpenCircuitAlarmLevel2         : TAlarmLevelSet;
    ShortCircuitAlarmLevel1,
    ShortCircuitAlarmLevel2        : TAlarmLevelSet;

    EBDSetting1, EBDSetting2       : TOnOffSet;
    end;

  TUnitEnableArray = array [0..4] of boolean;

  TfmModuleData_76 = class(TForm)
    PageControl1: TPageControl;
    InputTabSheet: TTabSheet;
    InputTypeSelector: TMyRadioGroup;
    InputOptionBox: TGroupBox;
    InputOptionSelector: TComboBox;
    FrequencySelector: TMyRadioGroup;

    InputGroupBox1: TGroupBox;
    InputNumberSelector1: TMyRadioGroup;
    CJCSelector1: TMyRadioGroup;
    CJCPanel1: TPanel;
    CJC_Edit1: TLabelRealEdit;
    RTDWiringSelector1: TMyRadioGroup;
    LinearisationSelector1: TMyRadioGroup;
    ProcessUnitSelector1: TMyRadioGroup;
    SignalRangeBox1: TGroupBox;
    Point4mA_Edit1: TLabelRealEdit;
    Point20mA_Edit1: TLabelRealEdit;

    InputGroupBox2: TGroupBox;
    InputNumberSelector2: TMyRadioGroup;
    CJCSelector2: TMyRadioGroup;
    CJCPanel2: TPanel;
    CJC_Edit2: TLabelRealEdit;
    RTDWiringSelector2: TMyRadioGroup;
    LinearisationSelector2: TMyRadioGroup;
    ProcessUnitSelector2: TMyRadioGroup;
    SignalRangeBox2: TGroupBox;
    Point4mA_Edit2: TLabelRealEdit;
    Point20mA_Edit2: TLabelRealEdit;

    OutputTabSheet: TTabSheet;
    OutputGroupBox1: TGroupBox;
    OutputGroupBox2: TGroupBox;
    OutputFilteringBox1: TGroupBox;
    DampingConstant_Edit1: TLabelRealEdit;
    SmoothingConstant_Edit1: TLabelIntegerEdit;
    OutputModeBox1: TGroupBox;
    NE43OnButton1: TRadioButton;
    NE43OffButton1: TRadioButton;
    ResponseTimeSelector: TMyRadioGroup;
    OutputFilteringBox2: TGroupBox;
    DampingConstant_Edit2: TLabelRealEdit;
    SmoothingConstant_Edit2: TLabelIntegerEdit;
    OutputModeBox2: TGroupBox;
    NE43OnButton2: TRadioButton;
    NE43OffButton2: TRadioButton;

    AlarmTabSheet: TTabSheet;
    AlarmLevelBox1: TGroupBox;
    AlarmLevelBox2: TGroupBox;
    TX_Alarm_Selector1: TMyRadioGroup;
    OC_Alarm_Selector1: TMyRadioGroup;
    CJC_Alarm_Selector1: TMyRadioGroup;
    SC_Alarm_Selector1: TMyRadioGroup;
    EBDSelector1: TMyRadioGroup;
    TX_Alarm_Selector2: TMyRadioGroup;
    OC_Alarm_Selector2: TMyRadioGroup;
    CJC_Alarm_Selector2: TMyRadioGroup;
    SC_Alarm_Selector2: TMyRadioGroup;
    EBDSelector2: TMyRadioGroup;

    UserSensorTabSheet: TTabSheet;
    DeviceUserSensorBox: TGroupBox;
    DeviceUserSensorHeaderBox: TGroupBox;
    DeviceUserInputTypeDisplay: TLabelDisplay;
    DeviceTempMinDisplay: TLabelDisplay;
    DeviceTempMaxDisplay: TLabelDisplay;
    DeviceCoeffTableStringGrid: TStringGrid;
    LoadFromDeviceButton: TButton;

    FileUserSensorBox: TGroupBox;
    FileUserSensorHeaderBox: TGroupBox;
    FileUserInputTypeDisplay: TLabelDisplay;
    FileTempMinDisplay: TLabelDisplay;
    FileTempMaxDisplay: TLabelDisplay;
    FileCoeffTableStringGrid: TStringGrid;
    LoadFromFileButton: TButton;
    SaveToDeviceButton: TButton;

    CommGauge: TGauge;
    OK_Button: TBitBtn;
    Close_Button: TBitBtn;

    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure PageControl1DrawTab(Control: TCustomTabControl; TabIndex: Integer;
      const Rect: TRect; Active: Boolean);

    procedure InputTypeSelectorClick(Sender: TObject);
    procedure InputOptionSelectorChange(Sender: TObject);
    procedure InputNumberSelector1Click(Sender: TObject);
    procedure InputNumberSelector2Click(Sender: TObject);

    procedure CJCSelector1Click(Sender: TObject);
    procedure CJCSelector2Click(Sender: TObject);
    procedure CJC_Edit1Exit(Sender: TObject);
    procedure CJC_Edit1RangeValidationError(Sender: TObject);
    procedure CJC_Edit2Exit(Sender: TObject);
    procedure CJC_Edit2RangeValidationError(Sender: TObject);

    procedure RTDWiringSelector1Click(Sender: TObject);
    procedure RTDWiringSelector2Click(Sender: TObject);

    procedure LinearisationSelector1Click(Sender: TObject);
    procedure LinearisationSelector2Click(Sender: TObject);

    procedure ProcessUnitSelector1Click(Sender: TObject);
    procedure ProcessUnitSelector2Click(Sender: TObject);

    procedure Point4mA_Edit1Change(Sender: TObject);
    procedure Point4mA_Edit1RangeValidationError(Sender: TObject);
    procedure Point4mA_Edit2Change(Sender: TObject);
    procedure Point4mA_Edit2RangeValidationError(Sender: TObject);
    procedure Point20mA_Edit1Change(Sender: TObject);
    procedure Point20mA_Edit1RangeValidationError(Sender: TObject);
    procedure Point20mA_Edit2Change(Sender: TObject);
    procedure Point20mA_Edit2RangeValidationError(Sender: TObject);

    procedure FrequencySelectorClick(Sender: TObject);

    procedure DampingConstant_Edit1Change(Sender: TObject);
    procedure DampingConstant_Edit1RangeValidationError(Sender: TObject);
    procedure SmoothingConstant_Edit1Change(Sender: TObject);
    procedure SmoothingConstant_Edit1RangeValidationError(Sender: TObject);
    procedure DampingConstant_Edit2Change(Sender: TObject);
    procedure DampingConstant_Edit2RangeValidationError(Sender: TObject);
    procedure SmoothingConstant_Edit2Change(Sender: TObject);
    procedure SmoothingConstant_Edit2RangeValidationError(Sender: TObject);

    procedure NE43OnButton1Click(Sender: TObject);
    procedure NE43OffButton1Click(Sender: TObject);
    procedure NE43OnButton2Click(Sender: TObject);
    procedure NE43OffButton2Click(Sender: TObject);
    procedure ResponseTimeSelectorClick(Sender: TObject);

    procedure TX_Alarm_Selector1Click(Sender: TObject);
    procedure TX_Alarm_Selector2Click(Sender: TObject);
    procedure OC_Alarm_Selector1Click(Sender: TObject);
    procedure OC_Alarm_Selector2Click(Sender: TObject);
    procedure CJC_Alarm_Selector1Click(Sender: TObject);
    procedure CJC_Alarm_Selector2Click(Sender: TObject);
    procedure SC_Alarm_Selector1Click(Sender: TObject);
    procedure SC_Alarm_Selector2Click(Sender: TObject);

    procedure EBDSelector1Click(Sender: TObject);
    procedure EBDSelector2Click(Sender: TObject);

    procedure LoadFromFileButtonClick(Sender: TObject);
    procedure LoadFromDeviceButtonClick(Sender: TObject);
    procedure SaveToDeviceButtonClick(Sender: TObject);
  private
    { Private declarations }
    fDialogMode: TDialogMode;
    fSaveMode: TSaveMode;
    pHartModule: PBasicHartModule;
    fDeviceType: TDeviceType;
    fModule2ChDataRec: TModule2ChDataRec;
    fDeviceUserSensorData,
    fFileUserSensorData: THUserSensorData_x576;
    fUserSensorLimits: TRealLimits;
    fSignalSpan1,
    fSignalSpan2: real; // in mV or Ohm
    fProtectedPath,
    fUnusualLinConfirmed,
    fUnusualCJCConfirmed: boolean;

    procedure EncodeModuleData;
    procedure DecodeModuleData;

    procedure SetInputTypeSelectorLabels;
    procedure SetInputTypeItem;
    procedure SetInputOptionLabels;
    procedure SetInputOptionItems;
    procedure SetInputOptionSpecificControls;
    procedure SetInputTypeSpecificInputNumberSelectorLabels1;
    procedure SetInputTypeSpecificInputNumberSelectorLabels2;
    procedure SetInputNumberSelectorItem1;
    procedure SetInputNumberSelectorItem2;
    procedure SetCJCSelectorLabels1;
    procedure SetCJCSelectorLabels2;
    {procedure SetCJCEditLimits1;
    procedure SetCJCEditValue1;
    procedure SetCJCEditLimits2;
    procedure SetCJCEditValue2;}
    procedure SetRTDWiringSelectorLabels1;
    procedure SetRTDWiringSelectorLabels2;
    procedure SetCJCorRTDWiringSelectorItems1(DisableUnused: boolean);
    procedure SetCJCorRTDWiringSelectorItems2(DisableUnused: boolean);

    procedure SetLinearisationSelectorLabels1;
    procedure SetLinearisationSelectorLabels2;
    procedure SetLinearisationSelectorItems1(DisableUnused: boolean);
    procedure SetLinearisationSelectorItems2(DisableUnused: boolean);

    procedure SetInputTypeSpecificProcessUnitSelectorLabels1;
    procedure SetInputTypeSpecificProcessUnitSelectorLabels2;
    procedure SetInputTypeSpecificLastProcessUnitSelectorLabel1;
    procedure SetInputTypeSpecificLastProcessUnitSelectorLabel2;
    procedure SetInputTypeSpecificProcessUnitSelectorItem1;
    procedure SetInputTypeSpecificProcessUnitSelectorItem2;

    procedure SetSignalRangeEditLabels1;
    procedure SetSignalRangeEditLabels2;
    procedure SetSignalRangeEditLimits1;
    procedure SetSignalRangeEditLimits2;
    procedure SetSignalRangeEditValues1;
    procedure SetSignalRangeEditValues2;
    procedure UpdateSignalRangeEditValues1(LSignal, USignal: real);
    procedure UpdateSignalRangeEditValues2(LSignal, USignal: real);
    procedure SetSignalRangeEditUnits1;
    procedure SetSignalRangeEditUnits2;

    procedure SetFilterFrequencyLabels;
    procedure SetFilterFrequencySelectorItems;

    procedure SetOutputFilteringEditLabels1;
    procedure SetOutputFilteringEditLabels2;
    procedure SetOutputFilteringEditLimits1;
    procedure SetOutputFilteringEditLimits2;
    procedure SetOutputFilteringEditValues1;
    procedure SetOutputFilteringEditValues2;

    procedure SetOutputLimitationSelectorLabels1;
    procedure SetOutputLimitationSelectorLabels2;
    procedure SetOutputLimitationSelectorItems1;
    procedure SetOutputLimitationSelectorItems2;
    procedure SetResponseTimeSelectorLabels;
    procedure SetResponseTimeSelectorItems;

    procedure SetAlarmLevelSelectorLabels1;
    procedure SetAlarmLevelSelectorLabels2;

    procedure SetTransmitterFailureAlarmLevelSelectorItems1;
    procedure SetTransmitterFailureAlarmLevelSelectorItems2;
    procedure SetColdJunctionFailureAlarmLevelItems1(DisableUnused: boolean);
    procedure SetColdJunctionFailureAlarmLevelItems2(DisableUnused: boolean);
    procedure SetOpenCircuitAlarmLevelItems1;
    procedure SetOpenCircuitAlarmLevelItems2;
    procedure SetShortCircuitAlarmLevelItems1(DisableUnused: boolean);
    procedure SetShortCircuitAlarmLevelItems2(DisableUnused: boolean);
    procedure SetAlarmLevelSelectorItems1;
    procedure SetAlarmLevelSelectorItems2;

    procedure SetEBDSelectorLabels1;
    procedure SetEBDSelectorLabels2;
    procedure SetEBDSelectorItems1(DisableUnused: boolean);
    procedure SetEBDSelectorItems2(DisableUnused: boolean);

    procedure SetDeviceUserSensorLabels;
    procedure SetFileUserSensorLabels;
    procedure SetDeviceUserSensorHeaderData;
    procedure SetFileUserSensorHeaderData;
    procedure SetDeviceUserSensorTableData;
    procedure SetFileUserSensorTableData;

    procedure SetAllLabels;
    procedure SetRangeErrorMessages;
    procedure ArrangeDisplayModeLook;
    procedure ArrangeConfigurationModeLook;
    procedure SetAllDisplayValues;
    procedure IndicateReceivedChar;
    procedure UpdateAcceptButton;
  public
    { Public declarations }
    procedure AssignHartModule(Value: PBasicHartModule);
    procedure SetMode(DMode: TDialogMode; SMode: TSaveMode);
  end;

var
  fmModuleData_76: TfmModuleData_76;

implementation

{$R *.dfm}

uses SysUtils, ArraysAndGrids, StringUtils, ProcessUtils, TempUtils, DataInstances, DataConstants,
     LabelNumbers, HelpContextNumbers, ConversionProcs, ImportExportProcs, MTL4575Sources;

function GetInputLimits(InputType: TTempInputType; TypeNumber: word; Linearisation: TOnOffSet; PVUnits: word): TRealLimits;
var lInputLimits: TRealLimits;
begin
  case InputType of
       itTHC: case TypeNumber of
                   0: lInputLimits:=C_Lim_B;
                   1: lInputLimits:=C_Lim_E;
                   2: lInputLimits:=C_Lim_J;
                   3: lInputLimits:=C_Lim_K;
                   4: lInputLimits:=C_Lim_N;
                   5: lInputLimits:=C_Lim_R75; // or C_Lim_R ?
                   6: lInputLimits:=C_Lim_S75; // or C_Lim_S ?
                   7: lInputLimits:=C_Lim_T;
                   8: lInputLimits:=C_Lim_XK;
                   9: lInputLimits:=fmModuleData_76.fUserSensorLimits;
                   10: lInputLimits:=C_Lim_mV;
                   end;
       itRTD: case TypeNumber of
                   0: if Linearisation=tsOn then
                         lInputLimits:=C_Lim_Pt
                      else lInputLimits:=C_Lim_RLin;
                   1: lInputLimits:=C_Lim_Pt;
                   2: lInputLimits:=C_Lim_Pt1T;
                   3,4,5: lInputLimits:=C_Lim_Ni;
                   6: lInputLimits:=C_Lim_Cu50;
                   7: lInputLimits:=C_Lim_Cu53;
                   8: lInputLimits:=fmModuleData_76.fUserSensorLimits;
                   9: lInputLimits:=C_Lim_RLin;
                   end;
       end;

  case PVUnits of
       1: begin             // Fahrenheit
          lInputLimits.LLim:=CelsiusToFahrenheit(lInputLimits.LLim);
          lInputLimits.ULim:=CelsiusToFahrenheit(lInputLimits.ULim);
          end;
       2: begin             // Rankine
          lInputLimits.LLim:=CelsiusToRankine(lInputLimits.LLim);
          lInputLimits.ULim:=CelsiusToRankine(lInputLimits.ULim);
          end;
       3: begin             // Kelvin
          lInputLimits.LLim:=CelsiusToKelvin(lInputLimits.LLim);
          lInputLimits.ULim:=CelsiusToKelvin(lInputLimits.ULim);
          end;
       4: begin             // mV
          // InputLimits.LLim:=InputLimits.LLim;               // ???
          // InputLimits.ULim:=InputLimits.ULim;
          end;
       5: begin             // Ohm
          // InputLimits.LLim:=InputLimits.LLim;               // ???
          // InputLimits.ULim:=InputLimits.ULim;
          end;
       end;
  Result:=lInputLimits;
end;

function GetSignalSpan (DT: TDeviceType; Source: TModule2ChDataRec; Channel: integer): real;
var lPoint4mA, lPoint20mA: real;
    xPoint4mA, xPoint20mA: real;
    xPVUnits, xTypeNumber: word;
    xLinearisation : TOnOffSet;
begin
  Result:=0.0; // default return value

  case Channel of
       1: begin
          xTypeNumber:=Source.TypeNumber1;
          xPoint4mA:=Source.Point4mA1;
          xPoint20mA:=Source.Point20mA1;
          xPVUnits:=Source.PVUnits1;
          xLinearisation:=Source.Linearisation1;
          end;
       2: begin
          xTypeNumber:=Source.TypeNumber2;
          xPoint4mA:=Source.Point4mA2;
          xPoint20mA:=Source.Point20mA2;
          xPVUnits:=Source.PVUnits2;
          xLinearisation:=Source.Linearisation2;
          end;
       else
          begin
          xTypeNumber:=0;
          xPoint4mA:=0.0;
          xPoint20mA:=0.0;
          xPVUnits:=0;
          xLinearisation:=tsOff;
          end;
      end;

  if (xPoint4mA<>xPoint20mA) then
     begin
     case xPVUnits of
          1: begin
             lPoint4mA:=FahrenheitToCelsius(xPoint4mA);
             lPoint20mA:=FahrenheitToCelsius(xPoint20mA);
             end;
          2: begin
             lPoint4mA:=RankineToCelsius(xPoint4mA);
             lPoint20mA:=RankineToCelsius(xPoint20mA);
             end;
          3: begin
             lPoint4mA:=KelvinToCelsius(xPoint4mA);
             lPoint20mA:=KelvinToCelsius(xPoint20mA);
             end;
          // 0: ; // PVUnits in Celsius
          // 4: ; // PVUnits in mV
          // 5: ; // PVUnits in Ohm
          else
             begin
             lPoint4mA:=xPoint4mA;
             lPoint20mA:=xPoint20mA;
             end;
          end;

     case Source.InputType of
          itTHC: begin
                 case xTypeNumber of
                      0: begin
                         lPoint4mA:=GetITS90THCVoltage(ttB,lPoint4mA);
                         lPoint20mA:=GetITS90THCVoltage(ttB,lPoint20mA);
                         end;
                      1: begin
                         lPoint4mA:=GetITS90THCVoltage(ttE,lPoint4mA);
                         lPoint20mA:=GetITS90THCVoltage(ttE,lPoint20mA);
                         end;
                      2: begin
                         lPoint4mA:=GetITS90THCVoltage(ttJ,lPoint4mA);
                         lPoint20mA:=GetITS90THCVoltage(ttJ,lPoint20mA);
                         end;
                      3: begin
                         lPoint4mA:=GetITS90THCVoltage(ttK,lPoint4mA);
                         lPoint20mA:=GetITS90THCVoltage(ttK,lPoint20mA);
                         end;
                      4: begin
                         lPoint4mA:=GetITS90THCVoltage(ttN,lPoint4mA);
                         lPoint20mA:=GetITS90THCVoltage(ttN,lPoint20mA);
                         end;
                      5: begin
                         lPoint4mA:=GetITS90THCVoltage(ttR,lPoint4mA);
                         lPoint20mA:=GetITS90THCVoltage(ttR,lPoint20mA);
                         end;
                      6: begin
                         lPoint4mA:=GetITS90THCVoltage(ttS,lPoint4mA);
                         lPoint20mA:=GetITS90THCVoltage(ttS,lPoint20mA);
                         end;
                      7: begin
                         lPoint4mA:=GetITS90THCVoltage(ttT,lPoint4mA);
                         lPoint20mA:=GetITS90THCVoltage(ttT,lPoint20mA);
                         end;
                      8: begin
                         // The formula for XK sensor calculation is based on the firmware sources for MTL4073XK
                         // The MTL4575 uses different approach with possibly minimally different results
                         lPoint4mA:=GetXKTHCVoltage(lPoint4mA);
                         lPoint20mA:=GetXKTHCVoltage(lPoint20mA);
                         end;
                      9: ; // mV - no calculation required
                      10:// User Sensor span cannot be evaluated and therefore correct configuration
                         // is completely in his responsibility -> force span > 3mV
                         begin
                         lPoint4mA:=0.0;
                         lPoint20mA:=3.5;
                         end;
                      else lPoint4mA:=lPoint20mA; // force Result to 0.0
                      end;
                 Result:=lPoint20mA-lPoint4mA;
                 end;
          itRTD: begin
                 case xTypeNumber of
                      0: begin
                         lPoint4mA:=GetRTDResistance(rtPlatin,100.0,lPoint4mA);
                         lPoint20mA:=GetRTDResistance(rtPlatin,100.0,lPoint20mA);
                         end;
                      1: begin
                         lPoint4mA:=GetRTDResistance(rtPlatin,500.0,lPoint4mA)/5.0;
                         lPoint20mA:=GetRTDResistance(rtPlatin,500.0,lPoint20mA)/5.0;
                         end;
                      2: begin
                         lPoint4mA:=GetRTDResistance(rtPlatin,1000.0,lPoint4mA)/10.0;
                         lPoint20mA:=GetRTDResistance(rtPlatin,1000.0,lPoint20mA)/10.0;
                         end;
                      3: begin
                         // The formula for Ni100 sensor is based on the firmware sources for MTL4075/4575 etc.
                         lPoint4mA:=T2OhmsNi100(lPoint4mA);
                         lPoint20mA:=T2OhmsNi100(lPoint20mA);
                         end;
                      4: begin // Ni500 sensor
                         // The span calculation for Ni500 sensor will be substituted with "5 * Ni100 / 5 = Ni100"
                         // The formula for Ni100 sensor is based on the firmware sources for MTL4075/4575 etc.
                         lPoint4mA:=T2OhmsNi100(lPoint4mA);
                         lPoint20mA:=T2OhmsNi100(lPoint20mA);
                         end;
                      5: begin // Ni1000 sensor
                         // The span calculation for Ni1000 sensor will be substituted with "10 * Ni100 / 10 = Ni100"
                         // The formula for Ni100 sensor is based on the firmware sources for MTL4075/4575 etc.
                         lPoint4mA:=T2OhmsNi100(lPoint4mA);
                         lPoint20mA:=T2OhmsNi100(lPoint20mA);
                         end;
                      6: begin
                         // The formula for Cu50 sensor is based on the firmware sources for MTL4075/4575 etc.
                         lPoint4mA:=T2OhmsCU50(lPoint4mA);
                         lPoint20mA:=T2OhmsCU50(lPoint20mA);
                         end;
                      7: begin
                         // The formula for Cu53 sensor is based on the firmware sources for MTL4075/4575 etc.
                         lPoint4mA:=T2OhmsCU53(lPoint4mA);
                         lPoint20mA:=T2OhmsCU53(lPoint20mA);
                         end;
                      8: // User Sensor span cannot be evaluated and therefore correct configuration
                         // is completely in his responsibility -> force span > 10 Ohm
                         begin
                         lPoint4mA:=0.0;
                         lPoint20mA:=15.0;
                         end;
                      9: // This input type is reserved for linear resistors only (without linearisation)
                         // In case of use this number zogether with linearisation, set the 4mA=20mA
                         // This will cause span = 0.0 and suggest to terminate the configuration
                         if not(xLinearisation=tsOff) then
                            lPoint4mA:=lPoint20mA;
                      // For unexpected input configurations set 4mA=20mA causing span 0.0
                      else lPoint4mA:=lPoint20mA;
                      end;
                 Result:=lPoint20mA-lPoint4mA;
                 end;
          end;
     end;
end;

procedure TfmModuleData_76.EncodeModuleData;
var lInputParameterArray_x576: THInputParameterArray_x576;
    lOutputParameterArray_x576: THOutputParameterArray_x576;
    lCommonParameters_x576: THCommonParameters_x576;
    lUserSensorHeader_x576: THUserSensorHeader_x576;
begin
  if (pHartModule<>nil) then
     begin
     lInputParameterArray_x576:=THartModule_x576(pHartModule^).InputParameters;
     lOutputParameterArray_x576:=THartModule_x576(pHartModule^).OutputParameters;
     lCommonParameters_x576:=THartModule_x576(pHartModule^).CommonParameters;
     lUserSensorHeader_x576:=THartModule_x576(pHartModule^).UserSensorHeader;

     fDeviceUserSensorData.SensorType:=lUserSensorHeader_x576.SensorType;
     fDeviceUserSensorData.TMIN:=lUserSensorHeader_x576.TMIN;
     fDeviceUserSensorData.TMAX:=lUserSensorHeader_x576.TMAX;
     fDeviceUserSensorData.TSEG:=lUserSensorHeader_x576.TSEG;
     fDeviceUserSensorData.reserved:=0;

     with fModule2ChDataRec do
          begin
          InputType:=InputTypeFromHART(fDeviceType,lInputParameterArray_x576[0].SensorType);

          UserSensorType:=UserSensorTypeFromHART(lUserSensorHeader_x576.SensorType);
          fUserSensorLimits.LLim:=lUserSensorHeader_x576.TMIN;
          fUserSensorLimits.ULim:=lUserSensorHeader_x576.TMAX;

          InputOption:=InputOptionx576FromHART(lCommonParameters_x576.InputOption);

          TypeNumber1:=TypeNumberFromHART(fDeviceType,lInputParameterArray_x576[0].SensorType);
          TypeNumber2:=TypeNumberFromHART(fDeviceType,lInputParameterArray_x576[1].SensorType);
          ColdJunction1:=CJCompx576FromHART(lInputParameterArray_x576[0].CJC_Option);
          CJCUserValue1:=lInputParameterArray_x576[0].CJC_UserValue;
          ColdJunction2:=CJCompx576FromHART(lInputParameterArray_x576[1].CJC_Option);
          CJCUserValue2:=lInputParameterArray_x576[1].CJC_UserValue;
          WiringNumber1:=WiringNumberFromHART(fDeviceType,lInputParameterArray_x576[0].SensorType);
          WiringNumber2:=WiringNumberFromHART(fDeviceType,lInputParameterArray_x576[1].SensorType);
          Linearisation1:=LinearFromHART(lInputParameterArray_x576[0].Linearisation);
          Linearisation2:=LinearFromHART(lInputParameterArray_x576[1].Linearisation);

          PVUnits1:=PVUnitsFromHART(lInputParameterArray_x576[0].PVUnits);
          Point4mA1:=lInputParameterArray_x576[0].Point4mA;
          Point20mA1:=lInputParameterArray_x576[0].Point20mA;

          PVUnits2:=PVUnitsFromHART(lInputParameterArray_x576[1].PVUnits);
          Point4mA2:=lInputParameterArray_x576[1].Point4mA;
          Point20mA2:=lInputParameterArray_x576[1].Point20mA;

          FilterFrequencySetting:=FrequencyFromHART(lCommonParameters_x576.FilterFrequencySelector);

          DampingTimeConstant1:=lOutputParameterArray_x576[0].DampingTimeConstant;
          SmoothingTimeConstant1:=lOutputParameterArray_x576[0].SmoothingTimeConstant;

          DampingTimeConstant2:=lOutputParameterArray_x576[1].DampingTimeConstant;
          SmoothingTimeConstant2:=lOutputParameterArray_x576[1].SmoothingTimeConstant;

          TransmitterFailureAlarmLevel1:=AlarmLevelFromHART(lOutputParameterArray_x576[0].TransmitterFailureAlarmLevel);
          ColdJunctionFailureAlarmLevel1:=AlarmLevelFromHART(lOutputParameterArray_x576[0].ColdJunctionFailureAlarmLevel);
          OpenCircuitAlarmLevel1:=AlarmLevelFromHART(lOutputParameterArray_x576[0].OpenCircuitAlarmLevel);
          ShortCircuitAlarmLevel1:=AlarmLevelFromHART(lOutputParameterArray_x576[0].ShortCircuitAlarmLevel);

          TransmitterFailureAlarmLevel2:=AlarmLevelFromHART(lOutputParameterArray_x576[1].TransmitterFailureAlarmLevel);
          ColdJunctionFailureAlarmLevel2:=AlarmLevelFromHART(lOutputParameterArray_x576[1].ColdJunctionFailureAlarmLevel);
          OpenCircuitAlarmLevel2:=AlarmLevelFromHART(lOutputParameterArray_x576[1].OpenCircuitAlarmLevel);
          ShortCircuitAlarmLevel2:=AlarmLevelFromHART(lOutputParameterArray_x576[1].ShortCircuitAlarmLevel);

          EBDSetting1:=x576EBDOptionFromHART(lOutputParameterArray_x576[0].EBD_Option);
          EBDSetting2:=x576EBDOptionFromHART(lOutputParameterArray_x576[1].EBD_Option);

          NamurOption1:=x576NAMURFromHART(lOutputParameterArray_x576[0].NAMUR_MTL);
          NamurOption2:=x576NAMURFromHART(lOutputParameterArray_x576[1].NAMUR_MTL);

          ResponseSpeed:=x575SpeedFromHART(lCommonParameters_x576.response_time);


          end;
     end;
end;

procedure TfmModuleData_76.DecodeModuleData;
var lInputParameterArray_x576: THInputParameterArray_x576;
    lOutputParameterArray_x576: THOutputParameterArray_x576;
    lCommonParameters_x576: THCommonParameters_x576;
begin
  if (pHartModule<>nil) then
     begin
     lInputParameterArray_x576[0].Channel:=0;
     lInputParameterArray_x576[1].Channel:=1;

     lOutputParameterArray_x576[0].Channel:=0;
     lOutputParameterArray_x576[1].Channel:=1;

     lCommonParameters_x576.InputOption:=InputOptionx576ToHART(fModule2ChDataRec.InputOption);

     lInputParameterArray_x576[0].SensorType:=InputTypeAndNumberAndWiringToHART(fDeviceType,fModule2ChDataRec.InputType,fModule2ChDataRec.TypeNumber1,fModule2ChDataRec.WiringNumber1);
     lInputParameterArray_x576[1].SensorType:=InputTypeAndNumberAndWiringToHART(fDeviceType,fModule2ChDataRec.InputType,fModule2ChDataRec.TypeNumber2,fModule2ChDataRec.WiringNumber2);

     lInputParameterArray_x576[0].CJC_Option:=CJCompx576ToHART(fModule2ChDataRec.ColdJunction1);
     lInputParameterArray_x576[1].CJC_Option:=CJCompx576ToHART(fModule2ChDataRec.ColdJunction2);

     lInputParameterArray_x576[0].CJC_UserValue:=fModule2ChDataRec.CJCUserValue1;
     lInputParameterArray_x576[1].CJC_UserValue:=fModule2ChDataRec.CJCUserValue2;

     lOutputParameterArray_x576[0].OpenCircuitAlarmLevel:=AlarmLevelToHART(fModule2ChDataRec.OpenCircuitAlarmLevel1);
     lOutputParameterArray_x576[1].OpenCircuitAlarmLevel:=AlarmLevelToHART(fModule2ChDataRec.OpenCircuitAlarmLevel2);

     lOutputParameterArray_x576[0].TransmitterFailureAlarmLevel:=AlarmLevelToHART(fModule2ChDataRec.TransmitterFailureAlarmLevel1);
     lOutputParameterArray_x576[1].TransmitterFailureAlarmLevel:=AlarmLevelToHART(fModule2ChDataRec.TransmitterFailureAlarmLevel2);

     lCommonParameters_x576.FilterFrequencySelector:=FrequencyToHART(fModule2ChDataRec.FilterFrequencySetting);

     lOutputParameterArray_x576[0].DampingTimeConstant:=fModule2ChDataRec.DampingTimeConstant1;
     lOutputParameterArray_x576[0].SmoothingTimeConstant:=fModule2ChDataRec.SmoothingTimeConstant1;
     lOutputParameterArray_x576[1].DampingTimeConstant:=fModule2ChDataRec.DampingTimeConstant2;
     lOutputParameterArray_x576[1].SmoothingTimeConstant:=fModule2ChDataRec.SmoothingTimeConstant2;

     lOutputParameterArray_x576[0].ColdJunctionFailureAlarmLevel:=AlarmLevelToHART(fModule2ChDataRec.ColdJunctionFailureAlarmLevel1);
     lOutputParameterArray_x576[1].ColdJunctionFailureAlarmLevel:=AlarmLevelToHART(fModule2ChDataRec.ColdJunctionFailureAlarmLevel2);

     lInputParameterArray_x576[0].Linearisation:=LinearToHART(fModule2ChDataRec.Linearisation1);
     lInputParameterArray_x576[1].Linearisation:=LinearToHART(fModule2ChDataRec.Linearisation2);

     lInputParameterArray_x576[0].PVUnits:=PVUnitsToHART(fModule2ChDataRec.PVUnits1);
     lInputParameterArray_x576[0].Point4mA:=fModule2ChDataRec.Point4mA1;
     lInputParameterArray_x576[0].Point20mA:=fModule2ChDataRec.Point20mA1;

     lInputParameterArray_x576[1].PVUnits:=PVUnitsToHART(fModule2ChDataRec.PVUnits2);
     lInputParameterArray_x576[1].Point4mA:=fModule2ChDataRec.Point4mA2;
     lInputParameterArray_x576[1].Point20mA:=fModule2ChDataRec.Point20mA2;

     lOutputParameterArray_x576[0].EBD_Option:=x576EBDOptionToHART(fModule2ChDataRec.EBDSetting1);
     lOutputParameterArray_x576[0].TripLimit:=THartModule_x576(pHartModule^).OutputParameters[0].TripLimit;
     lOutputParameterArray_x576[0].TripHysteresis:=THartModule_x576(pHartModule^).OutputParameters[0].TripHysteresis;
     lOutputParameterArray_x576[1].EBD_Option:=x576EBDOptionToHART(fModule2ChDataRec.EBDSetting2);
     lOutputParameterArray_x576[1].TripLimit:=THartModule_x576(pHartModule^).OutputParameters[1].TripLimit;
     lOutputParameterArray_x576[1].TripHysteresis:=THartModule_x576(pHartModule^).OutputParameters[1].TripHysteresis;

     lOutputParameterArray_x576[0].NAMUR_MTL:=x576NAMURToHART(fModule2ChDataRec.NamurOption1);
     lOutputParameterArray_x576[1].NAMUR_MTL:=x576NAMURToHART(fModule2ChDataRec.NamurOption2);

     lCommonParameters_x576.response_time:=x575SpeedToHART(fModule2ChDataRec.ResponseSpeed);

     lOutputParameterArray_x576[0].ShortCircuitAlarmLevel:=AlarmLevelToHART(fModule2ChDataRec.ShortCircuitAlarmLevel1);
     lOutputParameterArray_x576[1].ShortCircuitAlarmLevel:=AlarmLevelToHART(fModule2ChDataRec.ShortCircuitAlarmLevel2);

     THartModule_x576(pHartModule^).InputParameters:=lInputParameterArray_x576;
     THartModule_x576(pHartModule^).OutputParameters:=lOutputParameterArray_x576;
     THartModule_x576(pHartModule^).CommonParameters:=lCommonParameters_x576;

     fSignalSpan1:=GetSignalSpan(fDeviceType,fModule2ChDataRec,1);
     fSignalSpan2:=GetSignalSpan(fDeviceType,fModule2ChDataRec,2);
     end;
end;

procedure TfmModuleData_76.SetAllLabels;
begin
  // Self.Caption will be set later according to the fDialogMode

  InputTabSheet.Caption:=LanguageStrings[flInputTab];
  InputGroupBox1.Caption:=LanguageStrings[flChannel]+' '+IntToStr(1)+' ';
  InputGroupBox2.Caption:=LanguageStrings[flChannel]+' '+IntToStr(2)+' ';

  SetInputTypeSelectorLabels;
  SetInputOptionLabels;
  // InputNumber are input type specific
  SetCJCSelectorLabels1;
  SetCJCSelectorLabels2;
  SetRTDWiringSelectorLabels1;
  SetRTDWiringSelectorLabels2;

  SetLinearisationSelectorLabels1;
  SetLinearisationSelectorLabels2;
  // Process Units are Input Type specific

  SetSignalRangeEditLabels1;
  SetSignalRangeEditLabels2;

  SetFilterFrequencyLabels;

  OutputTabSheet.Caption:=LanguageStrings[flOutputTab];
  OutputGroupBox1.Caption:=LanguageStrings[flChannel]+' '+IntToStr(1)+' ';
  OutputGroupBox2.Caption:=LanguageStrings[flChannel]+' '+IntToStr(2)+' ';

  SetOutputFilteringEditLabels1;
  SetOutputFilteringEditLabels2;
  SetOutputFilteringEditLimits1;
  SetOutputFilteringEditLimits2;


  SetOutputLimitationSelectorLabels1;
  SetOutputLimitationSelectorLabels2;
  SetResponseTimeSelectorLabels;

  AlarmTabSheet.Caption:=LanguageStrings[flAlarmsTab];
  AlarmLevelBox1.Caption:=LanguageStrings[flChannel]+' '+IntToStr(1)+' ';
  AlarmLevelBox2.Caption:=LanguageStrings[flChannel]+' '+IntToStr(2)+' ';

  SetAlarmLevelSelectorLabels1;
  SetAlarmLevelSelectorLabels2;
  SetEBDSelectorLabels1;
  SetEBDSelectorLabels2;

  UserSensorTabSheet.Caption:=LanguageStrings[flUserSensor];
  SetDeviceUserSensorLabels;
  SetFileUserSensorLabels;

  OK_Button.Caption:=LanguageStrings[blSetting];
  Close_Button.Caption:=LanguageStrings[blClose];
end;

procedure TfmModuleData_76.SetRangeErrorMessages;
begin
  CJC_Edit1.RangeErrorMessage:=LanguageStrings[msFieldBetween];
  CJC_Edit2.RangeErrorMessage:=LanguageStrings[msFieldBetween];

  Point4mA_Edit1.RangeErrorMessage:=LanguageStrings[msFieldBetween];
  Point20mA_Edit1.RangeErrorMessage:=LanguageStrings[msFieldBetween];

  Point4mA_Edit2.RangeErrorMessage:=LanguageStrings[msFieldBetween];
  Point20mA_Edit2.RangeErrorMessage:=LanguageStrings[msFieldBetween];

  DampingConstant_Edit1.RangeErrorMessage:=LanguageStrings[msFieldBetween];
  SmoothingConstant_Edit1.RangeErrorMessage:=LanguageStrings[msFieldBetween];

  DampingConstant_Edit2.RangeErrorMessage:=LanguageStrings[msFieldBetween];
  SmoothingConstant_Edit2.RangeErrorMessage:=LanguageStrings[msFieldBetween];
end;

procedure TfmModuleData_76.ArrangeDisplayModeLook;
begin
  Caption:=' '+LanguageStrings[flDisplayModule];
  HelpContext:=hcDisplayModule_x576;

  // Input Configuration Tab Sheet

  InputOptionSelector.Color:=clSilver;

  SignalRangeBox1.Enabled:=false;
  Point4mA_Edit1.EditColor:=clSilver;
  Point20mA_Edit1.EditColor:=clSilver;

  SignalRangeBox2.Enabled:=false;
  Point4mA_Edit2.EditColor:=clSilver;
  Point20mA_Edit2.EditColor:=clSilver;

  OutputFilteringBox1.Enabled:=false;
  DampingConstant_Edit1.EditColor:=clSilver;
  SmoothingConstant_Edit1.EditColor:=clSilver;

  OutputFilteringBox2.Enabled:=false;
  DampingConstant_Edit2.EditColor:=clSilver;
  SmoothingConstant_Edit2.EditColor:=clSilver;

  LoadFromFileButton.Enabled:=false;
  LoadFromDeviceButton.Enabled:=false;
  SaveToDeviceButton.Enabled:=false;

  CommGauge.Visible:=false;
  OK_Button.Visible:=false;

  Close_Button.Top:=PageControl1.Top+PageControl1.Height+20;
  Close_Button.Left:=CommGauge.Left+(CommGauge.Width-Close_Button.Width) DIV 2;

  Self.Height:=Close_Button.Top+80;
end;

procedure TfmModuleData_76.ArrangeConfigurationModeLook;
var lButtonGap: integer;
begin
  Caption:=' '+LanguageStrings[flConfigModule];

  HelpContext:=hcConfigureModule_x576;

  SaveToDeviceButton.Enabled:=false;

  SetRangeErrorMessages;

  CommGauge.Visible:=true;
  CommGauge.Top:=PageControl1.Top+PageControl1.Height+20;

  OK_Button.Top:=CommGauge.Top+CommGauge.Height+20;
  Close_Button.Top:=OK_Button.Top;

  lButtonGap:=(CommGauge.Width-OK_Button.Width-Close_Button.Width) DIV 3;
  OK_Button.Left:=CommGauge.Left+lButtonGap;
  Close_Button.Left:=CommGauge.Left+OK_Button.Width+2*lButtonGap;

  Self.Height:=Close_Button.Top+80;
end;

procedure TfmModuleData_76.SetAllDisplayValues;
begin
  // Input Configuration Tab Sheet

  fProtectedPath:=true;

  SetInputTypeItem;
  SetInputOptionItems;

  SetInputNumberSelectorItem1;
  SetInputNumberSelectorItem2;

  // Disable unused CJC Buttons if mV (evaluated here as THC without Linearisation)
  SetCJCorRTDWiringSelectorItems1((fModule2ChDataRec.InputType=itTHC) and (fModule2ChDataRec.Linearisation1=tsOff));
  SetCJCorRTDWiringSelectorItems2((fModule2ChDataRec.InputType=itTHC) and (fModule2ChDataRec.Linearisation2=tsOff));

  SetLinearisationSelectorItems1(true);
  SetLinearisationSelectorItems2(true);

  SetInputTypeSpecificProcessUnitSelectorItem1;
  SetInputTypeSpecificProcessUnitSelectorItem2;

  if fDialogMode=dmConfig then
     begin
     if (fModule2ChDataRec.PVUnits1<4) and (fModule2ChDataRec.Linearisation1=tsOn) then
        ProcessUnitSelector1.SetButtonEnableArray(GetDynArray(CNonLinUnits))
     else if not(fModule2ChDataRec.PVUnits1<4) and (fModule2ChDataRec.Linearisation1=tsOff) then
             ProcessUnitSelector1.SetButtonEnableArray(GetDynArray(CLinUnits));
     if (fModule2ChDataRec.PVUnits2<4) and (fModule2ChDataRec.Linearisation2=tsOn) then
        ProcessUnitSelector2.SetButtonEnableArray(GetDynArray(CNonLinUnits))
     else if not(fModule2ChDataRec.PVUnits2<4) and (fModule2ChDataRec.Linearisation1=tsOff) then
             ProcessUnitSelector2.SetButtonEnableArray(GetDynArray(CLinUnits));
     end;

  SetSignalRangeEditValues1;
  SetSignalRangeEditValues2;

  SetSignalRangeEditUnits1;
  SetSignalRangeEditUnits2;

  SetFilterFrequencySelectorItems;

  // Output Configuration Tab Sheet

  SetOutputFilteringEditValues1;
  SetOutputFilteringEditValues2;

  SetOutputLimitationSelectorItems1;
  SetOutputLimitationSelectorItems2;

  SetResponseTimeSelectorItems;

  // Alarm Configuration Tab Sheet

  SetAlarmLevelSelectorItems1;
  SetAlarmLevelSelectorItems2;

  if (fDialogMode=dmConfig) and
     (fModule2ChDataRec.InputType=itTHC) then
     begin
     SC_Alarm_Selector1.DisableNotCheckedButtons;
     SC_Alarm_Selector2.DisableNotCheckedButtons;
     end
  else
     begin
     CJC_Alarm_Selector1.DisableNotCheckedButtons;
     CJC_Alarm_Selector2.DisableNotCheckedButtons;
     end;

  SetEBDSelectorItems1(false);
  SetEBDSelectorItems2(false);

  if (fDialogMode=dmConfig) and
     (fModule2ChDataRec.InputType=itRTD) then
     begin
     //
     end;

  SetDeviceUserSensorHeaderData;

  fProtectedPath:=false;
end;

procedure TfmModuleData_76.IndicateReceivedChar;
begin
  if CommGauge.Progress < CommGauge.MaxValue then
     begin
     CommGauge.AddProgress(1);
     WaitMilliseconds(10);
     end
  else WaitMilliseconds(100);
end;

procedure TfmModuleData_76.UpdateAcceptButton;
begin
  if pHartModule<>nil then
     OK_Button.Enabled:=not(pHartModule^.VerifyDeviceData);
end;

//****************************************************************************//

procedure TfmModuleData_76.AssignHartModule(Value: PBasicHartModule);
begin
  pHartModule:=Value;
  if (pHartModule<>nil) then
     pHartModule^.AssignReceivedCharEvent(IndicateReceivedChar);
end;

procedure TfmModuleData_76.SetMode(DMode: TDialogMode; SMode: TSaveMode);
begin
  fDialogMode:=DMode; fSaveMode:=SMode;
end;

procedure TfmModuleData_76.SetInputTypeSelectorLabels;
begin
  InputTypeSelector.Caption:=LanguageStrings[flInputType];
  InputTypeSelector.Items.Clear;
  InputTypeSelector.Items.Add(LanguageStrings[flTHC]);
  InputTypeSelector.Items.Add(LanguageStrings[flRTD]);
end;

procedure TfmModuleData_76.SetInputTypeItem;
begin
  case fModule2ChDataRec.InputType  of
       itTHC: InputTypeSelector.ItemIndex:=0;
       itRTD: InputTypeSelector.ItemIndex:=1;
       else InputTypeSelector.ItemIndex:=-1;
       end;
  if fDialogMode=dmDisplay then InputTypeSelector.DisableNotCheckedButtons;
end;

procedure TfmModuleData_76.SetInputOptionLabels;
begin
  InputOptionSelector.Items.Clear;
  InputOptionSelector.Items.Add(LanguageStrings[fl2in2out]);
  InputOptionSelector.Items.Add(LanguageStrings[fl1in2out]);
end;

procedure TfmModuleData_76.SetInputOptionItems;
begin
  if (fModule2ChDataRec.InputOption=is1In2Out) then
     InputOptionSelector.ItemIndex:=1
  else InputOptionSelector.ItemIndex:=0;
  if fDialogMode=dmDisplay then InputOptionBox.Enabled:=false;
end;

procedure TfmModuleData_76.SetInputOptionSpecificControls;
begin
  InputGroupBox2.Visible:=(fModule2ChDataRec.InputOption=is2In2Out);
  OutputGroupBox2.Visible:=(fModule2ChDataRec.InputOption=is2In2Out);
  AlarmLevelBox2.Visible:=(fModule2ChDataRec.InputOption=is2In2Out);

  if (fModule2ChDataRec.InputOption=is2In2Out) then
     begin
     OutputGroupBox1.Caption:=LanguageStrings[flChannel]+' '+IntToStr(1)+' ';
     AlarmLevelBox1.Caption:=LanguageStrings[flChannel]+' '+IntToStr(1)+' ';
     end
  else // fModule2ChDataRec.InputOption=is1In2Out
     begin
     OutputGroupBox1.Caption:=LanguageStrings[flChannel]+' '+IntToStr(1)+' + '+IntToStr(2)+' ';
     AlarmLevelBox1.Caption:=LanguageStrings[flChannel]+' '+IntToStr(1)+' + '+IntToStr(2)+' ';
     end;
end;

procedure TfmModuleData_76.SetInputTypeSpecificInputNumberSelectorLabels1;
var I: integer;
begin
  InputNumberSelector1.Items.Clear;
  if fModule2ChDataRec.InputType=itTHC then
     begin
     InputNumberSelector1.Caption:=LanguageStrings[flTHCtypes];

     for I:=0 to 5 do InputNumberSelector1.Items.Add(LanguageStrings[flTHC_B+I]);
     InputNumberSelector1.Items.Add(LanguageStrings[flTHC_B+6]);
     InputNumberSelector1.Items.Add(LanguageStrings[flTHC_T]);
     InputNumberSelector1.Items.Add(LanguageStrings[flTHC_XK]);
     InputNumberSelector1.Items.Add(LanguageStrings[flUser]);

     InputNumberSelector1.Items.Add(LanguageStrings[flmV]);
     end
  else // fModule2ChDataRec.InputType=itRTD
     begin
     InputNumberSelector1.Caption:=LanguageStrings[flRTDtypes];

     InputNumberSelector1.Items.Add(LanguageStrings[flPt100]);
     InputNumberSelector1.Items.Add(LanguageStrings[flPt500]);
     InputNumberSelector1.Items.Add(LanguageStrings[flPt1000]);
     InputNumberSelector1.Items.Add(LanguageStrings[flNi100]);
     InputNumberSelector1.Items.Add(LanguageStrings[flNi500]);
     InputNumberSelector1.Items.Add(LanguageStrings[flNi1000]);
     InputNumberSelector1.Items.Add(LanguageStrings[flCu50]);
     InputNumberSelector1.Items.Add(LanguageStrings[flCu53]);
     InputNumberSelector1.Items.Add(LanguageStrings[flUser]);

     InputNumberSelector1.Items.Add(LanguageStrings[flResistor]);
     end;
end;

procedure TfmModuleData_76.SetInputTypeSpecificInputNumberSelectorLabels2;
var I: integer;
begin
  InputNumberSelector2.Items.Clear;
  if fModule2ChDataRec.InputType=itTHC then
     begin
     InputNumberSelector2.Caption:=LanguageStrings[flTHCtypes];

     for I:=0 to 5 do InputNumberSelector2.Items.Add(LanguageStrings[flTHC_B+I]);
     InputNumberSelector2.Items.Add(LanguageStrings[flTHC_B+6]);
     InputNumberSelector2.Items.Add(LanguageStrings[flTHC_T]);
     InputNumberSelector2.Items.Add(LanguageStrings[flTHC_XK]);
     InputNumberSelector2.Items.Add(LanguageStrings[flUser]);

     InputNumberSelector2.Items.Add(LanguageStrings[flmV]);
     end
  else // fModule2ChDataRec.InputType=itRTD
     begin
     InputNumberSelector2.Caption:=LanguageStrings[flRTDtypes];

     InputNumberSelector2.Items.Add(LanguageStrings[flPt100]);
     InputNumberSelector2.Items.Add(LanguageStrings[flPt500]);
     InputNumberSelector2.Items.Add(LanguageStrings[flPt1000]);
     InputNumberSelector2.Items.Add(LanguageStrings[flNi100]);
     InputNumberSelector2.Items.Add(LanguageStrings[flNi500]);
     InputNumberSelector2.Items.Add(LanguageStrings[flNi1000]);
     InputNumberSelector2.Items.Add(LanguageStrings[flCu50]);
     InputNumberSelector2.Items.Add(LanguageStrings[flCu53]);
     InputNumberSelector2.Items.Add(LanguageStrings[flUser]);

     InputNumberSelector2.Items.Add(LanguageStrings[flResistor]);
     end;
end;

procedure TfmModuleData_76.SetInputNumberSelectorItem1;
begin
  // detect resistor selection - Pt100 with linearisation off
  InputNumberSelector1.EnableAllButtons;
  if ((fModule2ChDataRec.InputType=itRTD) and (fModule2ChDataRec.TypeNumber1=0) and (fModule2ChDataRec.Linearisation1=tsOff)) then
     InputNumberSelector1.ItemIndex:=InputNumberSelector1.Items.Count-1
  else // not resistor selection
     begin
     if fModule2ChDataRec.TypeNumber1<InputNumberSelector1.Items.Count then
        InputNumberSelector1.ItemIndex:=fModule2ChDataRec.TypeNumber1
     else InputNumberSelector1.ItemIndex:=0;
     end;
  case fModule2ChDataRec.InputType of
       itTHC: InputNumberSelector1.ButtonEnable[9]:=true; // (fModule2ChDataRec.UserSensorType=itTHC);
       itRTD: InputNumberSelector1.ButtonEnable[8]:=true; // (fModule2ChDataRec.UserSensorType=itRTD);
       end;
  if fDialogMode=dmDisplay then InputNumberSelector1.DisableNotCheckedButtons;
end;

procedure TfmModuleData_76.SetInputNumberSelectorItem2;
begin
  // detect resistor selection - Pt100 with linearisation off
  InputNumberSelector2.EnableAllButtons;
  if ((fModule2ChDataRec.InputType=itRTD) and (fModule2ChDataRec.TypeNumber2=0) and (fModule2ChDataRec.Linearisation2=tsOff)) then
     InputNumberSelector2.ItemIndex:=InputNumberSelector2.Items.Count-1
  else // not resistor selection
     begin
     if fModule2ChDataRec.TypeNumber1<InputNumberSelector2.Items.Count then
        InputNumberSelector2.ItemIndex:=fModule2ChDataRec.TypeNumber2
     else InputNumberSelector2.ItemIndex:=0;
     end;
  case fModule2ChDataRec.InputType of
       itTHC: InputNumberSelector2.ButtonEnable[9]:=true; // (fModule2ChDataRec.UserSensorType=itTHC);
       itRTD: InputNumberSelector2.ButtonEnable[8]:=true; // (fModule2ChDataRec.UserSensorType=itRTD);
       end;
  if fDialogMode=dmDisplay then InputNumberSelector2.DisableNotCheckedButtons;
end;

procedure TfmModuleData_76.SetCJCSelectorLabels1;
begin
  CJCSelector1.Caption:=LanguageStrings[flColdJnCompensation];

  CJCSelector1.Items.Clear;
  CJCSelector1.Items.Add(LanguageStrings[flOn]);
  CJCSelector1.Items.Add(LanguageStrings[flOff]);
  CJCSelector1.Items.Add(LanguageStrings[flUser]);

  CJC_Edit1.LabelCaption:=LanguageStrings[flCJCValue];
  CJC_Edit1.UnitText:=LanguageStrings[flCelsius];
end;

procedure TfmModuleData_76.SetCJCSelectorLabels2;
begin
  CJCSelector2.Caption:=LanguageStrings[flColdJnCompensation];

  CJCSelector2.Items.Clear;
  CJCSelector2.Items.Add(LanguageStrings[flOn]);
  CJCSelector2.Items.Add(LanguageStrings[flOff]);
  CJCSelector2.Items.Add(LanguageStrings[flUser]);

  CJC_Edit2.LabelCaption:=LanguageStrings[flCJCValue];
  CJC_Edit2.UnitText:=LanguageStrings[flCelsius];
end;

{procedure TfmModuleData_76.SetCJCEditLimits1;
begin
  with CJC_Edit1 do
       begin
       Min:=C_Lim_CJC.LLim;
       Max:=C_Lim_CJC.ULim;
       end;
end;

procedure TfmModuleData_76.SetCJCEditValue1;
begin
  CJC_Edit1.Value:=fModule2ChDataRec.CJCUserValue1;
end;

procedure TfmModuleData_76.SetCJCEditLimits2;
begin
  with CJC_Edit2 do
       begin
       Min:=C_Lim_CJC.LLim;
       Max:=C_Lim_CJC.ULim;
       end;
end;

procedure TfmModuleData_76.SetCJCEditValue2;
begin
  CJC_Edit2.Value:=fModule2ChDataRec.CJCUserValue2;
end;}

procedure TfmModuleData_76.SetRTDWiringSelectorLabels1;
begin
  RTDWiringSelector1.Caption:=LanguageStrings[flWiring];

  RTDWiringSelector1.Items.Clear;
  RTDWiringSelector1.Items.Add(LanguageStrings[fl2Wire]);
  RTDWiringSelector1.Items.Add(LanguageStrings[fl3Wire]);
  RTDWiringSelector1.Items.Add(LanguageStrings[fl4Wire]);
end;

procedure TfmModuleData_76.SetRTDWiringSelectorLabels2;
begin
  RTDWiringSelector2.Caption:=LanguageStrings[flWiring];

  RTDWiringSelector2.Items.Clear;
  RTDWiringSelector2.Items.Add(LanguageStrings[fl2Wire]);
  RTDWiringSelector2.Items.Add(LanguageStrings[fl3Wire]);
  RTDWiringSelector2.Items.Add(LanguageStrings[fl4Wire]);
end;

procedure TfmModuleData_76.SetCJCorRTDWiringSelectorItems1(DisableUnused: boolean);
begin
  if fModule2ChDataRec.InputType=itTHC then
     begin
     CJCSelector1.Visible:=true;
     CJCPanel1.Visible:=true;
     RTDWiringSelector1.Visible:=false;
     CJCSelector1.EnableAllButtons;
     CJC_Edit1.Enabled:=true;
     CJC_Edit1.EditColor:=clWindow;
     CJCSelector1.ItemIndex:=integer(fModule2ChDataRec.ColdJunction1);
     if fModule2ChDataRec.ColdJunction1 in [csOn..csOff] then
        begin
        CJC_Edit1.Enabled:=false;
        CJC_Edit1.EditColor:=clSilver;
        CJC_Edit1.EditFont.Color:=clSilver;
        end
     else // fModule2ChDataRec.ColdJunction1=csUser
        begin
        CJC_Edit1.EditFont.Color:=Self.Font.Color;
        CJC_Edit1.Value:=fModule2ChDataRec.CJCUserValue1;
        end;

     if (fDialogMode=dmDisplay) or DisableUnused then
        CJCSelector1.DisableNotCheckedButtons;
     if (fDialogMode=dmDisplay) then
        begin
        CJCPanel1.Enabled:=false;
        CJC_Edit1.EditColor:=clSilver;
        end;
     end
  else // fModule2ChDataRec.InputType=itRTD
     begin
     CJCSelector1.Visible:=false;
     CJCPanel1.Visible:=false;
     RTDWiringSelector1.Visible:=true;
     RTDWiringSelector1.EnableAllButtons;
     if fModule2ChDataRec.WiringNumber1 in [0..3] then
        RTDWiringSelector1.ItemIndex:=fModule2ChDataRec.WiringNumber1
     else RTDWiringSelector1.ItemIndex:=0;
     if fDialogMode=dmDisplay then RTDWiringSelector1.DisableNotCheckedButtons;
     end;
end;

procedure TfmModuleData_76.SetCJCorRTDWiringSelectorItems2(DisableUnused: boolean);
begin
    if fModule2ChDataRec.InputType=itTHC then
     begin
     CJCSelector2.Visible:=true;
     CJCPanel2.Visible:=true;
     RTDWiringSelector2.Visible:=false;
     CJCSelector2.EnableAllButtons;
     CJC_Edit2.Enabled:=true;
     CJC_Edit2.EditColor:=clWindow;
     CJCSelector2.ItemIndex:=integer(fModule2ChDataRec.ColdJunction2);
     if fModule2ChDataRec.ColdJunction2 in [csOn..csOff] then
        begin
        CJC_Edit2.Enabled:=false;
        CJC_Edit2.EditColor:=clSilver;
        CJC_Edit2.EditFont.Color:=clSilver;
        end
     else // fModule2ChDataRec.ColdJunction2=csUser
        begin
        CJC_Edit2.EditFont.Color:=Self.Font.Color;
        CJC_Edit2.Value:=fModule2ChDataRec.CJCUserValue1;
        end;

     if (fDialogMode=dmDisplay) or DisableUnused then
        CJCSelector2.DisableNotCheckedButtons;
     if (fDialogMode=dmDisplay) then
        begin
        CJCPanel2.Enabled:=false;
        CJC_Edit2.EditColor:=clSilver;
        end;
     end
  else // fModule2ChDataRec.InputType=itRTD
     begin
     CJCSelector2.Visible:=false;
     CJCPanel2.Visible:=false;
     RTDWiringSelector2.Visible:=true;
     RTDWiringSelector2.EnableAllButtons;
     if fModule2ChDataRec.WiringNumber2 in [0..3] then
        RTDWiringSelector2.ItemIndex:=fModule2ChDataRec.WiringNumber2
     else RTDWiringSelector2.ItemIndex:=0;
     if fDialogMode=dmDisplay then RTDWiringSelector2.DisableNotCheckedButtons;
     end;
end;

procedure TfmModuleData_76.SetLinearisationSelectorLabels1;
begin
  LinearisationSelector1.Caption:=LanguageStrings[flLinearisation];

  LinearisationSelector1.Items.Clear;
  LinearisationSelector1.Items.Add(LanguageStrings[flOn]);
  LinearisationSelector1.Items.Add(LanguageStrings[flOff]);
end;

procedure TfmModuleData_76.SetLinearisationSelectorLabels2;
begin
  LinearisationSelector2.Caption:=LanguageStrings[flLinearisation];

  LinearisationSelector2.Items.Clear;
  LinearisationSelector2.Items.Add(LanguageStrings[flOn]);
  LinearisationSelector2.Items.Add(LanguageStrings[flOff]);
end;

procedure TfmModuleData_76.SetLinearisationSelectorItems1(DisableUnused: boolean);
begin
  LinearisationSelector1.EnableAllButtons;
  if fModule2ChDataRec.Linearisation1 in [tsOn..tsOff] then
     LinearisationSelector1.ItemIndex:=integer(fModule2ChDataRec.Linearisation1)
  else LinearisationSelector1.ItemIndex:=1;
  if (fDialogMode=dmDisplay) or DisableUnused then LinearisationSelector1.DisableNotCheckedButtons;
end;

procedure TfmModuleData_76.SetLinearisationSelectorItems2(DisableUnused: boolean);
begin
  LinearisationSelector2.EnableAllButtons;
  if fModule2ChDataRec.Linearisation2 in [tsOn..tsOff] then
     LinearisationSelector2.ItemIndex:=integer(fModule2ChDataRec.Linearisation2)
  else LinearisationSelector2.ItemIndex:=1;
  if (fDialogMode=dmDisplay) or DisableUnused then LinearisationSelector2.DisableNotCheckedButtons;
end;



procedure TfmModuleData_76.SetInputTypeSpecificProcessUnitSelectorLabels1;
var I: integer;
begin
  ProcessUnitSelector1.Caption:=LanguageStrings[flProcessUnits];

  ProcessUnitSelector1.Items.Clear;
  for I:=0 to 3 do ProcessUnitSelector1.Items.Add(LanguageStrings[flCelsius+I]);
  if fModule2ChDataRec.InputType=itTHC then
     ProcessUnitSelector1.Items.Add(LanguageStrings[flCelsius+4])     // mV
  else ProcessUnitSelector1.Items.Add(LanguageStrings[flCelsius+5]);  // Ohm
end;

procedure TfmModuleData_76.SetInputTypeSpecificProcessUnitSelectorLabels2;
var I: integer;
begin
  ProcessUnitSelector2.Caption:=LanguageStrings[flProcessUnits];

  ProcessUnitSelector2.Items.Clear;
  for I:=0 to 3 do ProcessUnitSelector2.Items.Add(LanguageStrings[flCelsius+I]);
  if fModule2ChDataRec.InputType=itTHC then
     ProcessUnitSelector2.Items.Add(LanguageStrings[flCelsius+4])     // mV
  else ProcessUnitSelector2.Items.Add(LanguageStrings[flCelsius+5]);  // Ohm
end;

procedure TfmModuleData_76.SetInputTypeSpecificLastProcessUnitSelectorLabel1;
begin
  if (fModule2ChDataRec.InputType=itTHC) then
     ProcessUnitSelector1.Items.Strings[4]:=LanguageStrings[flCelsius+4]    //mV
  else ProcessUnitSelector1.Items.Strings[4]:=LanguageStrings[flCelsius+5]; // Ohm
end;

procedure TfmModuleData_76.SetInputTypeSpecificLastProcessUnitSelectorLabel2;
begin
  if (fModule2ChDataRec.InputType=itTHC) then
     ProcessUnitSelector2.Items.Strings[4]:=LanguageStrings[flCelsius+4]    //mV
  else ProcessUnitSelector2.Items.Strings[4]:=LanguageStrings[flCelsius+5]; // Ohm
end;

procedure TfmModuleData_76.SetInputTypeSpecificProcessUnitSelectorItem1;
begin
  ProcessUnitSelector1.EnableAllButtons;
  if (fModule2ChDataRec.PVUnits1 in [0..3]) or ((fModule2ChDataRec.PVUnits1=4) and(fModule2ChDataRec.InputType=itTHC)) then
     ProcessUnitSelector1.ItemIndex:=fModule2ChDataRec.PVUnits1
  else
     if (fModule2ChDataRec.PVUnits1=5) and (fModule2ChDataRec.InputType=itRTD) then
        ProcessUnitSelector1.ItemIndex:=4
     else ProcessUnitSelector1.ItemIndex:=0; // default units = C, however be careful here !!!
  if fDialogMode=dmDisplay then ProcessUnitSelector1.DisableNotCheckedButtons;
end;

procedure TfmModuleData_76.SetInputTypeSpecificProcessUnitSelectorItem2;
begin
  ProcessUnitSelector2.EnableAllButtons;
  if (fModule2ChDataRec.PVUnits2 in [0..3]) or ((fModule2ChDataRec.PVUnits2=4) and(fModule2ChDataRec.InputType=itTHC)) then
     ProcessUnitSelector2.ItemIndex:=fModule2ChDataRec.PVUnits2
  else
     if (fModule2ChDataRec.PVUnits2=5) and (fModule2ChDataRec.InputType=itRTD) then
        ProcessUnitSelector2.ItemIndex:=4
     else ProcessUnitSelector2.ItemIndex:=0; // default units = C, however be careful here !!!
  if fDialogMode=dmDisplay then ProcessUnitSelector2.DisableNotCheckedButtons;
end;

procedure TfmModuleData_76.SetSignalRangeEditLabels1;
begin
  SignalRangeBox1.Caption:=LanguageStrings[flSignalRange];
  Point4mA_Edit1.LabelCaption:=LanguageStrings[fl4mAPoint];
  Point20mA_Edit1.LabelCaption:=LanguageStrings[fl20mAPoint];
end;

procedure TfmModuleData_76.SetSignalRangeEditLabels2;
begin
  SignalRangeBox2.Caption:=LanguageStrings[flSignalRange];
  Point4mA_Edit2.LabelCaption:=LanguageStrings[fl4mAPoint];
  Point20mA_Edit2.LabelCaption:=LanguageStrings[fl20mAPoint];
end;

procedure TfmModuleData_76.SetSignalRangeEditLimits1;
var lLimits: TRealLimits;
begin
  lLimits:=GetInputLimits(fModule2ChDataRec.InputType, fModule2ChDataRec.TypeNumber1, fModule2ChDataRec.Linearisation1, fModule2ChDataRec.PVUnits1);

  with Point4mA_Edit1 do
       begin
       Min:=lLimits.LLim;
       Max:=lLimits.Ulim;
       end;
  with Point20mA_Edit1 do
       begin
       Min:=lLimits.LLim;
       Max:=lLimits.Ulim;
       end;
end;

procedure TfmModuleData_76.SetSignalRangeEditLimits2;
var lLimits: TRealLimits;
begin
  lLimits:=GetInputLimits(fModule2ChDataRec.InputType, fModule2ChDataRec.TypeNumber2, fModule2ChDataRec.Linearisation2, fModule2ChDataRec.PVUnits2);

  with Point4mA_Edit2 do
       begin
       Min:=lLimits.LLim;
       Max:=lLimits.Ulim;
       end;
  with Point20mA_Edit2 do
       begin
       Min:=lLimits.LLim;
       Max:=lLimits.Ulim;
       end;
end;

procedure  TfmModuleData_76.SetSignalRangeEditValues1;
begin
  Point4mA_Edit1.Value:=fModule2ChDataRec.Point4mA1;
  Point20mA_Edit1.Value:=fModule2ChDataRec.Point20mA1;
end;

procedure  TfmModuleData_76.SetSignalRangeEditValues2;
begin
  Point4mA_Edit2.Value:=fModule2ChDataRec.Point4mA2;
  Point20mA_Edit2.Value:=fModule2ChDataRec.Point20mA2;
end;

procedure TfmModuleData_76.UpdateSignalRangeEditValues1(LSignal, USignal: real);
begin
  fModule2ChDataRec.Point4mA1:=LSignal;
  fModule2ChDataRec.Point20mA1:=USignal;
  SetSignalRangeEditValues1;
end;

procedure TfmModuleData_76.UpdateSignalRangeEditValues2(LSignal, USignal: real);
begin
  fModule2ChDataRec.Point4mA2:=LSignal;
  fModule2ChDataRec.Point20mA2:=USignal;
  SetSignalRangeEditValues2;
end;

procedure TfmModuleData_76.SetSignalRangeEditUnits1;
begin
  Point4mA_Edit1.UnitText:=LanguageStrings[flCelsius+fModule2ChDataRec.PVUnits1];
  Point20mA_Edit1.UnitText:=LanguageStrings[flCelsius+fModule2ChDataRec.PVUnits1];
end;

procedure TfmModuleData_76.SetSignalRangeEditUnits2;
begin
  Point4mA_Edit2.UnitText:=LanguageStrings[flCelsius+fModule2ChDataRec.PVUnits2];
  Point20mA_Edit2.UnitText:=LanguageStrings[flCelsius+fModule2ChDataRec.PVUnits2];
end;

procedure TfmModuleData_76.SetFilterFrequencyLabels;
begin
  FrequencySelector.Caption:=LanguageStrings[flFilterFreq];

  FrequencySelector.Items.Clear;
  FrequencySelector.Items.Add(LanguageStrings[fl50Hz]);
  FrequencySelector.Items.Add(LanguageStrings[fl60Hz]);
end;

procedure TfmModuleData_76.SetFilterFrequencySelectorItems;
begin
  if fModule2ChDataRec.FilterFrequencySetting in [tf50..tf60] then
     FrequencySelector.ItemIndex:=integer(fModule2ChDataRec.FilterFrequencySetting)
  else FrequencySelector.ItemIndex:=0;
  if fDialogMode=dmDisplay then FrequencySelector.DisableNotCheckedButtons;
end;

procedure TfmModuleData_76.SetOutputFilteringEditLabels1;
begin
  OutputFilteringBox1.Caption:=LanguageStrings[flOutputFiltering];

  DampingConstant_Edit1.LabelCaption:=LanguageStrings[flDampingConst];
  SmoothingConstant_Edit1.LabelCaption:=LanguageStrings[flSmoothingConst];
end;

procedure TfmModuleData_76.SetOutputFilteringEditLabels2;
begin
  OutputFilteringBox2.Caption:=LanguageStrings[flOutputFiltering];

  DampingConstant_Edit2.LabelCaption:=LanguageStrings[flDampingConst];
  SmoothingConstant_Edit2.LabelCaption:=LanguageStrings[flSmoothingConst];
end;

procedure TfmModuleData_76.SetOutputFilteringEditLimits1;
begin
  with DampingConstant_Edit1 do
       begin
       Min:=C_Lim_Damp.LLim;
       Max:=C_Lim_Damp.Ulim;
       end;
  with SmoothingConstant_Edit1 do
       begin
       Min:=C_Lim_Smoo.LLim;
       Max:=C_Lim_Smoo.Ulim;
       end;
end;

procedure TfmModuleData_76.SetOutputFilteringEditLimits2;
begin
  with DampingConstant_Edit2 do
       begin
       Min:=C_Lim_Damp.LLim;
       Max:=C_Lim_Damp.Ulim;
       end;
  with SmoothingConstant_Edit2 do
       begin
       Min:=C_Lim_Smoo.LLim;
       Max:=C_Lim_Smoo.Ulim;
       end;
end;

procedure TfmModuleData_76.SetOutputFilteringEditValues1;
begin
  DampingConstant_Edit1.Value:=fModule2ChDataRec.DampingTimeConstant1;
  SmoothingConstant_Edit1.Value:=System.Round(fModule2ChDataRec.SmoothingTimeConstant1);
end;

procedure TfmModuleData_76.SetOutputFilteringEditValues2;
begin
  DampingConstant_Edit2.Value:=fModule2ChDataRec.DampingTimeConstant2;
  SmoothingConstant_Edit2.Value:=System.Round(fModule2ChDataRec.SmoothingTimeConstant2);
end;

procedure TfmModuleData_76.SetOutputLimitationSelectorLabels1;
begin
  OutputModeBox1.Caption:=LanguageStrings[flOutputCharacteristic];

  NE43OnButton1.Caption:=LanguageStrings[flOutNE43];
  NE43OffButton1.Caption:=LanguageStrings[flOutMTL];
end;

procedure TfmModuleData_76.SetOutputLimitationSelectorLabels2;
begin
  OutputModeBox2.Caption:=LanguageStrings[flOutputCharacteristic];

  NE43OnButton2.Caption:=LanguageStrings[flOutNE43];
  NE43OffButton2.Caption:=LanguageStrings[flOutMTL];
end;

procedure TfmModuleData_76.SetOutputLimitationSelectorItems1;
begin
  case fModule2ChDataRec.NamurOption1 of
       nsOff: begin
              NE43OffButton1.Enabled:=true;
              NE43OffButton1.Checked:=true;
              if fDialogMode=dmDisplay then NE43OnButton1.Enabled:=false;
              end;
       nsOn:  begin
              NE43OnButton1.Enabled:=true;
              NE43OnButton1.Checked:=true;
              if fDialogMode=dmDisplay then NE43OffButton1.Enabled:=false;
              end;
       nsNotAvailable: begin
                       // consider which action is required here ?
                       end;
       end;
end;

procedure TfmModuleData_76.SetOutputLimitationSelectorItems2;
begin
  case fModule2ChDataRec.NamurOption2 of
       nsOff: begin
              NE43OffButton2.Enabled:=true;
              NE43OffButton2.Checked:=true;
              if fDialogMode=dmDisplay then NE43OnButton2.Enabled:=false;
              end;
       nsOn:  begin
              NE43OnButton2.Enabled:=true;
              NE43OnButton2.Checked:=true;
              if fDialogMode=dmDisplay then NE43OffButton2.Enabled:=false;
              end;
       nsNotAvailable: begin
                       // consider which action is required here ?
                       end;
       end;
end;

procedure TfmModuleData_76.SetResponseTimeSelectorLabels;
begin
  ResponseTimeSelector.Caption:=LanguageStrings[flResponseTime];

  ResponseTimeSelector.Items.Clear;
  ResponseTimeSelector.Items.Add(LanguageStrings[flSlow]);
  ResponseTimeSelector.Items.Add(LanguageStrings[flMedium]);
  ResponseTimeSelector.Items.Add(LanguageStrings[flFast]);
end;

procedure TfmModuleData_76.SetResponseTimeSelectorItems;
begin
  if fModule2ChDataRec.ResponseSpeed in [tsMiddle..tsFast] then
     ResponseTimeSelector.ItemIndex:=integer(fModule2ChDataRec.ResponseSpeed)
  else ResponseTimeSelector.ItemIndex:=0;
  if fDialogMode=dmDisplay then ResponseTimeSelector.DisableNotCheckedButtons;
end;

procedure TfmModuleData_76.SetAlarmLevelSelectorLabels1;
begin
  // AlarmLevelBox1.Caption:=LanguageStrings[flAlarmLevels];

  TX_Alarm_Selector1.Caption:=LanguageStrings[flAlarmTX];
  TX_Alarm_Selector1.Items.Clear;
  TX_Alarm_Selector1.Items.Add(LanguageStrings[flLowAlarm]);
  TX_Alarm_Selector1.Items.Add(LanguageStrings[flHighAlarm]);
  TX_Alarm_Selector1.Items.Add(LanguageStrings[flAlarmOff]);

  CJC_Alarm_Selector1.Caption:=LanguageStrings[flAlarmCJC];
  CJC_Alarm_Selector1.Items.Clear;
  CJC_Alarm_Selector1.Items.Add(LanguageStrings[flLowAlarm]);
  CJC_Alarm_Selector1.Items.Add(LanguageStrings[flHighAlarm]);
  CJC_Alarm_Selector1.Items.Add(LanguageStrings[flAlarmOff]);

  OC_Alarm_Selector1.Caption:=LanguageStrings[flAlarmOC];
  OC_Alarm_Selector1.Items.Clear;
  OC_Alarm_Selector1.Items.Add(LanguageStrings[flLowAlarm]);
  OC_Alarm_Selector1.Items.Add(LanguageStrings[flHighAlarm]);
  OC_Alarm_Selector1.Items.Add(LanguageStrings[flAlarmOff]);

  SC_Alarm_Selector1.Caption:=LanguageStrings[flAlarmSC];
  SC_Alarm_Selector1.Items.Clear;
  SC_Alarm_Selector1.Items.Add(LanguageStrings[flLowAlarm]);
  SC_Alarm_Selector1.Items.Add(LanguageStrings[flHighAlarm]);
  SC_Alarm_Selector1.Items.Add(LanguageStrings[flAlarmOff]);
end;

procedure TfmModuleData_76.SetAlarmLevelSelectorLabels2;
begin
  // AlarmLevelBox2.Caption:=LanguageStrings[flAlarmLevels];

  TX_Alarm_Selector2.Caption:=LanguageStrings[flAlarmTX];
  TX_Alarm_Selector2.Items.Clear;
  TX_Alarm_Selector2.Items.Add(LanguageStrings[flLowAlarm]);
  TX_Alarm_Selector2.Items.Add(LanguageStrings[flHighAlarm]);
  TX_Alarm_Selector2.Items.Add(LanguageStrings[flAlarmOff]);

  CJC_Alarm_Selector2.Caption:=LanguageStrings[flAlarmCJC];
  CJC_Alarm_Selector2.Items.Clear;
  CJC_Alarm_Selector2.Items.Add(LanguageStrings[flLowAlarm]);
  CJC_Alarm_Selector2.Items.Add(LanguageStrings[flHighAlarm]);
  CJC_Alarm_Selector2.Items.Add(LanguageStrings[flAlarmOff]);

  OC_Alarm_Selector2.Caption:=LanguageStrings[flAlarmOC];
  OC_Alarm_Selector2.Items.Clear;
  OC_Alarm_Selector2.Items.Add(LanguageStrings[flLowAlarm]);
  OC_Alarm_Selector2.Items.Add(LanguageStrings[flHighAlarm]);
  OC_Alarm_Selector2.Items.Add(LanguageStrings[flAlarmOff]);

  SC_Alarm_Selector2.Caption:=LanguageStrings[flAlarmSC];
  SC_Alarm_Selector2.Items.Clear;
  SC_Alarm_Selector2.Items.Add(LanguageStrings[flLowAlarm]);
  SC_Alarm_Selector2.Items.Add(LanguageStrings[flHighAlarm]);
  SC_Alarm_Selector2.Items.Add(LanguageStrings[flAlarmOff]);
end;

procedure TfmModuleData_76.SetTransmitterFailureAlarmLevelSelectorItems1;
begin
  TX_Alarm_Selector1.EnableAllButtons;
  if fModule2ChDataRec.TransmitterFailureAlarmLevel1 in [taLow..taHigh] then
     TX_Alarm_Selector1.ItemIndex:=integer(fModule2ChDataRec.TransmitterFailureAlarmLevel1)
  else TX_Alarm_Selector1.ItemIndex:=2;
  if fDialogMode=dmDisplay then TX_Alarm_Selector1.DisableNotCheckedButtons;
end;

procedure TfmModuleData_76.SetTransmitterFailureAlarmLevelSelectorItems2;
begin
  TX_Alarm_Selector2.EnableAllButtons;
  if fModule2ChDataRec.TransmitterFailureAlarmLevel2 in [taLow..taHigh] then
     TX_Alarm_Selector2.ItemIndex:=integer(fModule2ChDataRec.TransmitterFailureAlarmLevel2)
  else TX_Alarm_Selector2.ItemIndex:=2;
  if fDialogMode=dmDisplay then TX_Alarm_Selector2.DisableNotCheckedButtons;
end;

procedure TfmModuleData_76.SetColdJunctionFailureAlarmLevelItems1(DisableUnused: boolean);
begin
  CJC_Alarm_Selector1.EnableAllButtons;
  if fModule2ChDataRec.ColdJunctionFailureAlarmLevel1 in [taLow..taHigh] then
     CJC_Alarm_Selector1.ItemIndex:=integer(fModule2ChDataRec.ColdJunctionFailureAlarmLevel1)
  else CJC_Alarm_Selector1.ItemIndex:=2;
  if (fDialogMode=dmDisplay) or DisableUnused then CJC_Alarm_Selector1.DisableNotCheckedButtons;
end;

procedure TfmModuleData_76.SetColdJunctionFailureAlarmLevelItems2(DisableUnused: boolean);
begin
  CJC_Alarm_Selector2.EnableAllButtons;
  if fModule2ChDataRec.ColdJunctionFailureAlarmLevel2 in [taLow..taHigh] then
     CJC_Alarm_Selector2.ItemIndex:=integer(fModule2ChDataRec.ColdJunctionFailureAlarmLevel2)
  else CJC_Alarm_Selector2.ItemIndex:=2;
  if (fDialogMode=dmDisplay) or DisableUnused then CJC_Alarm_Selector2.DisableNotCheckedButtons;
end;

procedure TfmModuleData_76.SetOpenCircuitAlarmLevelItems1;
begin
  OC_Alarm_Selector1.EnableAllButtons;
  if fModule2ChDataRec.OpenCircuitAlarmLevel1 in [taLow..taHigh] then
     OC_Alarm_Selector1.ItemIndex:=integer(fModule2ChDataRec.OpenCircuitAlarmLevel1)
  else OC_Alarm_Selector1.ItemIndex:=2;
  if fDialogMode=dmDisplay then OC_Alarm_Selector1.DisableNotCheckedButtons;
end;

procedure TfmModuleData_76.SetOpenCircuitAlarmLevelItems2;
begin
  OC_Alarm_Selector2.EnableAllButtons;
  if fModule2ChDataRec.OpenCircuitAlarmLevel2 in [taLow..taHigh] then
     OC_Alarm_Selector2.ItemIndex:=integer(fModule2ChDataRec.OpenCircuitAlarmLevel2)
  else OC_Alarm_Selector2.ItemIndex:=2;
  if fDialogMode=dmDisplay then OC_Alarm_Selector2.DisableNotCheckedButtons;
end;

procedure TfmModuleData_76.SetShortCircuitAlarmLevelItems1(DisableUnused: boolean);
begin
  SC_Alarm_Selector1.EnableAllButtons;
  if fModule2ChDataRec.ShortCircuitAlarmLevel1 in [taLow..taHigh] then
     SC_Alarm_Selector1.ItemIndex:=integer(fModule2ChDataRec.ShortCircuitAlarmLevel1)
  else SC_Alarm_Selector1.ItemIndex:=2;
  if (fDialogMode=dmDisplay) or DisableUnused then SC_Alarm_Selector1.DisableNotCheckedButtons;
end;

procedure TfmModuleData_76.SetShortCircuitAlarmLevelItems2(DisableUnused: boolean);
begin
  SC_Alarm_Selector2.EnableAllButtons;
  if fModule2ChDataRec.ShortCircuitAlarmLevel2 in [taLow..taHigh] then
     SC_Alarm_Selector2.ItemIndex:=integer(fModule2ChDataRec.ShortCircuitAlarmLevel2)
  else SC_Alarm_Selector2.ItemIndex:=2;
  if (fDialogMode=dmDisplay) or DisableUnused then SC_Alarm_Selector2.DisableNotCheckedButtons;
end;

procedure TfmModuleData_76.SetAlarmLevelSelectorItems1;
begin
  SetTransmitterFailureAlarmLevelSelectorItems1;

  SetColdJunctionFailureAlarmLevelItems1(false);

  SetOpenCircuitAlarmLevelItems1;

  SetShortCircuitAlarmLevelItems1(false);
end;

procedure TfmModuleData_76.SetAlarmLevelSelectorItems2;
begin
  SetTransmitterFailureAlarmLevelSelectorItems2;

  SetColdJunctionFailureAlarmLevelItems2(false);

  SetOpenCircuitAlarmLevelItems2;

  SetShortCircuitAlarmLevelItems2(false);
end;

procedure TfmModuleData_76.SetEBDSelectorLabels1;
begin
  EBDSelector1.Caption:=LanguageStrings[flEBDdetection];

  EBDSelector1.Items.Clear;
  EBDSelector1.Items.Add(LanguageStrings[flOn]);
  EBDSelector1.Items.Add(LanguageStrings[flOff]);
end;

procedure TfmModuleData_76.SetEBDSelectorLabels2;
begin
  EBDSelector2.Caption:=LanguageStrings[flEBDdetection];

  EBDSelector2.Items.Clear;
  EBDSelector2.Items.Add(LanguageStrings[flOn]);
  EBDSelector2.Items.Add(LanguageStrings[flOff]);
end;

procedure TfmModuleData_76.SetEBDSelectorItems1(DisableUnused: boolean);
begin
  EBDSelector1.EnableAllButtons;
  if fModule2ChDataRec.EBDSetting1 in [tsOn..tsOff] then
     EBDSelector1.ItemIndex:=integer(fModule2ChDataRec.EBDSetting1)
  else EBDSelector1.ItemIndex:=1;
  if (fDialogMode=dmDisplay) or DisableUnused then EBDSelector1.DisableNotCheckedButtons;
end;

procedure TfmModuleData_76.SetEBDSelectorItems2(DisableUnused: boolean);
begin
  EBDSelector2.EnableAllButtons;
  if fModule2ChDataRec.EBDSetting2 in [tsOn..tsOff] then
     EBDSelector2.ItemIndex:=integer(fModule2ChDataRec.EBDSetting2)
  else EBDSelector2.ItemIndex:=1;
  if (fDialogMode=dmDisplay) or DisableUnused then EBDSelector2.DisableNotCheckedButtons;
end;

procedure TfmModuleData_76.SetDeviceUserSensorLabels;
var I: integer;
begin
  DeviceUserSensorBox.Caption:=LanguageStrings[flDeviceUserSensor];

  DeviceUserSensorHeaderBox.Caption:=LanguageStrings[flSensorHeader];

  DeviceUserInputTypeDisplay.LabelCaption:=LanguageStrings[flType];
  DeviceTempMinDisplay.LabelCaption:=LanguageStrings[flTmin];
  DeviceTempMinDisplay.UnitText:=LanguageStrings[flCelsius];
  DeviceTempMaxDisplay.LabelCaption:=LanguageStrings[flTmax];
  DeviceTempMaxDisplay.UnitText:=LanguageStrings[flCelsius];

  DeviceCoeffTableStringGrid.ColWidths[1]:=70;
  DeviceCoeffTableStringGrid.Color:=clSilver;
  DeviceCoeffTableStringGrid.Cells[0,0]:=' '+LanguageStrings[flNumber];
  DeviceCoeffTableStringGrid.Cells[1,0]:=' '+LanguageStrings[flCoefficients];
  for I:= 1 to 65 do
      DeviceCoeffTableStringGrid.Cells[0,I]:=' '+IntToStr(I);

  UnselectDelphiStringGridCell(DeviceCoeffTableStringGrid);

  LoadFromDeviceButton.Caption:=LanguageStrings[blLoadFromDevice];
end;

procedure TfmModuleData_76.SetFileUserSensorLabels;
var I: integer;
begin
  FileUserSensorBox.Caption:=LanguageStrings[flFileUserSensor];

  FileUserSensorHeaderBox.Caption:=LanguageStrings[flSensorHeader];

  FileUserInputTypeDisplay.LabelCaption:=LanguageStrings[flType];
  FileTempMinDisplay.LabelCaption:=LanguageStrings[flTmin];
  FileTempMinDisplay.UnitText:=LanguageStrings[flCelsius];
  FileTempMaxDisplay.LabelCaption:=LanguageStrings[flTmax];
  FileTempMaxDisplay.UnitText:=LanguageStrings[flCelsius];

  FileCoeffTableStringGrid.ColWidths[1]:=70;
  FileCoeffTableStringGrid.Color:=clSilver;
  FileCoeffTableStringGrid.Cells[0,0]:=' '+LanguageStrings[flNumber];
  FileCoeffTableStringGrid.Cells[1,0]:=' '+LanguageStrings[flCoefficients];
  for I:= 1 to 65 do
      FileCoeffTableStringGrid.Cells[0,I]:=' '+IntToStr(I);

  UnselectDelphiStringGridCell(FileCoeffTableStringGrid);

  LoadFromFileButton.Caption:=LanguageStrings[blLoadFromFile];
  SaveToDeviceButton.Caption:=LanguageStrings[blSaveToDevice];
end;

procedure TfmModuleData_76.SetDeviceUserSensorHeaderData;
begin
  case fModule2ChDataRec.UserSensorType of
       itTHC: DeviceUserInputTypeDisplay.SetDisplay(DeleteAcceleratorKey(LanguageStrings[flTHC]));
       itRTD: DeviceUserInputTypeDisplay.SetDisplay(DeleteAcceleratorKey(LanguageStrings[flRTD]));
       end;

  DeviceTempMinDisplay.SetDisplay(fDeviceUserSensorData.TMIN);
  DeviceTempMaxDisplay.SetDisplay(fDeviceUserSensorData.TMAX);
end;

procedure TfmModuleData_76.SetFileUserSensorHeaderData;
begin
  case UserSensorTypeFromHART(fFileUserSensorData.SensorType) of
       itTHC: FileUserInputTypeDisplay.SetDisplay(DeleteAcceleratorKey(LanguageStrings[flTHC]));
       itRTD: FileUserInputTypeDisplay.SetDisplay(DeleteAcceleratorKey(LanguageStrings[flRTD]));
       end;

  FileTempMinDisplay.SetDisplay(fFileUserSensorData.TMIN);
  FileTempMaxDisplay.SetDisplay(fFileUserSensorData.TMAX);
end;

procedure TfmModuleData_76.SetDeviceUserSensorTableData;
var I: integer;
begin
  for I:=0 to 64 do
      DeviceCoeffTableStringGrid.Cells[1,I+1]:='   '+IntToStr(fDeviceUserSensorData.CoeffTable[I]);
end;

procedure TfmModuleData_76.SetFileUserSensorTableData;
var I: integer;
begin
  for I:=0 to 64 do
      FileCoeffTableStringGrid.Cells[1,I+1]:='   '+IntToStr(fFileUserSensorData.CoeffTable[I]);
end;

//****************************************************************************//

procedure TfmModuleData_76.FormCreate(Sender: TObject);
begin
  fDialogMode:=dmDisplay;
  fSaveMode:=smToDevice;
  fProtectedPath:=false;
  fDeviceType:=dtNone;
  pHartModule:=nil;

  with fModule2ChDataRec do
       begin
       InputType:=itNone;
       UserSensorType:=itNone;

       InputOption:=is2In2Out;

       TypeNumber1:=0;
       ColdJunction1:=csOff;
       CJCUserValue1:=20.0;
       WiringNumber1:=0;
       Linearisation1:=tsOff;
       PVUnits1:=0;

       TypeNumber2:=0;
       ColdJunction2:=csOff;
       CJCUserValue2:=20.0;
       WiringNumber2:=0;
       Linearisation2:=tsOff;
       PVUnits2:=0;

       // more default settings

       Point4mA1:=0.0;
       Point4mA2:=0.0;
       Point20mA1:=100.0;
       Point20mA2:=100.0;

       FilterFrequencySetting:=tf50;

       DampingTimeConstant1:=0.0;
       DampingTimeConstant2:=0.0;
       SmoothingTimeConstant1:=0.0;
       SmoothingTimeConstant2:=0.0;

       NamurOption1:=nsOff;
       NamurOption2:=nsOff;

       ResponseSpeed:=tsSlow;

       TransmitterFailureAlarmLevel1:=taOff;
       TransmitterFailureAlarmLevel2:=taOff;
       ColdJunctionFailureAlarmLevel1:=taOff;
       ColdJunctionFailureAlarmLevel2:=taOff;
       OpenCircuitAlarmLevel1:=taOff;
       OpenCircuitAlarmLevel2:=taOff;
       ShortCircuitAlarmLevel1:=taOff;
       ShortCircuitAlarmLevel2:=taOff;

       EBDSetting1:=tsOff;
       EBDSetting2:=tsOff;
       end;

  fSignalSpan1:=0.0;
  fSignalSpan2:=0.0;

  fUnusualLinConfirmed:=false;
  fUnusualCJCConfirmed:=false;

  PageControl1.OwnerDraw:=true;

  SetAllLabels;
end;

procedure TfmModuleData_76.FormShow(Sender: TObject);
begin
  if (pHartModule<>nil) then
     begin

     fDeviceType:=IdentToType(pHartModule^.BasicDeviceData.UID);
     if (fDeviceType<>dtNone) then
        begin
        EncodeModuleData;

        SetInputTypeSpecificInputNumberSelectorLabels1;
        SetInputTypeSpecificInputNumberSelectorLabels2;

        SetInputTypeSpecificProcessUnitSelectorLabels1;
        SetInputTypeSpecificProcessUnitSelectorLabels2;

        SetInputOptionSpecificControls;

        if fDialogMode=dmDisplay then ArrangeDisplayModeLook;
        if fDialogMode=dmConfig then ArrangeConfigurationModeLook;

        SetSignalRangeEditLimits1;
        SetSignalRangeEditLimits2;

        SetAllDisplayValues;

        if fDialogMode=dmConfig then OK_Button.Enabled:=false;
        end
     else
        begin
        MessageDlg('Unexpected error',mtError,[mbCancel],hcNoHelpTopic);
        Close;
        end;
     end
  else Close;
end;

procedure TfmModuleData_76.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var fExpectedTransferDataLength: integer;
    lUploadRequired,
    lTooSmallSpan,
    lIgnoreSmallSpan: boolean;
begin
  CanClose:=(ModalResult<>mrOK);
  if (pHartModule<>nil) and (fDialogMode=dmConfig) then
     begin
     // OriginalCursor:=Cursor;
     lUploadRequired:=false;
     lIgnoreSmallSpan:=false;
     PageControl1.Enabled:=false;
     OK_Button.Enabled:=false;
     Close_Button.Enabled:=false;
     if ((ModalResult<>mrOK) and not(pHartModule^.VerifyDeviceData)) then
        case (MessageDlg(LanguageStrings[mlChangedNotSaved],mtWarning,[mbYes,mbNo,mbCancel],hcNoHelpTopic)) of
             mrYes: lUploadRequired:=true;
             mrNo:  ModalResult:=mrIgnore;
             else CanClose:=false;
             end;

     if ((ModalResult=mrOK) or lUploadRequired) then
        begin

        lTooSmallSpan:=((fModule2ChDataRec.InputType=itTHC) and ((fSignalSpan1<3.0) or (fSignalSpan2<3.0))) or
                       ((fModule2ChDataRec.InputType=itRTD) and ((fSignalSpan1<10.0) or (fSignalSpan2<10.0)));
        if lTooSmallSpan then
           case (MessageDlg(LanguageStrings[msSpanTooSmall],mtWarning,[mbIgnore,mbCancel],hcNoHelpTopic)) of
                mrIgnore: lIgnoreSmallSpan:=true;
                else CanClose:=false;
                end;

        if not(lTooSmallSpan) or lIgnoreSmallSpan then
           begin
           pHartModule^.EvaluateRequiredDeviceDataStatusFlags;
           fExpectedTransferDataLength:=pHartModule^.GetModuleTransferDataLength(tdUpload);
           if (fExpectedTransferDataLength>0) then
              begin
              if (fSaveMode=smToDevice) then
                 begin
                 CommGauge.MaxValue:=fExpectedTransferDataLength;

                 Cursor:=crHourGlass;
                 Application.ProcessMessages;
                 pHartModule^.UploadRequiredDeviceData;

                 if not(pHartModule^.VerifyDeviceData) then
                    begin
                    MessageDlg(LanguageStrings[msDifferentResponse],mtError,[mbOk],hcNoHelpTopic);

                    EncodeModuleData;
                    SetAllDisplayValues;
                    pHartModule^.SynchronizeRequiredDeviceData;
                    UpdateAcceptButton;

                    ModalResult:=mrCancel;
                    end;

                 CommGauge.Progress:=0;
                 end
              else  // (fSaveMode=smToMemory)
                 begin
                 pHartModule^.SynchronizeActualDeviceData;
                 MessageDlg(LanguageStrings[msDataSavedToMemory],mtConfirmation,[mbOk],hcNoHelpTopic);
                 end;
              end;
           end;
        end;

     if not(CanClose) then
        begin
        PageControl1.Enabled:=true;
        UpdateAcceptButton;
        Close_Button.Enabled:=true;
        end;
     Cursor:=OriginalCursor;
     end;
end;

procedure TfmModuleData_76.FormDestroy(Sender: TObject);
begin
  if (pHartModule<>nil) then
     pHartModule^.UnAssignReceivedCharEvent;
end;

procedure TfmModuleData_76.PageControl1Change(Sender: TObject);
begin
  if (fDialogMode=dmDisplay) then
     begin
     if (PageControl1.ActivePage=InputTabSheet) then
        HelpContext:=hcDisplayInput73
     else if (PageControl1.ActivePage=OutputTabSheet) then
             HelpContext:=hcDisplayOutput73
     else if (PageControl1.ActivePage=AlarmTabSheet) then
             HelpContext:=hcDisplayAlarm73
     else // (PageControl1.ActivePage=UserSensorTabSheet)
             HelpContext:=hcUserSensor;
     end
  else // fDialogMode=dmConfig
     begin
     if (PageControl1.ActivePage=InputTabSheet) then
        HelpContext:=hcConfigInput73
     else if (PageControl1.ActivePage=OutputTabSheet) then
             HelpContext:=hcConfigOutput73
     else if (PageControl1.ActivePage=AlarmTabSheet) then
             HelpContext:=hcConfigAlarm73
     else // (PageControl1.ActivePage=UserSensorTabSheet)
             HelpContext:=hcUserSensor;
     end;
end;

procedure TfmModuleData_76.PageControl1DrawTab(Control: TCustomTabControl;
  TabIndex: Integer; const Rect: TRect; Active: Boolean);
begin
  if (Active) then
     Control.Canvas.Font.Style:=Control.Canvas.Font.Style+[fsBold]
  else Control.Canvas.Font.Style:=Control.Canvas.Font.Style-[fsBold];
  Control.Canvas.TextOut(Rect.Left+5,Rect.Top+3,PageControl1.Pages[TabIndex].Caption);
end;

//****************************************************************************//

procedure TfmModuleData_76.InputTypeSelectorClick(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     case InputTypeSelector.ItemIndex of
          0: fModule2ChDataRec.InputType:=itTHC;
          1: fModule2ChDataRec.InputType:=itRTD;
          else fModule2ChDataRec.InputType:=itNone;
          end;

     fModule2ChDataRec.Linearisation1:=tsOn;   // linearisation on
     fModule2ChDataRec.PVUnits1:=0;            // PVUnits C
     fModule2ChDataRec.Linearisation2:=tsOn;   // linearisation on
     fModule2ChDataRec.PVUnits2:=0;            // PVUnits C
     fModule2ChDataRec.TransmitterFailureAlarmLevel1:=taLow;
     fModule2ChDataRec.TransmitterFailureAlarmLevel2:=taLow;
     fModule2ChDataRec.OpenCircuitAlarmLevel1:=taHigh;
     fModule2ChDataRec.OpenCircuitAlarmLevel2:=taHigh;
     fModule2ChDataRec.ShortCircuitAlarmLevel1:=taOff;
     fModule2ChDataRec.ShortCircuitAlarmLevel2:=taOff;
     fModule2ChDataRec.EBDSetting1:=tsOff;
     fModule2ChDataRec.EBDSetting2:=tsOff;

     if fModule2ChDataRec.InputType=itTHC then
        begin
        fModule2ChDataRec.TypeNumber1:=3;      // Type K
        fModule2ChDataRec.ColdJunction1:=csOn;
        fModule2ChDataRec.TypeNumber2:=3;      // Type K
        fModule2ChDataRec.ColdJunction2:=csOn;
        // RTD wiring number is not relevant
        fModule2ChDataRec.Point4mA1:=0.0;
        fModule2ChDataRec.Point20mA1:=250.0;
        fModule2ChDataRec.Point4mA2:=0.0;
        fModule2ChDataRec.Point20mA2:=250.0;
        // ColdJunctionFailureAlarmLevel remain not affected
        fModule2ChDataRec.ShortCircuitAlarmLevel1:=taOff;
        fModule2ChDataRec.ShortCircuitAlarmLevel2:=taOff;
        // EBD remain unchanged
        end
     else // fModule2ChDataRec.InputType=itRTD
        begin
       fModule2ChDataRec.TypeNumber1:=0;       // Pt100
       fModule2ChDataRec.TypeNumber2:=0;       // Pt100
        // Cold Junction Selection is not relevant
        fModule2ChDataRec.WiringNumber1:=0;    // 2-wire
        fModule2ChDataRec.WiringNumber2:=0;    // 2-wire
        fModule2ChDataRec.Point4mA1:=0.0;
        fModule2ChDataRec.Point20mA1:=100.0;
        fModule2ChDataRec.Point4mA2:=0.0;
        fModule2ChDataRec.Point20mA2:=100.0;
        fModule2ChDataRec.ColdJunctionFailureAlarmLevel1:=taOff;
        fModule2ChDataRec.ColdJunctionFailureAlarmLevel2:=taOff;
        // ShortCircuitAlarmLevel remain unchanged
        end;

     fProtectedPath:=true;

     SetInputTypeSpecificInputNumberSelectorLabels1;
     SetInputTypeSpecificInputNumberSelectorLabels2;
     SetInputNumberSelectorItem1;
     SetInputNumberSelectorItem2;

     // Disable unused CJC Buttons is not required here (Input Number cannot be mV)
     SetCJCorRTDWiringSelectorItems1(false);
     SetCJCorRTDWiringSelectorItems2(false);

     SetLinearisationSelectorItems1(true);
     SetLinearisationSelectorItems2(true);

     SetInputTypeSpecificLastProcessUnitSelectorLabel1;
     SetInputTypeSpecificLastProcessUnitSelectorLabel2;
     SetInputTypeSpecificProcessUnitSelectorItem1;
     SetInputTypeSpecificProcessUnitSelectorItem2;
     ProcessUnitSelector1.SetButtonEnableArray(GetDynArray(CNonLinUnits));
     ProcessUnitSelector2.SetButtonEnableArray(GetDynArray(CNonLinUnits));

     SetSignalRangeEditValues1;
     SetSignalRangeEditValues2;
     SetSignalRangeEditUnits1;
     SetSignalRangeEditUnits2;
     SetSignalRangeEditLimits1;
     SetSignalRangeEditLimits2;

     SetTransmitterFailureAlarmLevelSelectorItems1;
     SetTransmitterFailureAlarmLevelSelectorItems2;
     SetOpenCircuitAlarmLevelItems1;
     SetOpenCircuitAlarmLevelItems2;

     if fModule2ChDataRec.InputType=itTHC then
        begin
        SetColdJunctionFailureAlarmLevelItems1(false);
        SetShortCircuitAlarmLevelItems1(true);
        SetColdJunctionFailureAlarmLevelItems2(false);
        SetShortCircuitAlarmLevelItems2(true);
        end
     else // fModule2ChDataRec.InputType=itRTD
        begin
        SetColdJunctionFailureAlarmLevelItems1(true);
        SetShortCircuitAlarmLevelItems1(false);
        SetColdJunctionFailureAlarmLevelItems2(true);
        SetShortCircuitAlarmLevelItems2(false);
        end;

     SetEBDSelectorItems1(fModule2ChDataRec.InputType=itRTD);
     SetEBDSelectorItems2(fModule2ChDataRec.InputType=itRTD);

     fProtectedPath:=false;
     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.InputOptionSelectorChange(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     if (InputOptionSelector.ItemIndex=1) then
        fModule2ChDataRec.InputOption:=is1In2Out
     else fModule2ChDataRec.InputOption:=is2In2Out;

     SetInputOptionSpecificControls;
     
     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.InputNumberSelector1Click(Sender: TObject);
var lTypeNumber, lLinearTypeNumber: word;
    lUpdateRangeUnits: boolean;
begin
  if not(fProtectedPath) then
     begin
     lUpdateRangeUnits:=false;

     lTypeNumber:=InputNumberSelector1.ItemIndex;
     // note: this is always the "mV" or "resistor" selection
     lLinearTypeNumber:=InputNumberSelector1.Items.Count-1;

     if fModule2ChDataRec.InputType=itTHC then
        begin
        if (lTypeNumber<>lLinearTypeNumber) then
           begin
           // This is the first input type change from itmV to itTHC
           if (fModule2ChDataRec.TypeNumber1=lLinearTypeNumber) then
              begin
              fProtectedPath:=true;

              fModule2ChDataRec.ColdJunction1:=csOn;
              SetCJCorRTDWiringSelectorItems1(false);

              fModule2ChDataRec.Linearisation1:=tsOn;
              SetLinearisationSelectorItems1(true);

              fModule2ChDataRec.PVUnits1:=0; // set default selection to "C"
              SetInputTypeSpecificProcessUnitSelectorItem1;
              ProcessUnitSelector1.SetButtonEnableArray(GetDynArray(CNonLinUnits));

              UpdateSignalRangeEditValues1(0.0,250.0);

              lUpdateRangeUnits:=true;

              CJC_Alarm_Selector1.EnableAllButtons;

              fModule2ChDataRec.ColdJunctionFailureAlarmLevel1:=taLow;
              SetColdJunctionFailureAlarmLevelItems1(false);

              // Note: RTD Short Circuit Alarm is already off

              fProtectedPath:=false;
              end;
           end
        else // the new selection is "mV"
           begin
           fProtectedPath:=true;

           fModule2ChDataRec.ColdJunction1:=csOff;
           SetCJCorRTDWiringSelectorItems1(true);

           fModule2ChDataRec.Linearisation1:=tsOff;
           SetLinearisationSelectorItems1(true);

           fModule2ChDataRec.PVUnits1:=4; // set default selection to "mV"
           SetInputTypeSpecificProcessUnitSelectorItem1;
           ProcessUnitSelector1.SetButtonEnableArray(GetDynArray(CLinUnits));

           UpdateSignalRangeEditValues1(0.0,50.0);

           lUpdateRangeUnits:=true;

           fModule2ChDataRec.ColdJunctionFailureAlarmLevel1:=taOff;
           SetColdJunctionFailureAlarmLevelItems1(true);

           fProtectedPath:=false;
           end;
        end
     else // fModule2ChDataRec.InputType=itRTD
        begin
        if (lTypeNumber<>lLinearTypeNumber) then
           begin
           // This is the first input type change from "resistor" to "true RTD"
           // Note: for RTD the LastTypeNumber applies only to the selector component
           // but not to the "fModule2ChDataRec.TypeNumber", therefore check linearisation
           if (fModule2ChDataRec.Linearisation1=tsOff) then
              begin
              fProtectedPath:=true;

              // RTD wiring remain unchanged

              fModule2ChDataRec.Linearisation1:=tsOn;
              SetLinearisationSelectorItems1(true);

              fModule2ChDataRec.PVUnits1:=0; // set default selection to "C"
              SetInputTypeSpecificProcessUnitSelectorItem1;
              ProcessUnitSelector1.SetButtonEnableArray(GetDynArray(CNonLinUnits));

              UpdateSignalRangeEditValues1(0.0,100.0);

              lUpdateRangeUnits:=true;

              // Note: CJC Failure Alarm is already off

              SC_Alarm_Selector1.EnableAllButtons;

              // EBD is already off and Trip remain unchanged

              fProtectedPath:=false;
              end;
           end
        else // the new selection is "resistor"
           begin
           fProtectedPath:=true;

           // RTD wiring remain unchanged

           fModule2ChDataRec.Linearisation1:=tsOff;
           SetLinearisationSelectorItems1(true);

           fModule2ChDataRec.PVUnits1:=5; // set default selection to "Ohm"
           SetInputTypeSpecificProcessUnitSelectorItem1;
           ProcessUnitSelector1.SetButtonEnableArray(GetDynArray(CLinUnits));

           UpdateSignalRangeEditValues1(0.0,400.0);

           lUpdateRangeUnits:=true;

           fModule2ChDataRec.ShortCircuitAlarmLevel1:=taOff;
           SetShortCircuitAlarmLevelItems1(true);

           fProtectedPath:=false;
           end;
        end;

     fModule2ChDataRec.TypeNumber1:=lTypeNumber;

     if lUpdateRangeUnits then
        SetSignalRangeEditUnits1;
     SetSignalRangeEditLimits1;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.InputNumberSelector2Click(Sender: TObject);
var lTypeNumber, lLinearTypeNumber: word;
    lUpdateRangeUnits: boolean;
begin
  if not(fProtectedPath) then
     begin
     lUpdateRangeUnits:=false;

     lTypeNumber:=InputNumberSelector2.ItemIndex;
     // note: this is always the "mV" or "resistor" selection
     lLinearTypeNumber:=InputNumberSelector2.Items.Count-1;

     if fModule2ChDataRec.InputType=itTHC then
        begin
        if (lTypeNumber<>lLinearTypeNumber) then
           begin
           // This is the first input type change from itmV to itTHC
           if (fModule2ChDataRec.TypeNumber2=lLinearTypeNumber) then
              begin
              fProtectedPath:=true;

              fModule2ChDataRec.ColdJunction2:=csOn;
              SetCJCorRTDWiringSelectorItems2(false);

              fModule2ChDataRec.Linearisation2:=tsOn;
              SetLinearisationSelectorItems2(true);

              fModule2ChDataRec.PVUnits2:=0; // set default selection to "C"
              SetInputTypeSpecificProcessUnitSelectorItem2;
              ProcessUnitSelector2.SetButtonEnableArray(GetDynArray(CNonLinUnits));

              UpdateSignalRangeEditValues2(0.0,250.0);

              lUpdateRangeUnits:=true;

              CJC_Alarm_Selector2.EnableAllButtons;

              fModule2ChDataRec.ColdJunctionFailureAlarmLevel1:=taLow;
              SetColdJunctionFailureAlarmLevelItems1(false);

              // Note: RTD Short Circuit Alarm is already off

              fProtectedPath:=false;
              end;
           end
        else // the new selection is "mV"
           begin
           fProtectedPath:=true;

           fModule2ChDataRec.ColdJunction2:=csOff;
           SetCJCorRTDWiringSelectorItems2(true);

           fModule2ChDataRec.Linearisation2:=tsOff;
           SetLinearisationSelectorItems2(true);

           fModule2ChDataRec.PVUnits2:=4; // set default selection to "mV"
           SetInputTypeSpecificProcessUnitSelectorItem2;
           ProcessUnitSelector2.SetButtonEnableArray(GetDynArray(CLinUnits));

           UpdateSignalRangeEditValues2(0.0,50.0);

           lUpdateRangeUnits:=true;

           fModule2ChDataRec.ColdJunctionFailureAlarmLevel2:=taOff;
           SetColdJunctionFailureAlarmLevelItems2(true);

           fProtectedPath:=false;
           end;
        end
     else // fModule2ChDataRec.InputType=itRTD
        begin
        if (lTypeNumber<>lLinearTypeNumber) then
           begin
           // This is the first input type change from "resistor" to "true RTD"
           // Note: for RTD the LastTypeNumber applies only to the selector component
           // but not to the "fModule2ChDataRec.TypeNumber", therefore check linearisation
           if (fModule2ChDataRec.Linearisation2=tsOff) then
              begin
              fProtectedPath:=true;

              // RTD wiring remain unchanged

              fModule2ChDataRec.Linearisation2:=tsOn;
              SetLinearisationSelectorItems2(true);

              fModule2ChDataRec.PVUnits2:=0; // set default selection to "C"
              SetInputTypeSpecificProcessUnitSelectorItem2;
              ProcessUnitSelector2.SetButtonEnableArray(GetDynArray(CNonLinUnits));

              UpdateSignalRangeEditValues2(0.0,100.0);

              lUpdateRangeUnits:=true;

              // Note: CJC Failure Alarm is already off

              SC_Alarm_Selector2.EnableAllButtons;

              // EBD is already off and Trip remain unchanged

              fProtectedPath:=false;
              end;
           end
        else // the new selection is "resistor"
           begin
           fProtectedPath:=true;

           // RTD wiring remain unchanged

           fModule2ChDataRec.Linearisation2:=tsOff;
           SetLinearisationSelectorItems2(true);

           fModule2ChDataRec.PVUnits2:=5; // set default selection to "Ohm"
           SetInputTypeSpecificProcessUnitSelectorItem2;
           ProcessUnitSelector2.SetButtonEnableArray(GetDynArray(CLinUnits));

           UpdateSignalRangeEditValues2(0.0,400.0);

           lUpdateRangeUnits:=true;

           fModule2ChDataRec.ShortCircuitAlarmLevel2:=taOff;
           SetShortCircuitAlarmLevelItems2(true);

           fProtectedPath:=false;
           end;
        end;

     fModule2ChDataRec.TypeNumber2:=lTypeNumber;

     if lUpdateRangeUnits then
        SetSignalRangeEditUnits2;
     SetSignalRangeEditLimits2;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.CJCSelector1Click(Sender: TObject);
var lColdJunction1: Tx576CJCSet;
begin
  if not(fProtectedPath) then
     begin
     lColdJunction1:=Tx576CJCSet(CJCSelector1.ItemIndex);

     // Evaluate Unusual Cold Junction Compensation Selection and show adequate warning
     // However when once ignored, don't show this warning again until dialog is closed
     // This path can be achieved only when "InputType=itTHC" and not "mV" is selected
     if (lColdJunction1=csOff) and
        not(fUnusualCJCConfirmed) then
        fUnusualCJCConfirmed:=(MessageDlg(LanguageStrings[msWrongCJCSetting],mtWarning,[mbIgnore,mbCancel],hcNoHelpTopic)=mrIgnore);

     if (lColdJunction1<>csOff) or fUnusualCJCConfirmed then
        begin
        fModule2ChDataRec.ColdJunction1:=lColdJunction1;

        fProtectedPath:=true;
        if (fModule2ChDataRec.ColdJunction1=csUser) then
           begin
           CJC_Edit1.Enabled:=true;
           CJC_Edit1.EditColor:=clWindow;
           CJC_Edit1.EditFont.Color:=Self.Font.Color;
           end
        else
           begin
           CJC_Edit1.Enabled:=false;
           CJC_Edit1.EditColor:=clSilver;
           CJC_Edit1.EditFont.Color:=clSilver;
           end;

        if (fModule2ChDataRec.ColdJunction1=csOff) then
           begin
           fModule2ChDataRec.ColdJunctionFailureAlarmLevel1:=taOff;
           SetColdJunctionFailureAlarmLevelItems1(true);
           end
        else  // fModule2ChDataRec.ColdJunction1=csOn (or csUser)
           begin
           fModule2ChDataRec.ColdJunctionFailureAlarmLevel1:=taLow;
           SetColdJunctionFailureAlarmLevelItems1(false);
           end;

        // EBD is and Trip configuration remain unaffected during CJC change
        fProtectedPath:=false;

        DecodeModuleData;
        UpdateAcceptButton;
        end
     else // lColdJunction1=tsOff and not(fUnusualCJCConfirmed)
        begin
        fProtectedPath:=true;
        CJCSelector1.ItemIndex:=integer(fModule2ChDataRec.ColdJunction1);
        fProtectedPath:=false;
        end;
     end;
end;

procedure TfmModuleData_76.CJCSelector2Click(Sender: TObject);
var lColdJunction2: Tx576CJCSet;
begin
  if not(fProtectedPath) then
     begin
     lColdJunction2:=Tx576CJCSet(CJCSelector2.ItemIndex);

     // Evaluate Unusual Cold Junction Compensation Selection and show adequate warning
     // However when once ignored, don't show this warning again until dialog is closed
     // This path can be achieved only when "InputType=itTHC" and not "mV" is selected
     if (lColdJunction2=csOff) and
        not(fUnusualCJCConfirmed) then
        fUnusualCJCConfirmed:=(MessageDlg(LanguageStrings[msWrongCJCSetting],mtWarning,[mbIgnore,mbCancel],hcNoHelpTopic)=mrIgnore);

     if (lColdJunction2<>csOff) or fUnusualCJCConfirmed then
        begin
        fModule2ChDataRec.ColdJunction2:=lColdJunction2;

        fProtectedPath:=true;
        if (fModule2ChDataRec.ColdJunction2=csUser) then
           begin
           CJC_Edit2.Enabled:=true;
           CJC_Edit2.EditColor:=clWindow;
           CJC_Edit2.EditFont.Color:=Self.Font.Color;
           end
        else
           begin
           CJC_Edit2.Enabled:=false;
           CJC_Edit2.EditColor:=clSilver;
           CJC_Edit2.EditFont.Color:=clSilver;
           end;

        if (fModule2ChDataRec.ColdJunction2=csOff) then
           begin
           fModule2ChDataRec.ColdJunctionFailureAlarmLevel2:=taOff;
           SetColdJunctionFailureAlarmLevelItems2(true);
           end
        else  // fModule2ChDataRec.ColdJunction1=csOn (or csUser)
           begin
           fModule2ChDataRec.ColdJunctionFailureAlarmLevel2:=taLow;
           SetColdJunctionFailureAlarmLevelItems2(false);
           end;

        // EBD is and Trip configuration remain unaffected during CJC change
        fProtectedPath:=false;

        DecodeModuleData;
        UpdateAcceptButton;
        end
     else // lColdJunction2=tsOff and not(fUnusualCJCConfirmed)
        begin
        fProtectedPath:=true;
        CJCSelector2.ItemIndex:=integer(fModule2ChDataRec.ColdJunction2);
        fProtectedPath:=false;
        end;
     end;
end;

procedure TfmModuleData_76.CJC_Edit1Exit(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModule2ChDataRec.CJCUserValue1:=CJC_Edit1.Value;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.CJC_Edit1RangeValidationError(Sender: TObject);
begin
  CJC_Edit1.SetValueToValidRange;
end;

procedure TfmModuleData_76.CJC_Edit2Exit(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModule2ChDataRec.CJCUserValue2:=CJC_Edit2.Value;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.CJC_Edit2RangeValidationError(Sender: TObject);
begin
  CJC_Edit2.SetValueToValidRange;
end;

procedure TfmModuleData_76.RTDWiringSelector1Click(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModule2ChDataRec.WiringNumber1:=RTDWiringSelector1.ItemIndex;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.RTDWiringSelector2Click(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModule2ChDataRec.WiringNumber2:=RTDWiringSelector2.ItemIndex;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.LinearisationSelector1Click(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModule2ChDataRec.Linearisation1:=TOnOffSet(LinearisationSelector1.ItemIndex);

     // Evaluate Unusual Linearisation Selection and show adequate warning
     if (fModule2ChDataRec.Linearisation1=tsOff) and
        not(fUnusualLinConfirmed) and
        (((fModule2ChDataRec.InputType=itTHC) and (fModule2ChDataRec.TypeNumber1<(InputNumberSelector1.Items.Count-1))) or
         ((fModule2ChDataRec.InputType=itRTD) and (fModule2ChDataRec.TypeNumber1<(InputNumberSelector1.Items.Count-1)))) then
        fUnusualLinConfirmed:=(MessageDlg(LanguageStrings[msWrongLinSetting],mtWarning,[mbIgnore,mbCancel],hcNoHelpTopic)=mrIgnore);

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.LinearisationSelector2Click(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModule2ChDataRec.Linearisation2:=TOnOffSet(LinearisationSelector2.ItemIndex);

     // Evaluate Unusual Linearisation Selection and show adequate warning
     if (fModule2ChDataRec.Linearisation2=tsOff) and
        not(fUnusualLinConfirmed) and
        (((fModule2ChDataRec.InputType=itTHC) and (fModule2ChDataRec.TypeNumber2<(InputNumberSelector2.Items.Count-1))) or
         ((fModule2ChDataRec.InputType=itRTD) and (fModule2ChDataRec.TypeNumber2<(InputNumberSelector2.Items.Count-1)))) then
        fUnusualLinConfirmed:=(MessageDlg(LanguageStrings[msWrongLinSetting],mtWarning,[mbIgnore,mbCancel],hcNoHelpTopic)=mrIgnore);

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.ProcessUnitSelector1Click(Sender: TObject);
var lPVUnits: integer;
begin
  if not(fProtectedPath) then
     begin
     lPVUnits:=ProcessUnitSelector1.ItemIndex;
     if not((fModule2ChDataRec.InputType=itRTD) and (lPVUnits=4)) then // not Ohm selection
        fModule2ChDataRec.PVUnits1:=lPVUnits
     else fModule2ChDataRec.PVUnits1:=5;

     SetSignalRangeEditUnits1;
     SetSignalRangeEditLimits1;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.ProcessUnitSelector2Click(Sender: TObject);
var lPVUnits: integer;
begin
  if not(fProtectedPath) then
     begin
     lPVUnits:=ProcessUnitSelector2.ItemIndex;
     if not((fModule2ChDataRec.InputType=itRTD) and (lPVUnits=4)) then // not Ohm selection
        fModule2ChDataRec.PVUnits2:=lPVUnits
     else fModule2ChDataRec.PVUnits2:=5;

     SetSignalRangeEditUnits2;
     SetSignalRangeEditLimits2;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.Point4mA_Edit1Change(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModule2ChDataRec.Point4mA1:=Point4mA_Edit1.Value;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.Point4mA_Edit1RangeValidationError(Sender: TObject);
begin
  Point4mA_Edit1.SetValueToValidRange;
end;

procedure TfmModuleData_76.Point20mA_Edit1Change(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModule2ChDataRec.Point20mA1:=Point20mA_Edit1.Value;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.Point20mA_Edit1RangeValidationError(Sender: TObject);
begin
  Point20mA_Edit1.SetValueToValidRange;
end;

procedure TfmModuleData_76.Point4mA_Edit2Change(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModule2ChDataRec.Point4mA2:=Point4mA_Edit2.Value;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.Point4mA_Edit2RangeValidationError(Sender: TObject);
begin
  Point4mA_Edit2.SetValueToValidRange;
end;

procedure TfmModuleData_76.Point20mA_Edit2Change(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModule2ChDataRec.Point20mA2:=Point20mA_Edit2.Value;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.Point20mA_Edit2RangeValidationError(Sender: TObject);
begin
  Point20mA_Edit2.SetValueToValidRange;
end;

procedure TfmModuleData_76.FrequencySelectorClick(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModule2ChDataRec.FilterFrequencySetting:=TFilterFrequency(FrequencySelector.ItemIndex);

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.DampingConstant_Edit1Change(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModule2ChDataRec.DampingTimeConstant1:=DampingConstant_Edit1.Value;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.DampingConstant_Edit1RangeValidationError(Sender: TObject);
begin
  DampingConstant_Edit1.SetValueToValidRange;
end;

procedure TfmModuleData_76.SmoothingConstant_Edit1Change(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModule2ChDataRec.SmoothingTimeConstant1:=SmoothingConstant_Edit1.Value;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.SmoothingConstant_Edit1RangeValidationError(Sender: TObject);
begin
  SmoothingConstant_Edit1.SetValueToValidRange;
end;

procedure TfmModuleData_76.DampingConstant_Edit2Change(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModule2ChDataRec.DampingTimeConstant2:=DampingConstant_Edit2.Value;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.DampingConstant_Edit2RangeValidationError(Sender: TObject);
begin
  DampingConstant_Edit2.SetValueToValidRange;
end;

procedure TfmModuleData_76.SmoothingConstant_Edit2Change(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModule2ChDataRec.SmoothingTimeConstant2:=SmoothingConstant_Edit2.Value;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.SmoothingConstant_Edit2RangeValidationError(Sender: TObject);
begin
  SmoothingConstant_Edit2.SetValueToValidRange;
end;

procedure TfmModuleData_76.NE43OnButton1Click(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModule2ChDataRec.NamurOption1:=nsOn;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.NE43OffButton1Click(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModule2ChDataRec.NamurOption1:=nsOff;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.NE43OnButton2Click(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModule2ChDataRec.NamurOption2:=nsOn;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.NE43OffButton2Click(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModule2ChDataRec.NamurOption2:=nsOff;

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.ResponseTimeSelectorClick(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModule2ChDataRec.ResponseSpeed:=TResponseSpeed(ResponseTimeSelector.ItemIndex);

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.TX_Alarm_Selector1Click(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModule2ChDataRec.TransmitterFailureAlarmLevel1:=TAlarmLevelSet(TX_Alarm_Selector1.ItemIndex);

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.TX_Alarm_Selector2Click(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModule2ChDataRec.TransmitterFailureAlarmLevel2:=TAlarmLevelSet(TX_Alarm_Selector2.ItemIndex);

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.OC_Alarm_Selector1Click(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModule2ChDataRec.OpenCircuitAlarmLevel1:=TAlarmLevelSet(OC_Alarm_Selector1.ItemIndex);

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.OC_Alarm_Selector2Click(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModule2ChDataRec.OpenCircuitAlarmLevel2:=TAlarmLevelSet(OC_Alarm_Selector2.ItemIndex);

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.CJC_Alarm_Selector1Click(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModule2ChDataRec.ColdJunctionFailureAlarmLevel1:=TAlarmLevelSet(CJC_Alarm_Selector1.ItemIndex);

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.CJC_Alarm_Selector2Click(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModule2ChDataRec.ColdJunctionFailureAlarmLevel2:=TAlarmLevelSet(CJC_Alarm_Selector2.ItemIndex);

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.SC_Alarm_Selector1Click(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModule2ChDataRec.ShortCircuitAlarmLevel1:=TAlarmLevelSet(SC_Alarm_Selector1.ItemIndex);

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.SC_Alarm_Selector2Click(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModule2ChDataRec.ShortCircuitAlarmLevel2:=TAlarmLevelSet(SC_Alarm_Selector2.ItemIndex);

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.EBDSelector1Click(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModule2ChDataRec.EBDSetting1:=TOnOffSet(EBDSelector1.ItemIndex);

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.EBDSelector2Click(Sender: TObject);
begin
  if not(fProtectedPath) then
     begin
     fModule2ChDataRec.EBDSetting2:=TOnOffSet(EBDSelector2.ItemIndex);

     DecodeModuleData;
     UpdateAcceptButton;
     end;
end;

procedure TfmModuleData_76.LoadFromFileButtonClick(Sender: TObject);
var lOpenDialog: TOpenDialog;
begin
  lOpenDialog:=TOpenDialog.Create(Self);
  with lOpenDialog do
       begin
       Title:=' '+LanguageStrings[dlImportCustomSensor];
       Filter:=LanguageStrings[dsCustomSensorFileFilter];
       DefaultExt:=LowerCase(CDef_LOGExt);
       if (MOD45.LastD45Path<>'') then
          InitialDir:=MOD45.LastD45Path
       else InitialDir:=GetMyDocumentsFolder;
       if Execute then
          if (ImportUserSensorConfiguration(FileName,fFileUserSensorData)) then
             begin
             SetFileUserSensorHeaderData;
             SetFileUserSensorTableData;
             SaveToDeviceButton.Enabled:=true;
             end
          else
             SaveToDeviceButton.Enabled:=false;
       end;
  lOpenDialog.Free;
end;

procedure TfmModuleData_76.LoadFromDeviceButtonClick(Sender: TObject);
var lUserSensorTable: THUserSensorTable;
    I: integer;
begin
  CommGauge.MaxValue:=5*(8+27);

  if (THartModule_x576(pHartModule^).DownloadUserSensorTableCoefficients(lUserSensorTable)) then
     begin
     for I:=0 to 64 do
         fDeviceUserSensorData.CoeffTable[I]:=lUserSensorTable[I];
     SetDeviceUserSensorTableData;
     end;

  WaitMilliseconds(100);
  CommGauge.Progress:=0;
end;


procedure TfmModuleData_76.SaveToDeviceButtonClick(Sender: TObject);
var lUpdateInputType1, lUpdateInputType2: boolean;
begin
  CommGauge.MaxValue:=8+14+5*(8+27);

  if (THartModule_x576(pHartModule^).UploadUserSensorData(fFileUserSensorData)) then
     begin
     fDeviceUserSensorData:=fFileUserSensorData;
     fModule2ChDataRec.UserSensorType:=UserSensorTypeFromHART(fDeviceUserSensorData.SensorType);
     fUserSensorLimits.LLim:=fDeviceUserSensorData.TMIN;
     fUserSensorLimits.ULim:=fDeviceUserSensorData.TMAX;

     SetDeviceUserSensorHeaderData;
     SetDeviceUserSensorTableData;

     lUpdateInputType1:=false;
     lUpdateInputType2:=false;

     case fModule2ChDataRec.InputType of
          itTHC: begin
                 // deselect User Sensor when they are of different type (RTD while THC)
                 if (fModule2ChDataRec.UserSensorType=itRTD) and // user sensor is RTD
                    (fModule2ChDataRec.TypeNumber1=9) then       // but THC User sensor was selected
                    begin
                    fModule2ChDataRec.TypeNumber1:=3;            // then set to Type K
                    lUpdateInputType1:=true;
                    end;
                 if (fModule2ChDataRec.UserSensorType=itRTD) and // user sensor is RTD
                    (fModule2ChDataRec.TypeNumber2=9) then       // but THC User sensor was selected
                    begin
                    fModule2ChDataRec.TypeNumber2:=3;            // then set to Type K
                    lUpdateInputType2:=true;
                    end;
                 // allow User Sensor selection only when it is of the same type (both THC)
                 InputNumberSelector1.ButtonEnable[9]:=(fModule2ChDataRec.UserSensorType=itTHC);
                 InputNumberSelector2.ButtonEnable[9]:=(fModule2ChDataRec.UserSensorType=itTHC);
                 end;
          itRTD: begin
                 // deselect User Sensor when they are of different type (THC while RTD)
                 if (fModule2ChDataRec.UserSensorType=itTHC) and // user sensor is THC
                    (fModule2ChDataRec.TypeNumber1=8) then       // but RTD User sensor was selected
                    begin
                    fModule2ChDataRec.TypeNumber1:=0;            // then set to Pt100
                    lUpdateInputType1:=true;
                    end;
                 if (fModule2ChDataRec.UserSensorType=itTHC) and // user sensor is THC
                    (fModule2ChDataRec.TypeNumber2=8) then       // but RTD User sensor was selected
                    begin
                    fModule2ChDataRec.TypeNumber2:=0;            // then set to Pt100
                    lUpdateInputType2:=true;
                    end;
                 // allow User Sensor selection only if it is of the same type (both RTD)
                 InputNumberSelector1.ButtonEnable[8]:=(fModule2ChDataRec.UserSensorType=itRTD);
                 end;
          end;

     if lUpdateInputType1 then
        begin
        SetSignalRangeEditLimits1;
        end;

     if lUpdateInputType2 then
        begin
        SetSignalRangeEditLimits2;
        end;

     SaveToDeviceButton.Enabled:=false;

     if lUpdateInputType1 or
        lUpdateInputType2 then
        begin
        DecodeModuleData;
        UpdateAcceptButton;
        end;

     end
  else MessageDlg(LanguageStrings[msDifferentResponse],mtError,[mbOk],hcNoHelpTopic);

  WaitMilliseconds(100);
  CommGauge.Progress:=0;
end;

end.
