unit NewDevice;

interface

uses Windows, StdCtrls, Buttons, Classes, Controls, Forms, GroupControls, DataTypes;

type
  TfmNewDevice = class(TForm)
    SelectionGroup: TMyRadioGroup;
    OK_Button: TBitBtn;
    Close_Button: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OK_ButtonClick(Sender: TObject);
  private
    { Private declarations }
    fNewDevice: TDeviceType;
  public
    { Public declarations }
    procedure SetDevice(DeviceData: TDeviceType);
    function GetDevice: TDeviceType;
  end;

var
  fmNewDevice: TfmNewDevice;

implementation

{$R *.dfm}

uses DataInstances, LabelNumbers, HelpContextNumbers;

{ TfmNewDevice }

procedure TfmNewDevice.SetDevice(DeviceData: TDeviceType);
begin
  fNewDevice:=DeviceData;
end;

function TfmNewDevice.GetDevice: TDeviceType;
begin
  Result:=fNewDevice;
end;

procedure TfmNewDevice.FormCreate(Sender: TObject);
begin
  Caption:=' '+LanguageStrings[flNewDataSet];
  HelpContext:=hcNewDataSet;

  with SelectionGroup do
       begin
       Caption:=LanguageStrings[flSelectDevice];

       Items.Add(LanguageStrings[flMTL3073_4073]);
       Items.Add(LanguageStrings[flMTL4073XK]);
       Items.Add(LanguageStrings[flMTL4075]);
       Items.Add(LanguageStrings[flMTL5073_5074]);
       Items.Add(LanguageStrings[flMTL5074XK]);
       Items.Add(LanguageStrings[flMTL4532_5532]);
       Items.Add(LanguageStrings[flMTL4573_5573]);
       Items.Add(LanguageStrings[flMTL4575_5575]);
       Items.Add(LanguageStrings[flMTL4576_5576]);
       end;

  OK_Button.Caption:=LanguageStrings[blSetting];
  Close_Button.Caption:=LanguageStrings[blClose];

  OK_Button.Top:=SelectionGroup.Top+SelectionGroup.Height+20;
  OK_Button.Left:=SelectionGroup.Left;
  Close_Button.Top:=OK_Button.Top;
  Close_Button.Left:=SelectionGroup.Left+SelectionGroup.Width-Close_Button.Width;

  Self.Height:=Close_Button.Top+80;
end;

procedure TfmNewDevice.FormShow(Sender: TObject);
begin
  case fNewDevice of
       dtx073: SelectionGroup.ItemIndex:=0;
       dt4073XK: SelectionGroup.ItemIndex:=1;
       dt4075: SelectionGroup.ItemIndex:=2;
       dt507x: SelectionGroup.ItemIndex:=3;
       dt5074XK: SelectionGroup.ItemIndex:=4;
       dtx532: SelectionGroup.ItemIndex:=5;
       dtx573: SelectionGroup.ItemIndex:=6;
       dtx575: SelectionGroup.ItemIndex:=7;
       dtx576: SelectionGroup.ItemIndex:=8;
       else SelectionGroup.ItemIndex:=-1; // wrong selection
       end;
end;

procedure TfmNewDevice.OK_ButtonClick(Sender: TObject);
begin
  case SelectionGroup.ItemIndex of
       0: fNewDevice:=dtx073;
       1: fNewDevice:=dt4073XK;
       2: fNewDevice:=dt4075;
       3: fNewDevice:=dt507x;
       4: fNewDevice:=dt5074XK;
       5: fNewDevice:=dtx532;
       6: fNewDevice:=dtx573;
       7: fNewDevice:=dtx575;
       8: fNewDevice:=dtx576;
       else fNewDevice:=dtNone;
       end;
end;

end.
