//*************************************************************************************************
//*************************************************************************************************
//*************************************************************************************************
//**
//**	ORDER DESCRIPTION - CONFIGURATION SOFTWARE WITH HART COMMUNICATION (PCS45)
//**	HELPCONTEXTNUMBERS.PAS (Derived from former file LABELS.PAS)
//**
//**	Help Context reference numbers for PCS45
//**
//**	Autor : Georg  Hahn
//**	Datum :  xx.yy.96 / 09.08.14
//**
//*************************************************************************************************
//*************************************************************************************************
//*************************************************************************************************
unit HelpContextNumbers;

interface

const

  // The below numbers come from the help project file PCS45xxx.h (xxx=DEU, ENG or FRA)


     hcIntroduction             = 100;
     hcOperationModes           = 101;
     hcDataFlow                 = 102;
     hcDataFormat               = 103;
     hcTemperatureConverter     = 104;
     hcPulseIsolator            = 105;
     hcPCL45                    = 106;

     hcFile                     = 110;
     hcNewDataSet               = 111;
     hcOpen                     = 112;
     hcSave                     = 113;
     hcSaveAs                   = 114;
     hcImport                   = 115;
     hcExport                   = 116;
     hcPrint                    = 117;
     hcExitProgram              = 118;

     hcConnection               = 120;
     hcEstablish                = 121;
     hcDisconnectq              = 122;

     hcDisplay                  = 130;
     hcDisplayBasic             = 131;
     hcDisplayModule            = 132;
     hcDisplayInput73           = 133;
     hcDisplayOutput73          = 134;
     hcDisplayAlarm73           = 135;
     hcDisplayInput32           = 136;
     hcDisplayOutput32          = 137;
     hcDisplayDigital           = 138;

     hcDiagnostics              = 140;
     hcSetCurrent               = 141;
     hcSetDigital               = 142;
     hcResetDevice              = 143;
     hcStatus                   = 144;
     hcMonitor                  = 145;
     hcDataLogger               = 146;

     hcDeviceData               = 150;
     hcCalibrate                = 151;
     hcConfigBasic              = 152;
     hcConfigModule             = 153;
     hcConfigInput73            = 154;
     hcConfigOutput73           = 155;
     hcConfigAlarm73            = 156;
     hcConfigInput32            = 157;
     hcConfigOutput32           = 158;
     hcConfigDigital            = 159;
     hcChangeDevice             = 160;
     hcSaveToDevice             = 161;
     hcCompareToDevice          = 162;

     hcOptions                  = 170;
     hcPassword                 = 171;
     hcLanguage                 = 172;
     hcPortSelection            = 173;
     hcErrorIndication          = 174;

     hcDeviceError              = 180;
     hcInterfaceError           = 181;
     hcConfigError              = 182;
     hcDeviceProblem            = 183;

     hcDate                     = 190;
     hcInputType                = 191;

     hcProcessUnits             = 192;
     hcDampingSmoothing         = 193;
     hcAlarmSignals             = 194;
     hcTripOutput               = 195;
     hcEarlyBurnout             = 196;
     hcResponseTime             = 197;
     hcOutputCharacteristic     = 198;
     hcUserSensor               = 199;
     hcAdjustOutput             = 200;
     hcLeakFlow                 = 201;
     hcPulseOutputOptions       = 202;
     hcAlarmOutputOptions       = 203;

     hcConnectionPCL45          = 210;

     hcNoHelpTopic              = 220;

     hcModuleData               = hcDeviceData;

     hcDisplayModule_x532       = hcDisplayInput32;
     hcConfigureModule_x532     = hcConfigInput32;
     hcDisplayModule_x573       = hcDisplayInput73;
     hcConfigureModule_x573     = hcConfigInput73;
     hcDisplayModule_x576       = hcDisplayInput73;
     hcConfigureModule_x576     = hcConfigInput73;

     hcAbout                    = hcIntroduction;

     hcTransfer                 = hcNoHelpTopic;
     hcDefaultConfig            = hcNoHelpTopic;
     hcHardwareConfig           = hcNoHelpTopic;
     hcInspection               = hcNoHelpTopic;
     hcCalculator               = hcNoHelpTopic;

implementation

end.
