//*************************************************************************************************
//*************************************************************************************************
//*************************************************************************************************
//**
//**	ORDER DESCRIPTION - CONFIGURATION SOFTWARE WITH HART COMMUNICATION (PCS45)
//**	LABELNUMBERS.PAS (Former file name was LABELS.PAS)
//**
//**	Label and other string reference numbers for PCS45
//**
//**	Autor : Georg  Hahn
//**	Datum :  xx.yy.96 / 11.08.05 / 18.04.06 / 20.10.06 / 12.03.07 / 24.10.08 / 11.04.14
//**
//*************************************************************************************************
//*************************************************************************************************
//*************************************************************************************************
unit LabelNumbers;

interface

const

// The three below strings forms a sort of language file header and contain its property information.
// All available language headers will be imported once during the application launch procedure and will
// be present simultanuously during the run time. The string numbers in the resource file are identical.

    lhDllVersion         = 96;
    lhDllLanguageNumber	 = 97;
    lhDllLanguageName		 = 98;
    lhLanguageWarning		 = 99;

//*************************************************************************************************
//**  The below strings contain the language specific strings for control captions,
//**  labels, dialogs, file filters and messages.
//*************************************************************************************************

    flFirstLabelNumber   = 100;

// Application detail labels

    flToolCaption		           = flFirstLabelNumber;
    flCopyright                = 101;
    flMainToolName             = 102;
    flBuild                    = 103;
    flMemory                   = 104;
    mlFile                     = 105;
    mlConnection               = 106;
    mlDisplay                  = 107;
    mlDiagnostics              = 108;
    mlDeviceData               = 109;
    mlOptions                  = 110;
    mlHelp                     = 111;
    mlNewDataSet               = 112;
    mlOpenDataSet              = 113;
    mlSaveDataSet              = 114;
    mlSaveDataSetAs            = 115;
    mlImportFromFile           = 116;
    mlExportToFile             = 117;
    mlPrint                    = 118;
    mlExit                     = 119;
    mlEstablish                = 120;
    mlDisconnect               = 121;
    mlBasicConfig              = 122;
    mlModuleConfig             = 123;
    mlSetCurrentOutput         = 124;
    mlSetDigitalOutputs        = 125;
    mlStatus                   = 126;
    mlMonitor                  = 127;
    mlDataLogger               = 128;
    mlResetDevice              = 129;
    mlInspection               = 130;
    mlCalibrateOutput          = 131;
    mlSaveToDevice             = 132;
    mlVerifyDevice             = 133;
    mlChangeDevice             = 134;
    mlDefaultConfig            = 135;
    mlHardwareConfig           = 136;
    mlPassword                 = 137;
    mlLanguage                 = 138;
    mlPortSelection            = 139;
    mlErrorIndication          = 140;
    mlResetPassword            = 141;
    mlContents                 = 142;
    mlAbout                    = 143;
    slHelpF1                   = 144;
    slNoDeviceSelected         = 145;
    slNoDataAvailable          = 146;
    slOffline                  = 147;
    slOnline                   = 148;
    slRestrictedAccess         = 149;
    slFullAccess               = 150;
    blOk                       = 151;
    blSetting                  = 152;
    blClose                    = 153;
    blSetToday                 = 154;
    blFileName                 = 155;
    blStart                    = 156;
    blFinish                   = 157;
    blOn                       = 158;
    blOff                      = 159;
    blPulse                    = 160;
    blSet                      = 161;
    flNewDataSet               = 162;
    flSelectDevice             = 163;
    flMTL3073_4073             = 164;
    flMTL4073XK                = 165;
    flMTL4075                  = 166;
    flMTL5073_5074             = 167;
    flMTL5074XK                = 168;
    flMTL4532_5532             = 169;
    flMTL4573_5573             = 170;
    flMTL4575_5575             = 171;
    flMTL4576_5576             = 172;
    dlLoadFile                 = 173;
    dsLoadFileFilter           = 174;
    msWrongFileExtension       = 175;
    msFileCorrupted            = 176;
    msUnknownDeviceData        = 177;
    msLoadedFromFile           = 178;
    dlSaveFile                 = 179;
    dsSaveFileFilter           = 180;
    msSavedToFile              = 181;
    dlImportFromFile           = 182;
    msImportedFromFile         = 183;
    dsXlsCsvTxtImpFilter       = 184;
    dsCsvTxtImportFilter       = 185;
    dlExportToFile             = 186;
    msExportedToFile           = 187;
    dsXlsCsvTxtExpFilter       = 188;
    dsCsvTxtExportFilter       = 189;
    mlPrintConfigData          = 190;
    mlCreationDate             = 191;
    msNothingToPrint           = 192;
    msSendToPrinter            = 193;
    flDataTransfer             = 194;
    flDataExchanging           = 195;
    msTimeOutError             = 196;
    msCommunicationDataError   = 197;
    msStatusInfo               = 198;
    msCommandNumber            = 199;
    msConfigDataError          = 200;
    msUnexpectedCommError      = 201;
    msUnitCorrupted            = 202;
    msUnitFailure              = 203;
    msDeviceNotResponding      = 204;
    msCommunicationFaults      = 205;
    msUnknownManufacturer      = 206;
    msUnknownDeviceDetected    = 207;
    msDifferentDeviceDetected  = 208;
    msShouldReconnectDevice    = 209;
    msUnitException            = 210;
    msDifferentResponse        = 211;
    msTransferError            = 212;
    msDemoAttention            = 213;
    msNoDeviceConnected        = 214;
    msNoDataNoFunction         = 215;
    msNoDataShouldConnect      = 216;
    msDataPresentOverwrite     = 217;
    flDisplayBasic             = 218;
    flConfigBasic              = 219;
    flManufacturer             = 220;
    flDeviceCode               = 221;
    flSWRevision               = 222;
    flHWRevision               = 223;
    flTag                      = 224;
    flDescription              = 225;
    flDate                     = 226;
    mlChangedNotSaved          = 227;
    msDataSavedToMemory        = 228;
    msPartDataTransmitted      = 229;
    ms9002Warning              = 230;
    flAnalogueOutput           = 231;
    flRequiredValue            = 232;
    flMeasuredValue            = 233;
    flStatusInformation        = 234;
    flStatusByte               = 235;
    flAlarmInformation         = 236;
    flDynamicVariables         = 237;
    flOutputCurrent            = 238;
    flProcessValue             = 239;
    flColdJunctionComp         = 240;
    flLoggerSetup              = 241;
    flMeasureValue             = 242;
    flProcessValueShort        = 243;
    flCurrentValue             = 244;
    flIntervalValue            = 245;
    flSecUnits                 = 246;
    flMinUnits                 = 247;
    flRecordCount              = 248;
    dsXlsCsvFilterList         = 249;
    dsCsvFilterList            = 250;
    flLoggerControl            = 251;
    flElapsedTime              = 252;
    flRemainingTime            = 253;
    msShortInterval            = 254;
    msCannotBreakLogger        = 255;
    msRecordComplete           = 256;
    msRecordBreak              = 257;
    msOverwriteFile            = 258;
    flChangeDeviceType         = 259;
    flTargetDeviceType         = 260;
    msDataEqual                = 261;
    msDataDifferent            = 262;
    msDataSuccessfulSaved      = 263;
    msDataSavingFailed         = 264;
    flVerifyPassword           = 265;
    flChangePassword           = 266;
    flEnterPassword            = 267;
    flEnterNewPassword         = 268;
    flRepeatNewPassword        = 269;
    msEnabledBecauseValid      = 270;
    msValidButNoChange         = 271;
    msPasswordSaved            = 272;
    msNoChangeBecauseWrong     = 273;
    msDisabledBecauseWrong     = 274;
    msCannotOpenPort           = 275;
    msCannotInitPCL45USB       = 276;
    flIndicate                 = 277;
    flDefect                   = 278;
    flDisruption               = 279;
    flException                = 280;
    flDisplayModule            = 281;
    flConfigModule             = 282;
    flInputTab                 = 283;
    flOutputTab                = 284;
    flAlarmsTab                = 285;
    flInputType                = 286;
    flTHC                      = 287;
    flRTD                      = 288;
    flTType                    = 289;
    flTHCtypes                 = 290;
    flRTDtypes                 = 291;
    flTHC_B                    = 292;
    flTHC_E                    = 293;
    flTHC_J                    = 294;
    flTHC_K                    = 295;
    flTHC_N                    = 296;
    flTHC_R                    = 297;
    flTHC_S                    = 298;
    flTHC_T                    = 299;
    flTHC_XK                   = 300;
    flmV                       = 301;
    flUser                     = 302;
    flPt100                    = 303;
    flPt500                    = 304;
    flPt1000                   = 305;
    flNi100                    = 306;
    flNi500                    = 307;
    flNi1000                   = 308;
    flCu50                     = 309;
    flCu53                     = 310;
    flResistor                 = 311;
    flColdJnCompensation       = 312;
    flOn                       = 313;
    flOff                      = 314;
    flWiring                   = 315;
    fl2Wire                    = 316;
    fl3Wire                    = 317;
    fl4Wire                    = 318;
    flLinearisation            = 319;
    flProcessUnits             = 320;
    flCelsius                  = 321;
    flFarenheit                = 322;
    flRankine                  = 323;
    flKelvin                   = 324;
    flmiliVolt                 = 325;
    flOhm                      = 326;
    flHerz                     = 327;
    flmiliAmp                  = 328;
    flPercent                  = 329;
    flSignalRange              = 330;
    fl4mAPoint                 = 331;
    fl20mAPoint                = 332;
    flFilterFreq               = 333;
    fl50Hz                     = 334;
    fl60Hz                     = 335;
    flOutputFiltering          = 336;
    flDampingConst             = 337;
    flSmoothingConst           = 338;
    flOutputCharacteristic     = 339;
    flOutNE43                  = 340;
    flOutMTL                   = 341;
    flResponseTime             = 342;
    flSlow                     = 343;
    flMedium                   = 344;
    flFast                     = 345;
    flAlarmLevels              = 346;
    flTXAlarmLevel             = 347;
    flAlarmTX                  = 348;
    flAlarmCJC                 = 349;
    flAlarmOC                  = 350;
    flAlarmSC                  = 351;
    flLowAlarm                 = 352;
    flHighAlarm                = 353;
    flAlarmOff                 = 354;
    flEBDdetectionTrip         = 355;
    flEBDdetection             = 356;
    flTrip                     = 357;
    flEBD                      = 358;
    flThreshold                = 359;
    flHysteresis               = 360;
    msWrongCJCSetting          = 361;
    msWrongLinSetting          = 362;
    msFieldBetween             = 363;
    msSpanTooSmall             = 364;
    fl2in2out                  = 365;
    fl1in2out                  = 366;
    flChannel                  = 367;
    flCJCValue                 = 368;
    flUserSensor               = 369;
    flDeviceUserSensor         = 370;
    flFileUserSensor           = 371;
    flSensorHeader             = 372;
    flType                     = 373;
    flTmin                     = 374;
    flTmax                     = 375;
    blLoadFromFile             = 376;
    blLoadFromDevice           = 377;
    blSaveToDevice             = 378;
    flNumber                   = 379;
    flCoefficients             = 380;
    dlImportCustomSensor       = 381;
    dsCustomSensorFileFilter   = 382;
    flCurrentOutputTab         = 383;
    flDigitalOutputsTab        = 384;
    flInputSource              = 385;
    flCurrentOrVoltage         = 386;
    flSwitchProximity          = 387;
    flFilteringAndLimitation   = 388;
    flOut0to20mA               = 389;
    flOut4to20mA               = 390;
    flAdjustOutput             = 391;
    flAdjustOffset             = 392;
    flAdjustGain               = 393;
    flLeakFlowOption           = 394;
    flLeakFlowThreshold        = 395;
    flLeakFlowCurrent          = 396;
    flInhibitInputEnable       = 397;
    flNormalShort              = 398;
    flInvertedShort            = 399;
    flPulseOutput              = 400;
    flPulseDirect              = 401;
    flToggleOutput             = 402;
    flFixedPulse               = 403;
    flDividerOption            = 404;
    flDivisorValue             = 405;
    flPulseDuration            = 406;
    flAlarmOutput              = 407;
    flLFDShort                 = 408;
    flSimpleTrip               = 409;
    flWindowTrip               = 410;
    flInvertedOutput           = 411;
    flTrip1                    = 412;
    flTrip2                    = 413;
    flAlarmTrip                = 414;
    flAlarmLFD                 = 415;
    flAlarmLeakFlow            = 416;
    flSoftAdjust               = 417;
    flHardAdjust               = 418;
    flLEDOutput                = 419;
    flFreq                     = 420;
    flInhibit                  = 421;
    dlMsgWarning               = 422;
    dlMsgError                 = 423;
    dlMsgInformation           = 424;
    dlMsgConfirm               = 425;
    dlMsgYes                   = 426;
    dlMsgNo                    = 427;
    dlMsgOK                    = 428;
    dlMsgCancel                = 429;
    dlMsgHelp                  = 430;
    dlMsgAbort                 = 431;
    dlMsgRetry                 = 432;
    dlMsgIgnore                = 433;
    mlExportSheetNameAssign    = 434;
    mlEnterExportSheetName     = 435;
    mlImportSheetNameSelection = 436;
    mlAvailableSheetNames      = 437;
    mlSheetAlreadyExisting     = 438;

// End of the language table

     flLastLabelNumber         = 450;

implementation

end.
