//*************************************************************************************************
//*************************************************************************************************
//*************************************************************************************************
//**
//**	ORDER DESCRIPTION - CONFIGURATION SOFTWARE WITH HART COMMUNICATION (PCS45)
//**	LANGUAGESTRINGPROCS.PAS (Derived from former file LABELS.PAS)
//**
//**	Default lange strings and load string procedures for PCS45
//**
//**	Autor : Georg  Hahn
//**	Datum :  xx.yy.96 / 14.04.14
//**
//*************************************************************************************************
//*************************************************************************************************
//*************************************************************************************************
unit LanguageStringProcs;

interface

uses LabelNumbers, DataConstants;

  procedure SetDefaultLanguageStrings;

  function LoadDllLanguageString(Number: integer): string;

const

  CDefaultLanguageHeader: array [lhDllVersion..lhLanguageWarning] of string = (
    CPcs45Version,
    '$09',
    '&English',
    'Your Computer is configured for the English language.'+^M+'Do you want to change the language for the PCS45?');

implementation

uses ArraysAndGrids, DataInstances;

procedure SetDefaultLanguageStrings;
begin

// Application labels

  LanguageStrings[flToolCaption]:='PCS45 for Windows - Version ';
  LanguageStrings[flCopyright]:=' 2000-2014 MTL Instruments Group plc';
  LanguageStrings[flMainToolName]:='PC-Configuration software for MTL converter';
  LanguageStrings[flBuild]:='Build';
  LanguageStrings[flMemory]:='Available Windows Memory';

// Main menu

  LanguageStrings[mlFile]:='&File';
  LanguageStrings[mlConnection]:='&Connection';
  LanguageStrings[mlDisplay]:='&Display';
  LanguageStrings[mlDiagnostics]:='Dia&gnostics';
  LanguageStrings[mlDeviceData]:='De&vice data';
  LanguageStrings[mlOptions]:='&Options';
  LanguageStrings[mlHelp]:='&Help';

// Submenu file

  LanguageStrings[mlNewDataSet]:='&New';
  LanguageStrings[mlOpenDataSet]:='&Open...';
  LanguageStrings[mlSaveDataSet]:='&Save';
  LanguageStrings[mlSaveDataSetAs]:='Save &as...';
  LanguageStrings[mlImportFromFile]:='&Import...';
  LanguageStrings[mlExportToFile]:='&Export...';
  LanguageStrings[mlPrint]:='&Print...';
  LanguageStrings[mlExit]:='E&xit';

// Submenu connection

  LanguageStrings[mlEstablish]:='&Establish';
  LanguageStrings[mlDisconnect]:='&Disconnect';

// Submenu display device data

  LanguageStrings[mlBasicConfig]:='&Basic config.';
  LanguageStrings[mlModuleConfig]:='&Module config.';

// Submenu diagnostics

  LanguageStrings[mlSetCurrentOutput]:='Set current output';
  LanguageStrings[mlSetDigitalOutputs]:='Set &digital outputs';
  LanguageStrings[mlStatus]:='&Status';
  LanguageStrings[mlMonitor]:='&Monitor';
  LanguageStrings[mlDataLogger]:='Data-&Logger';
  LanguageStrings[mlResetDevice]:='&Reset';
  LanguageStrings[mlInspection]:='&Inspection';

// Submenu device data - amendment to the dislay submenu

  LanguageStrings[mlCalibrateOutput]:='&Calibrate';
  LanguageStrings[mlSaveToDevice]:='&Save to device';
  LanguageStrings[mlVerifyDevice]:='Compare to &device';
  LanguageStrings[mlChangeDevice]:='Change device type';
  LanguageStrings[mlDefaultConfig]:='Factory settings';
  LanguageStrings[mlHardwareConfig]:='Hardware configuration';

// Submenu options

  LanguageStrings[mlPassword]:='&Password';
  LanguageStrings[mlLanguage]:='&Language';
  LanguageStrings[mlPortSelection]:='&Port selection';
  LanguageStrings[mlErrorIndication]:='&Error indication';
  LanguageStrings[mlResetPassword]:='Reset password';

// Submenu help

  LanguageStrings[mlContents]:='&Contents';
  LanguageStrings[mlAbout]:='In&formation';

// Statusbar messages

  LanguageStrings[slHelpF1]:='Press F1 for help';
  LanguageStrings[slNoDeviceSelected]:='no device selected';
  LanguageStrings[slNoDataAvailable]:='no data available';
  LanguageStrings[slOffline]:='Offline';
  LanguageStrings[slOnline]:='Online';
  LanguageStrings[slRestrictedAccess]:='restricted access';
  LanguageStrings[slFullAccess]:='full access';

// All Button captions

  LanguageStrings[blOk]:='&OK';
  LanguageStrings[blSetting]:='&Accept';
  LanguageStrings[blClose]:='&Close';

  LanguageStrings[blSetToday]:='&Today';
  LanguageStrings[blFileName]:='&File name';
  LanguageStrings[blStart]:='&Start';
  LanguageStrings[blFinish]:='&Break';

  LanguageStrings[blOn]:='On';
  LanguageStrings[blOff]:='Off';
  LanguageStrings[blPulse]:='Pulse';
  LanguageStrings[blSet]:='Set';

// Form new data set (select device)

  LanguageStrings[flNewDataSet]:='New';
  LanguageStrings[flSelectDevice]:='Select device';
  LanguageStrings[flMTL3073_4073]:='MTL3073 and MTL4073';
  LanguageStrings[flMTL4073XK]:='MTL4073XK';
  LanguageStrings[flMTL4075]:='MTL4075';
  LanguageStrings[flMTL5073_5074]:='MTL5073 and MTL5074';
  LanguageStrings[flMTL5074XK]:='MTL5074XK';
  LanguageStrings[flMTL4532_5532]:='MTL4532 and MTL5532';
  LanguageStrings[flMTL4573_5573]:='MTL4573 and MTL5573';
  LanguageStrings[flMTL4575_5575]:='MTL4575 and MTL5575';
  LanguageStrings[flMTL4576_5576]:='MTL4576 and MTL5576';

// Dialogs load from file labels

  LanguageStrings[dlLoadFile]:='Read from file';
  LanguageStrings[dsLoadFileFilter]:='onfiguration data files (*.d45)|*.d45|Configuration data files (*.d73)|*.d73|Old data format files (*.mtl)|*.mtl|All files (*.*)|*.*';
  LanguageStrings[msWrongFileExtension]:='Wrong file extension. Cannot read data.';
  LanguageStrings[msFileCorrupted]:='Data file %s is corrupted. Cannot read data.';
  LanguageStrings[msUnknownDeviceData]:='Unknown device type. Cannot read data.';
  LanguageStrings[msLoadedFromFile]:='Data read from file:'+^M+^M;

// Dialogs save to file labels

  LanguageStrings[dlSaveFile]:='Save to file';
  LanguageStrings[dsSaveFileFilter]:='Configuration data files (*.d45)|*.d45|All files (*.*)|*.*';
  LanguageStrings[msSavedToFile]:='Data saved into file:'+^M+^M;

// Dialogs import from file labels

  LanguageStrings[dlImportFromFile]:='Import from file';
  LanguageStrings[msImportedFromFile]:='Data imported from file:'+^M+^M;
  LanguageStrings[dsXlsCsvTxtImpFilter]:='Excel Import files (*.xls)|*.xls|CSV Import files (*.csv)|*.csv|TXT Import files (*.txt)|*.txt|All files (*.*)|*.*';
  LanguageStrings[dsCsvTxtImportFilter]:='CSV Import files (*.csv)|*.csv|TXT Import files (*.txt)|*.txt|All files (*.*)|*.*';

// Dialogs export to file labels

  LanguageStrings[dlExportToFile]:='Export to file';
  LanguageStrings[msExportedToFile]:='Data exported into file:'+^M+^M;
  LanguageStrings[dsXlsCsvTxtExpFilter]:='Excel Export files (*.xls)|*.xls|CSV Export files (*.csv)|*.csv|TXT Export files (*.txt)|*.txt|All files (*.*)|*.*';
  LanguageStrings[dsCsvTxtExportFilter]:='CSV Export files (*.csv)|*.csv|TXT Export files (*.txt)|*.txt|All files (*.*)|*.*';

// Printer dialogs

  LanguageStrings[mlPrintConfigData]:='Print of configuration data';
  LanguageStrings[mlCreationDate]:='Created on:';

  LanguageStrings[msNothingToPrint]:='There is no data available for printing.'+^M+'The operation will be terminated.';
  LanguageStrings[msSendToPrinter]:='Configuration data was send to the printer:'+^M+^M;

// Form connection and communication status and error messages

  LanguageStrings[flDataTransfer]:='Connection';
  LanguageStrings[flDataExchanging]:='Data exchanging. Please wait ...';

  LanguageStrings[msTimeOutError]:='Time out during receipt.';
  LanguageStrings[msCommunicationDataError]:='Data format error during receipt.';
  LanguageStrings[msStatusInfo]:='Status ';
  LanguageStrings[msCommandNumber]:='Command number ';
  LanguageStrings[msConfigDataError]:='Configuration data error.';
  LanguageStrings[msUnexpectedCommError]:='Unexpected interface error. Please try again!';

  LanguageStrings[msUnitCorrupted]:='The transmitter is disrupted  (corrupted'+^M+'configuration or fault sensor connection) .';
  LanguageStrings[msUnitFailure]:='The transmitter is defective.';

// More connection error messages

  LanguageStrings[msDeviceNotResponding]:='The connection to converter cannot be'+^M+'established. Device is not responding!';
  LanguageStrings[msCommunicationFaults]:='The connection to converter cannot be'+^M+'established. Data transfer is disturbated!';
  LanguageStrings[msUnknownManufacturer]:='There is an extraneous converter identified.'+^M+'Cannot continue with this function.';
  LanguageStrings[msUnknownDeviceDetected]:='There is an unknown converter identified.'+^M+'Cannot continue with this function.';
  LanguageStrings[msDifferentDeviceDetected]:='The actually identified device is of different type as previously connected.';
  LanguageStrings[msShouldReconnectDevice]:='Please confirm to establish connection and overwrite the device data'+^M+'to continue or cancel and terminate the actual attempt.';
  LanguageStrings[msUnitException]:='The transmitter is in exception status'+^M+' (reconfigured or after Reset) .';

  LanguageStrings[msDifferentResponse]:='The converter has sent different data. The input fields are changed.';
  LanguageStrings[msTransferError]:='The data exchange cannot be realized without'+^M+'faults. The connection status is now offline.';

// Operation mode and data status messages

  LanguageStrings[msDemoAttention]:='ATTENTION!  Demo-Mode activated. The data'+^M+'exchange with converter will be simulated.';
  LanguageStrings[msNoDeviceConnected]:='There is no connection to the field device.'+^M+'Should the connection be established now?';
  LanguageStrings[msNoDataNoFunction]:='There is no data in memory. Function cannot be executed.';
  LanguageStrings[msNoDataShouldConnect]:='There is no data in memory. Should the'+^M+'connection to the converter be established ?';
  LanguageStrings[msDataPresentOverwrite]:='There is device data in the memory. Should the data be overwriten?';

// Form basic data captions and messages

  LanguageStrings[flDisplayBasic]:='Display Basic Data';
  LanguageStrings[flConfigBasic]:='Configure Basic Data';
  LanguageStrings[flManufacturer]:='Manufacturers Ident.';
  LanguageStrings[flDeviceCode]:='Device Type';
  LanguageStrings[flSWRevision]:='Software Revision';
  LanguageStrings[flHWRevision]:='Hardware Revision';
  LanguageStrings[flTag]:='Tag Name';
  LanguageStrings[flDescription]:='Descriptor';
  LanguageStrings[flDate]:='Date';

  LanguageStrings[mlChangedNotSaved]:='One or more parameters has been modified but not downloaded'+^M+'to the device. Should the modified data be downloaded now?';
  LanguageStrings[msDataSavedToMemory]:='The data is shifted to memory.';
  LanguageStrings[msPartDataTransmitted]:='A part of data was saved correct before disrupption occured. Should'+^M+'the wrong data be repeated and saving be continued or broken?';

// Warning ISO900x

  LanguageStrings[ms9002Warning]:='Attention! This function can be used only, when the control loop is open.';

// Form set current output and calibrate current output

  LanguageStrings[flAnalogueOutput]:='Current output';
  LanguageStrings[flRequiredValue]:='Enter required value';
  LanguageStrings[flMeasuredValue]:='Enter measured value';

// Form status

  LanguageStrings[flStatusInformation]:='Status information';
  LanguageStrings[flStatusByte]:='Comm. and device byte';
  LanguageStrings[flAlarmInformation]:='Alarm information';

// Form monitor

  LanguageStrings[flDynamicVariables]:='Dynamic variables';
  LanguageStrings[flOutputCurrent]:='Output Current';
  LanguageStrings[flProcessValue]:='Process Value';
  LanguageStrings[flColdJunctionComp]:='Cold Jn. Value';

// Form data logger captions and labels

  LanguageStrings[flLoggerSetup]:='Recording setup';
  LanguageStrings[flMeasureValue]:='&Measure';
  LanguageStrings[flCurrentValue]:='&Current';
  LanguageStrings[flIntervalValue]:='Interval';
  LanguageStrings[flSecUnits]:='Sec.';
  LanguageStrings[flMinUnits]:='Min.';
  LanguageStrings[flRecordCount]:='&Records';
  LanguageStrings[dsXlsCsvFilterList]:='Excel-files (*.xls)|*.xls|CSV-files (*.csv)|*.csv|All files (*.*)|*.*';
  LanguageStrings[dsCsvFilterList]:='CSV-files (*.csv)|*.csv|All files (*.*)|*.*';

  LanguageStrings[flLoggerControl]:='Recording control';
  LanguageStrings[flElapsedTime]:='Elapsed time';
  LanguageStrings[flRemainingTime]:='Remaining time';

// Form data logger messages and warnings

  LanguageStrings[msShortInterval]:='The requested interval value is shorter as the module response time.'+^M+'Please increase the interval value and start the operation again!';
  LanguageStrings[msCannotBreakLogger]:='Sorry, you cannot close the logger until record is running!';
  LanguageStrings[msRecordComplete]:='Recording completed. The results saved into file %s';
  LanguageStrings[msRecordBreak]:='Recording interrupted. The results partly saved into file %s';
  LanguageStrings[msOverwriteFile]:='File %s already exists. Should it be overwritten?';

// Form change Device Type (from legacy to new product)

  LanguageStrings[flChangeDeviceType]:='Change Device Type';
  LanguageStrings[flTargetDeviceType]:='Target Device Type';

// Dialog Save to device and Compare to device

  LanguageStrings[msDataEqual]:='The device configuration is identical.';
  LanguageStrings[msDataDifferent]:='The device configuration is different!';
  LanguageStrings[msDataSuccessfulSaved]:='Configuration data successful saved to device.';
  LanguageStrings[msDataSavingFailed]:='Configuration data saving process failed!';

// Form password check or password change

  LanguageStrings[flVerifyPassword]:='Password check';
  LanguageStrings[flChangePassword]:='&Change password';
  LanguageStrings[flEnterPassword]:='Enter password:';
  LanguageStrings[flEnterNewPassword]:='Enter new password:';
  LanguageStrings[flRepeatNewPassword]:='Repeat to confirm:';

  LanguageStrings[msEnabledBecauseValid]:='Password input ok. All functions enabled.';
  LanguageStrings[msValidButNoChange]:='Password input ok. All functions enabled. No changes.';
  LanguageStrings[msPasswordSaved]:='Password changed and saved to Windows Registry.';
  LanguageStrings[msNoChangeBecauseWrong]:='Password wrong or input broken. No changes.';
  LanguageStrings[msDisabledBecauseWrong]:='Password wrong. All important functions disabled.';

// Form language - no strings

// Form port selection

  LanguageStrings[msCannotOpenPort]:='Cannot open the serial port COM%d.'+^M+'Operation changed to demonstration mode.';
  LanguageStrings[msCannotInitPCL45USB]:='Cannot initialise PCL45USB PClink.'+^M+'Operation changed to demonstration mode.';

// Form error indication
   LanguageStrings[flIndicate]:='Indicate status ...';
   LanguageStrings[flDefect]:='&Defect';
   LanguageStrings[flDisruption]:='Di&sturbed';
   LanguageStrings[flException]:='&Exception';

// Form module data for temperature converter MTLx073 to MTLx575 (display and configure)

  LanguageStrings[flDisplayModule]:='Display module data';
  LanguageStrings[flConfigModule]:='Configure module data';

// Form module tab captions

  LanguageStrings[flInputTab]:='Input';
  LanguageStrings[flOutputTab]:='Output';
  LanguageStrings[flAlarmsTab]:='Alarms';

  LanguageStrings[flInputType]:='&Input Type';
  LanguageStrings[flTHC]:='THC';
  LanguageStrings[flRTD]:='RTD';
  LanguageStrings[flTType]:='type';

  LanguageStrings[flTHCtypes]:='&THC Types';
  LanguageStrings[flRTDtypes]:='&RTD Types';

  LanguageStrings[flTHC_B]:='B';
  LanguageStrings[flTHC_E]:='E';
  LanguageStrings[flTHC_J]:='J';
  LanguageStrings[flTHC_K]:='K';
  LanguageStrings[flTHC_N]:='N';
  LanguageStrings[flTHC_R]:='R';
  LanguageStrings[flTHC_S]:='S';
  LanguageStrings[flTHC_T]:='T';
  LanguageStrings[flTHC_XK]:='XK';
  LanguageStrings[flmV]:='mV';
  LanguageStrings[flUser]:='User';

  LanguageStrings[flPt100]:='Pt100';
  LanguageStrings[flPt500]:='Pt500';
  LanguageStrings[flPt1000]:='Pt1000';
  LanguageStrings[flNi100]:='Ni100';
  LanguageStrings[flNi500]:='Ni500';
  LanguageStrings[flNi1000]:='Ni1000';
  LanguageStrings[flCu50]:='Cu50';
  LanguageStrings[flCu53]:='Cu53';
  LanguageStrings[flResistor]:='Ohm';

  LanguageStrings[flColdJnCompensation]:='&Cold Jn. Comp.';
  LanguageStrings[flOn]:='On';
  LanguageStrings[flOff]:='Off';

  LanguageStrings[flWiring]:='RTD Wiring';
  LanguageStrings[fl2Wire]:='2-wire';
  LanguageStrings[fl3Wire]:='3-wire';
  LanguageStrings[fl4Wire]:='4-wire';

  LanguageStrings[flLinearisation]:='&Linearisation';

  LanguageStrings[flProcessUnits]:='&Process Units';
  LanguageStrings[flCelsius]:='C';
  LanguageStrings[flFarenheit]:='F';
  LanguageStrings[flRankine]:='R';
  LanguageStrings[flKelvin]:='K';
  LanguageStrings[flmiliVolt]:='mV';
  LanguageStrings[flOhm]:='Ohm';
  LanguageStrings[flHerz]:='Hz';
  LanguageStrings[flmiliAmp]:='mA';
  LanguageStrings[flPercent]:='%';

  LanguageStrings[flSignalRange]:=' Signal Range';
  LanguageStrings[fl4mAPoint]:='Point 4mA';
  LanguageStrings[fl20mAPoint]:='Point 20mA';

  LanguageStrings[flFilterFreq]:='Filter Frequency';
  LanguageStrings[fl50Hz]:='50 Hz';
  LanguageStrings[fl60Hz]:='60 Hz';

  LanguageStrings[flOutputFiltering]:='Output Filtering';
  LanguageStrings[flDampingConst]:='Damping Time Constant';
  LanguageStrings[flSmoothingConst]:='Smoothing Time Constant';

  LanguageStrings[flOutputCharacteristic]:='Output Characteristic';
  LanguageStrings[flOutNE43]:='&NE43 limits';
  LanguageStrings[flOutMTL]:='MTL';

  LanguageStrings[flResponseTime]:='&Response Time';
  LanguageStrings[flSlow]:='Slow';
  LanguageStrings[flMedium]:='Medium';
  LanguageStrings[flFast]:='Fast';

  LanguageStrings[flAlarmLevels]:='Alarm Levels';
  LanguageStrings[flTXAlarmLevel]:='Transmitter Failure Alarm';
  LanguageStrings[flAlarmTX]:='Transmitter Failure';
  LanguageStrings[flAlarmCJC]:='Cold Junction Failure';
  LanguageStrings[flAlarmOC]:='Open Circuit Failure';
  LanguageStrings[flAlarmSC]:='Short Circuit Failure';
  LanguageStrings[flLowAlarm]:='Low';
  LanguageStrings[flHighAlarm]:='High';
  LanguageStrings[flAlarmOff]:='Off';

  LanguageStrings[flEBDdetectionTrip]:='Early Burnout Detection / Trip';
  LanguageStrings[flEBDdetection]:='Early Burnout Detection';
  LanguageStrings[flTrip]:='Trip';
  LanguageStrings[flEBD]:='EBD';

  LanguageStrings[flThreshold]:='Threshold';
  LanguageStrings[flHysteresis]:='Hysteresis';

  LanguageStrings[msWrongCJCSetting]:='The selected assignment of input type and cold junction compensation'+^M+'can be the cause of incorrect configuration. Be sure before confirming!';
  LanguageStrings[msWrongLinSetting]:='The selected assignment of input type and linearisation can be'+^M+'the cause of incorrect configuration. Be sure before confirming!';
  LanguageStrings[msFieldBetween]:='The input value for this field'+^M+'%s'+^M+'must be between'+^M+'%s to %s';
  LanguageStrings[msSpanTooSmall]:='The required input signal span is below the specified product limit.'+^M+
                                   'Please enlarge adequately the input signal range and try again.';

  LanguageStrings[fl2in2out]:='2 inputs - 2 outputs';
  LanguageStrings[fl1in2out]:='1 input - 2 outputs';

  LanguageStrings[flChannel]:='Channel';

  LanguageStrings[flCJCValue]:='Value';

  LanguageStrings[flUserSensor]:='User Sensor';

  LanguageStrings[flDeviceUserSensor]:='User Sensor Data in Device';
  LanguageStrings[flFileUserSensor]:='User Sensor Data from File';
  LanguageStrings[flSensorHeader]:='Sensor Header';

  LanguageStrings[flType]:='Type';
  LanguageStrings[flTmin]:='T min';
  LanguageStrings[flTmax]:='T max';

  LanguageStrings[blLoadFromFile]:='Load From File';
  LanguageStrings[blLoadFromDevice]:='Load From Device';
  LanguageStrings[blSaveToDevice]:='Save To Device';

  LanguageStrings[flNumber]:='No.';
  LanguageStrings[flCoefficients]:='Coefficients';

  LanguageStrings[dlImportCustomSensor]:='Import User Sensor Data';
  LanguageStrings[dsCustomSensorFileFilter]:='User Sensor files (*.dat)|*.dat|All files (*.*)|*.*';

// Form module data for frequency converter MTLx532 and E01003 (display and configuration)

  LanguageStrings[flCurrentOutputTab]:='Current Output';
  LanguageStrings[flDigitalOutputsTab]:='Digital Functions';

  LanguageStrings[flInputSource]:='Input Source';
  LanguageStrings[flCurrentOrVoltage]:='Current or voltage pulses';
  LanguageStrings[flSwitchProximity]:='Switch/Proximity detector';

  LanguageStrings[flFilteringAndLimitation]:='Output Filtering and Characteristic';
  LanguageStrings[flOut0to20mA]:='0-20mA';
  LanguageStrings[flOut4to20mA]:='4-20mA';

  LanguageStrings[flAdjustOutput]:='Output Adjustment';
  LanguageStrings[flAdjustOffset]:='Offset';
  LanguageStrings[flAdjustGain]:='Gain';

  LanguageStrings[flLeakFlowOption]:='&Leak Flow';
  LanguageStrings[flLeakFlowThreshold]:='Threshold';
  LanguageStrings[flLeakFlowCurrent]:='Output';

  LanguageStrings[flInhibitInputEnable]:='Inhibit input enable';
  LanguageStrings[flNormalShort]:='norm.';
  LanguageStrings[flInvertedShort]:='invert';

  LanguageStrings[flPulseOutput]:='Pulse Output';
  LanguageStrings[flPulseDirect]:='1:1';
  LanguageStrings[flToggleOutput]:='toggle';
  LanguageStrings[flFixedPulse]:='fixed pulse';

  LanguageStrings[flDividerOption]:='Pulse divider';
  LanguageStrings[flDivisorValue]:='Divisor';
  LanguageStrings[flPulseDuration]:='Pulse dur.';

  LanguageStrings[flAlarmOutput]:='Alarm Output';
  LanguageStrings[flLFDShort]:='LFD';
  LanguageStrings[flSimpleTrip]:='simple trip';
  LanguageStrings[flWindowTrip]:='window trip';
  LanguageStrings[flInvertedOutput]:='Inverted Output';

  LanguageStrings[flTrip1]:='Trip &1';
  LanguageStrings[flTrip2]:='Trip &2';

// Diverse strings for MTL4532

  LanguageStrings[flAlarmTrip]:='Trip alarm';
  LanguageStrings[flAlarmLFD]:='LFD alarm';
  LanguageStrings[flAlarmLeakFlow]:='Leak Flow alarm';

// Form module data for frequency converter E01003 (additional labels)

  LanguageStrings[flSoftAdjust]:='Software';
  LanguageStrings[flHardAdjust]:='Trimmer';

// Form digital diagnostics for frequency converter E01003 and MTL4532

  LanguageStrings[flLEDOutput]:='Error LED';

  LanguageStrings[flFreq]:='Freq.';

  // LanguageStrings[flInhibit]:='Inhibit';

// Localised MessageDlg strings (from Consts.pas)

  LanguageStrings[dlMsgWarning]:='Warning';
  LanguageStrings[dlMsgError]:='Error';
  LanguageStrings[dlMsgInformation]:='Information';
  LanguageStrings[dlMsgConfirm]:='Confirm';
  LanguageStrings[dlMsgYes]:='&Yes';
  LanguageStrings[dlMsgNo]:='&No';
  LanguageStrings[dlMsgOK]:='OK';
  LanguageStrings[dlMsgCancel]:='Cancel';
  LanguageStrings[dlMsgHelp]:='&Help';
  LanguageStrings[dlMsgAbort]:='&Abort';
  LanguageStrings[dlMsgRetry]:='&Retry';
  LanguageStrings[dlMsgIgnore]:='&Ignore';

// Messages for considered Excel Import (not used yet)

  LanguageStrings[mlExportSheetNameAssign]:='Export sheet name assignation';
  LanguageStrings[mlEnterExportSheetName]:='Please enter sheet name';
  LanguageStrings[mlImportSheetNameSelection]:='Import sheet name selection';
  LanguageStrings[mlAvailableSheetNames]:='Available sheets';
  LanguageStrings[mlSheetAlreadyExisting]:='The  selected  target file  includes already data sheet'+^M+'with exactly the same name. Please confirm to overwrite'+^M+'this sheet or consider to change anyway the selection.';

end;

function LoadDllLanguageString(Number: integer): string;
var S: array [0..255] of char;
begin
  if (ActiveLibrary<>0) and (@LoadDllStr<>nil) then
     begin
     LoadDllStr(Number,255,@S);
     Result:=String(S);
     end;
end;

end.
